     ----------------------------------------------------------------------

   WIVE FIRMWARE IS FREE FOR THE NON-COMMERCIAL USE ONLY.
   Conditions of commercial use non GPL (or other not viral license)
   components are discussed individually.

     ----------------------------------------------------------------------

   News and changes in Russian:
   wive-ng.sf.net - development opensource routers firmware
   wi-cat.ru - wireless comprehensive advanced technology

   Release tree changes:
   0.0.x-0.30.x
   1) full new codebase.
   2) sync with 4.2.1.0 SDK.
   3) toolchain: move to 4.8.4 gcc svn version (after 4.8.3 release 4.8 tree
   apply only bugfixes).
   4) webui: add wan mac change logic.
   5) fix drop nvram in fs fullreset in some situations.
   6) defaults: temp disable multicast2unicast.
   7) rf calib: use avarage calibs if need fullreset or factory part crash.
   8) init.d: add workaround for fix txring fill in drivers if M2U enabled.
   9) init.d: fix disabled forwarding after sysctl rebuild.
   10) init.d: fix get vendid at new mac generate.
   11) init.d: fix double vlan tag disable from UI.
   12) init.d: rewrite logic for ipv6 suppor (need write logic for more modes
   support).
   13) init.d: add base rules for upnpv6 pinholes.
   14) init.d: radvd,dhcpv6: read dns server from uplink if recived.
   15) igmpproxy: lan snoping: fix infinitive loop if find unused endtry.
   16) igmpproxy: wifi snoping: fix manipulate snooping records in wifi
   drivers, and mac lookup.
   17) goahead: add base webUI for ipv6 configure (need write logic for more
   modes support).
   18) goahead: add replace RWFS (/etc folder) by webui (full or different
   components).
   19) goahead: add dhcpv6 server control in misc.
   20) goahead: fix add portforward rules (syntax compat with new iptables
   fix).
   21) openssl up to 0.9.8zc version.
   23) apps: port wide-dhcpv6 (need write client logic, server logic work
   good).
   24) apps: add and use sambav3 for > 4Mb flash sizes images.
   25) apps: dropbear: up to 2014.66 version.
   26) apps: miniupnpd: add ipv6 support if configured.
   27) apps: ppp,busybox,miniupnpd: build with no strict aliasing (safe build
   with new compilers).
   28) libs: add libnfnetlink (need for ipv6 miniupnpd support).
   29) miniupnpd: version up to 1.8.20141022.
   30) busybox: apply lzop upstream patch (zcat suspended - break depmod).
   31) kernel: link time optimization.
   32) kernel: hash speed optimization.
   33) kernel: add autodetect ramsize support.
   34) kernel: ralink hw_nat: correct ppe work at revH (206 PPE).
   35) kernel: ralink hw_nat: skip mark and imq target from PPE.
   36) kernel: ralink hw_nat: webstr target fix from PPE.
   37) kernel: ralink hw_nat: pass workloads in PPE for some cases.
   38) kernel: ralink hw_nat: foe header in some cases.
   39) kernel: ralink hw_nat: show destination port on
   PpeHitBindForceToCpuHandler failed.
   40) kernel: hw_nat, raeth: MT762x external switch control improvements.
   41) kernel: hw_nat, raeth: reinit PPE engine after FE reset
   (RT3x5x/RT3883), reset PPE engine on FE reset (MT762x).
   42) kernel: ralink wifi: fix some ATE issues.
   43) kernel: ralink wifi: use my version mcast filter table and backport
   small snooping fixes from 4.x.x driver.
   44) kernel: ralink wifi: prevent skb double free in igmp_snoop
   processiong.
   45) kernel: ralink wifi: workaround for stop tx if client not correct
   disconnect.
   46) kernel: ralink wifi: rx/tx optimization (remove stupid wrappers in
   time critical code).
   47) kernel: fastroute/fastnat: implement for new kernel.
   48) kernel: fastroute/fastnat: optimization skip logic.
   49) kernel: rewrite min3, max3 and clamp using min and max.
   50) kernel: fix compat with new gcc compiler versions.
   51) kernel: arp at media state change send arp broadcast packet for arp
   table update(fix issue with some radio and switches).
   52) kernel: arp: do not perturb drop profiles with ignored ARP packets.
   53) kernel: arp: make arp_invalidate static.
   54) kernel: sit: fix ipip6_tunnel_lookup device matching criteria.
   55) kernel: skbuff: fix ftrace handling in skb_unshare.
   56) kernel: packet: handle too big packets for PACKET_V3.
   57) kernel: lro: remove dead code.
   58) kernel: jiffies: fix timeval conversion to jiffies.
   59) kernel: futex: Unlock hb->lock in futex_wait_requeue_pi() error path.
   60) kernel: locking/mutexes: Optimize mutex trylock slowpath.
   61) kernel: fix nasty 32-bit overflow bug in buffer i/o code.
   62) kernel: xhci: fix null pointer dereference if xhci initialization
   fails.
   63) kernel: usb: host: xhci: fix compliance mode workaround.
   64) kernel: storage: add single-LUN quirk for Jaz USB adapter.
   65) kernel: softirq: reduce latencies.
   66) kernel: 8021q: fix vlan device to inherit the unicast filtering
   capability flag.
   67) kernel: netfilter: conntrack: disable generic tracking for known
   protocols.
   68) kernel: netfilter: nf_conntrack: remove dead code.
   69) kernel: netfilter: push reasm skb through instead of original frag
   skbs.
   70) kernel: mips: fix jump label support.
   71) kernel: mips: modules: rellocate for prevent long call.
   71) kernel: mips: Use inline function to access current thread pointer.
   72) kernel: mips: Improve atomic.h robustness.
   73) kernel: mips: vmlinux.lds.h: Allow architectures to add sections to
   the front of .bss.
   74) kernel: mips: Align swapper_pg_dir to 64K for better TLB Refill code.
   75) kernel: mips: R4k clock source initialization bug fix.
   76) kernel: mips: Discard .eh_frame sections in linker script.
   77) kernel: mips: mcount: Adjust stack pointer for static trace in MIPS32.
   78) kernel: mips: O32/32-bit: Fix bug which can cause incorrect system
   call restarts.
   79) kernel: af_unix: fix a fatal race with bit fields.
   80) kernel: unix/dgram: peek beyond 0-sized skbs.
   81) kernel: unix/dgram: fix peeking with an offset larger than data in
   queue.
   82) kernel: unix/stream: fix peeking with an offset larger than data in
   queue.
   83) kenrel: route: Remove redirect_genid
   84) kernel: net: only use a single page of slop in MAX_SKB_FRAGS.
   85) kernel: net: pack skb_shared_info more efficiently.
   86) kernel: net: use consume_skb() in place of kfree_skb().
   87) kernel: net: optimize csum_replace2().
   88) kernel: net: optimise csum_replace4().
   89) kernel: net: optimise inet_proto_csum_replace4().
   90) kernel: net: skbuff: const-ify casts in skb_queue_* functions.
   91) kernel: net: remove function sk_reset_txq().
   92) kernel: net: Use consume_skb() to free gso segmented skb.
   93) kernel: net: remove redundant code in dev_hard_start_xmit().
   94) kernel: net: core: let skb_partial_csum_set() set transport header.
   95) kernel: net: cacheline adjust struct netns_frags, inet_frags and
   inet_frag_queue for better frag performance.
   96) kernel: net: compute skb->rxhash if nic hash may be 3-tuple.
   97) kernel: net: make skb_gso_segment error handling more robust.
   98) kernel: ipv[4|6]: correct dropwatch false positive in
   local_deliver_finish.
   99) kernel: ipv4: igmp: fix v3 general query drop monitor false positive.
   100) kernel: ipv4: consistent reporting of pmtu data in case of corking.
   101) kernel: ipv4: fix ip header ident selection in __ip_make_skb().
   102) kernel: ipv4: fix ip_send_skb().
   103) kernel: ipv4: fix buffer overflow in ip_options_compile().
   104) kernel: ipv4: Cache ip_error() routes even when not forwarding.
   105) kernel: ipv4: distinguish EHOSTUNREACH from the ENETUNREACH.
   106) kernel: ipv4: ip_forward: perform skb->pkt_type check at the
   beginning.
   107) kernel: ipv4: arp: update neighbour address when a gratuitous arp is
   received and arp_accept is set.
   108) kernel: ipv4: revert: use a 64bit load/store in output path (profit
   on x86_64 only).
   109) kernel: ipv6: remove aca_lock spinlock from struct ifacaddr6.
   110) kernel: ipv6: Do not warn for informational ICMP messages, regardless
   of type.
   111) kernel: ipv6: removed unused inet6 address state.
   112) kernel: ipv6: remove unused function ipv6_inherit_linklocal().
   113) kernel: l2tp: fix race while getting PMTU on PPP pseudo-wire.
   114) kernel: l2tp: exclude session versions check if l2tp v3 support not
   builded (small speedup).
   115) kernel: l2tp: remove debug in in time critical code (small speedup).
   116) kernel: tcp: fix ooo_okay setting vs Small Queues.
   117) kernel: tcp: md5: remove unneeded check in tcp_v4_parse_md5_keys.
   118) kernel: tcp: make tcp_cwnd_application_limited() static.
   119) kernel: tcp: do not leak non zero tstamp in output packets.
   120) kernel: tcp: reduce the bloat caused by tcp_is_cwnd_limited().
   121) kernel: tcp: use zero-window when free_space is low.
   122) kernel: tcp: optimize some skb_shinfo(skb) uses.
   123) kernel: tcp: remove redundant code in __tcp_retransmit_skb().
   124) kernel: tcp: remove the sk_can_gso() check from
   tcp_set_skb_tso_segs().
   125) kernel: tcp: tcp_transmit_skb() optimizations.
   126) kernel: tcp: Always set options to 0 before calling
   tcp_established_options.
   127) kernel: tcp: tcp_tso_segment() small optimization.
   128) kernel: tcp: make tcp_clear_md5_list static.
   129) kernel: increase rwfs size for 8Mb devices to 512kb (prepare for add
   custom webui upload to rwfs).

   0.3x.x
   1) build system: ppp,miniupnpd and busybox build with -fno-strict-aliasing
   for safe build with new gcc.
   2) build system: xz tool up to 5.0.7 version.
   3) build system: xz tune rootfs pack for decrease image size.
   4) build system: toolchain: update gcc to 4.8.4(svn up version).
   5) radvd: up to 2.8 version.
   6) miniupnpd up to: 1.9 version.
   7) igmpproxy: add igmpv3 support and cleanup.
   8) goahead: remove bogus double restart ripd/zebra.
   9) goahead: remove dead mesh support.
   10) pppd: cap MTU to the user configured value.
   11) init.d: fix reinit switch (now support internal esw only).
   12) init.d: enable multicast2unicast in wifi drivers only if igmpproxy
   enabled.
   13) init.d: move dhcpv6 client start to wan config.
   14) init.d: use ISP DNS ipv6 servers for local resolv if recived.
   15) init.d: ipv6: need check ipv4 adress on wan only in tunneling modes.
   16) init.d: fix pcp/nat-pmp control port accept from lan.
   17) init.d: fix get wan_if for IPv6
   18) init.d: move ipv6 config and radvd/dhcp6s start in S20six script.
   19) init.d: more remove init at goahead dependency.
   20) init.d: rearrange first step config for more linear boot.
   21) init.d: flush only scope route at deconfig ipv6.
   22) init.d: more safe samba restart.
   23) init.d: add /etc/script/switchadv.sh hook for advanced switch
   (vlan/portmap/etc) configure.
   24) init.d: rework config-switch.sh (cleanup and more direct steps
   configs).
   25) kernel: use the deterministic mode of AR if available.
   26) kernel: periodically refresh ralink watchdog from net/core/dev
   (prevent reboot at very high load).
   27) kernel: skip fastnat/fastroute from mark/connmark.
   28) kernel: add missing linux/prefetch.h include to net/core/sock.c.
   29) kernel: shmem: fix nlink for rename overwrite directory.
   30) kernel: fs: namespace: suppress 'may be used uninitialized' warnings.
   31) kernel: nfsd: Fix ACL null pointer deref.
   32) kernel: softirq: use const char * const for softirq_to_name,
   whitespace neatening.
   33) kernel: mtd: mtd_blkdevs: Replace request handler kthread with a
   workqueue.
   34) kernel: mtd: merge mtdchar module with mtdcore.
   35) kernel: mtd: introduce mtd_block_isreserved().
   36) kernel: mtd: account for BBT blocks when a partition is being
   allocated.
   37) kernel: mtd: correct upper bounds check for mtd_*() APIs.
   38) kernel: mtd: mtdchar: return expected errors on mmap() call.
   39) kernel: mtd: mtdchar: handle chips that have user otp but no factory
   otp.
   40) kernel: mtd: mtd_blkdevs: handle REQ_FLUSH request and do explicit
   flush of writeback buffer.
   41) kenrel: mtd: cfi_cmdset_0002: allow retry/timeout loop to exit.
   42) kernel: squashfs: sanity check information from disk.
   43) kernel: squashfs: fix corruption check in get_dir_index_using_name().
   44) kernel: squashfs: fix corruption checks in squashfs_lookup().
   45) kernel: squashfs: fix corruption checks in squashfs_readdir().
   46) kenrel: squashfs: revert bogus commit from OpenWRT tree.
   47) kernel: pptp: use for_each_set_bit_from.
   48) kernel: pptp: fix sparse pointer warning.
   49) kernel: pptp: fix byte order warnings.
   50) kernel: raeth: always skb_pad in xmit path (fix stop PPPE work at wifi
   offload + PPPOE uplink).
   51) kernel: raeth: optimize skb_shinfo(skb) uses.
   52) kernel: raeth: use RAETH_DEBUG from kernel config.
   53) kernel: raeth: add support NAPI and enable by default (speedup).
   54) kernel: raeth: fetch pending FE counters before FE reset.
   55) kernel: raeth: properly reset irq status on softirq exit.
   56) kernel: netfilter: nf_conntrack: flush net_gre->keymap_list only from
   gre helper.
   57) kernel: netfilter: nf_defrag_ipv6.o included twice.
   58) kernel: netfilter: nf_conntrack: avoid large timeout for mid-stream
   pickup.
   59) kernel: ipv4: igmp: fix v3 general query drop monitor false positive.
   60) kernel: ipv4: raise IP_MAX_MTU to theoretical limit.
   61) kernel: ipv6: reuse ip6_frag_id from ip6_ufo_append_data.
   62) kernel: sched: rework check_for_tasks().
   63) kernel: net: loopback: set default mtu to 64K.

   0.4x.x
   1) defaults: init.d: fix work ipv6 on some devices if igmp snooping
   disabled.
   2) goahead: rearrange services in misc pages for more usefull.
   3) init.d: cleanup and optimize (next step).
   4) init.d: add static routes for all resolved vpn server adresses.
   5) init.d: remove web_wait logic, not more need and unused some time.
   6) init.d: vpnhelper: direct set iface name in static routes to vpn
   servers.
   7) busybox: udhcpc: allow unicast RENEW for lease time from 60s, allow
   first unicast RENEW on force renew performed (fix short leases under ISP
   with DHCP snooping).
   8) kernel: irq: consolidate do_softirq() arch overriden implementations.
   9) kernel: irq: optimize call to softirq on hardirq exit.
   10) kernel: irq: improve a bit softirq debugging.
   11) kernel: irq: justify the various softirq stack choices.
   12) kernel: irq: optimize softirq stack selection in irq exit.
   13) kernel: irq: ensure irq_exit() code runs with interrupts disabled.
   14) kernel: irq: sanitize invoke_softirq.
   15) kernel: irq: force hardirq exit's softirq processing on its own stack.
   16) kernel: irq: don't re-enable interrupts at the end of irq_exit.
   17) kernel: irq: remove IRQ_EXIT_OFFSET workaround.
   18) kernel: softirq: remove support for triggering softirq work on
   softirqs patch.
   19) kernel: softirq: use ffs() in __do_softirq().
   20) kernel: genirq: correct fuzzy and fragile IRQ_RETVAL() definition.
   21) kernel: lockdep: correctly annotate hardirq context in irq_exit().
   22) kernel: printk/cache: mark printk_once test variable __read_mostly.
   23) kernel: printk: add printk_deferred_once.
   24) kernel: kprobes: make hash_64() as always inlined.
   25) kernel: sections: fix const sections for crc32 table.
   26) kernel: ipv6: store Router Alert option in IP6CB directly.
   27) kernel: linux/kernel.h: DIV_ROUND_CLOSEST add support negative
   dividends (and depends).
   28) kernel: mm: mark mm-inline functions as __always_inline.
   29) kernel: mips: fix strnlen_user() return value in case of overlong
   strings.
   30) kernel: mcast: define and use MRT[6]_MAX in ip[6]_mroute_opt().
   31) kernel: sched: fix the theoretical signal_wake_up() vs schedule()
   race.
   32) kernel: fix lockup related to stop_machine being stuck in
   __do_softirq.
   33) kernel: raeth: fix NAPI race issue.
   34) kernel: raeth: ack all not RX/TX interrupts before enter to NAPI poll
   mode.
   35) kernel: net/core: make GRO/napi_frags_skb() methods static.
   36) kernel: net: add ETH_P_802_3_MIN.
   37) kernel: net: skbuff: Use ALIGN macro instead of open coding it.
   38) kernel: net: dont use ifindices in hash fns.
   39) kernel: net: reset mac header in dev_start_xmit().
   40) kernel: ipv4: Do not cache routing failures due to disabled
   forwarding.
   41) kernel: netfilter: nf_conntrack: constify sk_buff argument to
   nf_ct_attach().

   0.5x.x
   1) init.d: dnsmasq: increase cache size and allowen forward per one time
   limit.
   2) init.d: optimize get parametrs from nvram (more variable always avail
   by call global script).
   3) init.d: cleanup and optimize wifi/apcli init logic.
   4) init.d: remove old unused hacks.
   5) init.d: fix apcli mode connect after apply before reboot.
   6) init.d: always tune wifi after ifacse up.
   7) init.d: tune parametrs for apcli to.
   8) init.d: do not use goahead.pid as boot complete flag, use /tmp/goodboot
   instead (more independed from goahead logic).
   9) init.d: rework cdp-send start.
   10) init.d: in ap/apcli bridge mode enable Multicast2Unicast independed
   Igmpproxy enabled.
   11) apps: add lldpd daemon and control tools.
   12) miniupnpd: up to version 1.9.20141108.
   13) goahead: fix print error messages at update fw/restore settings/load
   rwfs.
   14) goahead: read lan/wan ifnames from /tmp/*an_if_name exported by init.d
   in global script.
   15) goahead: fix get mode vpn.
   16) goahead: add show real ip adress vpn/wan in status page.
   17) kernel: lockdep: fix oops in processing workqueue.
   18) kernel: workqueue: change BUG_ON() to WARN_ON().
   19) kernel: workqueue: don't use WQ_HIGHPRI for unbound workqueues.
   20) kernel: raeth: disable TSO for rev <207 (rev206 has TSO bug to).
   21) kernel: raeth: use DLY_INT (with aggregate up to 2 INT and max 40us
   delay) for NAPI (decrease CPU usage on medium FE load).
   22) kernel: raeth: add support independent TX rings (w/o cross lock) for
   2xRGMII mode (RT3883/MT7621).
   23) kernel: raeth: improvements for external switch case, move stats
   update from softirq to workqueue.
   24) kernel: ralink_wifi: fix apscan support.
   25) kernel: ralink_wifi: update eeprom array in driver.
   26) kernel: ralink_wifi: patch fix dhcp issue on new Apple and others
   buggy clients (use RATE_6 instead of 24).
   27) kernel: ralink_wifi: fix and enable decrease interference effects
   logic (dynamicvga and friends).
   28) kernel: net: sysctl: set frto=2, bug TCP: snd_cwnd is null
   http://patchwork.ozlabs.org/patch/234793/
   29) kernel: net: apply http://patchwork.ozlabs.org/patch/234793/ fix (in
   future need backport new FRTO code).
   30) kernel: net: fastnat/fastroute: use ip_route_input_noref(), to avoid 4
   atomic ops per packet.
   31) kernel: net: fix network-related panic in Linux 3.2.63 and later
   (CVE-2014-7207).
   32) kernel: net: ipv[46] - Remove 2 unnecessary NETDEBUG OOM messages.
   33) kernel: ipv6: mld: fix add_grhead skb_over_panic for devs with large
   MTUs.

   1.0.x
   1) init.d: optimize and small fix switch and offload configure.
   2) init.d: add shortname for LAN (need to lldpd daemon for hostname
   resolutions).
   3) init.d: automount.sh: fix check cold boot.
   4) goahead: fix swith from/to apcli with apcli bridge only modes.
   5) igmpproxy: auto enable Multicast2Unicast in wifi driver at first
   request.
   6) igmpproxy: fix wifi igmp records managment.
   7) kernel: mm: page-writeback: inline account_page_dirtied() into single
   caller.
   8) kernel: ipv4: fix nexthop attlen check in fib_nh_match.
   9) kernel: hw_nat: spin_(un)lock must be Bottom Halve (prevent deadlock).
   10) kernel: ralink wifi: decrease life check packets count, decrease life
   time and check interval for more speed cleanup died clients.
   11) kernel: ralink wifi: add lost increment retry count in jam traffic
   detect path.
   12) kernel: ralink wifi: backport unify jam traffic detect logic from v4
   drivers.
   13) kernel: ralink wifi: decrease tx ring size (set 64 instead of 128).
   14) kernel: ralink wifi: limit to 16 numbers of mcast packets in normal/ps
   queue.
   15) kernel: raeth: fix raise spurious interrupts.
   16) kernel: fastroute: increase CB offcet (found used offset 41 in wifi
   drivers).

   1.1.x
   1) init.d: fix diable offloads in bridged modes.
   2) init.d: fix LLLLL config for bridget modes.
   3) init.d: fix LLLWW config.
   4) init.d: fix kext switch workaround.
   5) init.d: in bridged mode direct enable Multicast2Unicast in wifi drivers
   independed by igmpproxy enable.
   10) sysctl: tune defaults more optimal for 64Mb ram devices.
   11) igmpproxy: rework snooping managment code (temp disable static records
   managent).
   12) buildsystem: small cleanup and more safe gcc flags use for wireless
   modules (driver code in some cases ugly and mabe uncrorrect build with
   this options).
   13) kernel: ralink wifi: fix m2u filter table. Add MDNS and fix IgmpV3
   filter.
   14) kernel: tcp: limit GSO packets to half cwnd.
   15) kernel: fix misuses of f_count() in ppp.
   16) kernel: mips: jump_label.c: Correct the span of the J instruction.
   17) kernel: mips: jump_label.c: Handle the microMIPS J instruction
   encoding.

   1.2.x
   1) init.d/genkeys: remove not need sleep (move to goahead boot complite).
   2) init.d/dnsserv: correct steps generate hosts.
   3) init.d/lanconf: remove not needed swicth clear call.
   4) init.d/goahead: add vlan support for bridge port TV/SIP/STB modes.
   5) init.d/goahead: add 3WAN/2LAN modes for STB+SIP bridget ports mode.
   6) init.d/goahead: add get mcast from VLAN TV/SIP/STB bridges.
   7) init.d/goahead: move delayed backup from goahead to init.d web script.
   8) init.d/goahead: add M2U conversion managment.
   9) init.d/l2tpsrv: fix masqrade rule add.
   10) goahead: use mtd_write erase RW-FS instead of direct crash rwfs.
   11) goahead: cleanup dead code and fix debug.
   12) igmpproxy: ignore igmpv3 block_old_sources
   13) miniupnpd: up to 1.9.20141128 version.
   14) kernel: bridge: implement multicast fast leave.
   15) kernel: bridge: add support multicast-to-unicast (M2U) conversion.
   16) kernel: ralink ehci/ohci: improve host mode init.
   17) kernel: ralink_wifi: disable igmp snooping and mcast rate specific.
   18) kernel: ralink_wifi: fix SGI use/indication in rate_ctl.
   19) kernel: mips: oprofile: Fix backtrace on 64-bit kernel.
   20) kernel: mips: fix address type used for early memory detection.
   21) kernel: mips: lib: memset: Use macro to build the __bzero symbol.
   22) kernel: mips: lib: memset: Add EVA support for the __bzero function.
   23) kernel: pptp: fix stack info leak in pptp_getname().
   24) kernel: random: add and use memzero_explicit() for clearing data.
   25) kernel: mm/memory.c: use entry = ACCESS_ONCE(*pte) in
   handle_pte_fault().
   26) kernel: mm/page_alloc: add unlikely macro to help compiler
   optimization.
   27) kernel: mm/mempolicy: remove per-process flag.
   28) kernel: ppp: build ppp* as static (sligth optimize performance, small
   increase ram usage).
   29) kernel: enchane sections speed hack(fastpathsys ~2% cpu free).
   30) kernel: ipv4: Make IP_MULTICAST_ALL and IP_MSFILTER work on raw
   sockets.
   31) kernel: apply optimize_mips_memcpy_memset_cache.
   32) kernel: ralink spi: allow set FAST/DOR/DIOR from kernel config,
   support DOR on Macronix chips.
   33) kernel: bridge: fix netfilter/NF_BR_LOCAL_OUT for own, locally
   generated queries.
   34) kernel: bridge: send query as soon as leave is received.
   35) kernel: bridge: multicast: enable snooping on general queries only.
   36) kernel: bridge: multicast: allow leave and fast_leave for M2U records.
   37) kernel: disable IPv6 offload for SDRAM memory devices (4Mb FLASH
   samples).

   1.3.x
   1) toolchain: sync with 4.8.4 gcc svn version (after 4.8.3 release 4.8
   tree apply only bugfixes).
   2) toolchain: kernel headers up 02.12.2014.
   3) toolchain: rebuild for 32bit hosts (need for prebuildede build compat).
   4) miniupnpd: up to 1.9.20141204 version.
   5) xl2tpd: up to Nov 26, 2014 git version.
   6) kernel: update to 3.4.105.
   7) kernel: ralink_wifi: update to 2.7.2.0/2.6.2.0 (20140820) AP/STA
   drivers.
   8) kernel: ralink_wifi: add support 64 bit interface counters.
   9) kernel: ralink_wifi: backport ApCliRcvBeaconTime fix from 3.x.x.x
   driver.
   10) kernel: raeth: ppe: move hoocks to raeth instead off external code if
   raeth static build (more consistent code generate).
   11) kernel: raeth: move raeth up in link order place (mast be before ppp
   and wireless modules for more consistent code generate).
   12) kernel: net: pppoe: missed check for destination addr in PADT frame
   processing.
   13) kernel: net: core: Remove redundant call to nf_reset in
   dev_forward_skb.
   14) kernel: net: skbuff: reduce struct size if nf_trace disable.
   15) kernel: net: exclude skb_recycle code from real build, small codesize
   reduce.
   16) kernel: net: revert route cache garbage collector changes introdused
   in 3.4.105 (~5% speed regression after this changes).

   2.0.x
   1) init.d/goahead: add codel auto qos mode support in WebUI.
   2) init.d/goahead: remove simple tos based qos support(use port based or
   codel instead for).
   3) miniupnpd: up to 1.9.20141209 version.
   4) igmpproxy: fix init mrDesc.
   5) igmpproxy: fix client record find in rt switch table.
   6) kernel: arch/ralink: fix mem autodetect if highmem support
   disabled(limit to 256Mb).
   7) kernel: introduce and use generic init task.
   8) kernel: mips: backport some upstream fixes.
   9) kernel: irq: disallow commit to random entropy pool from every
   irq(decrease latency).
   10) kernel: sched: remove extra static_key*() function indirection.
   11) kernel: enable BQL/DQL by default for 8Mb flash with DDR RAM
   devices(decrease latency).
   12) kernel: fastpath: cleanup and small optimize.
   13) kernel: inetdevice: fixed signed integer overflow.
   14) kernel: neigh: remove dynamic neigh table registration support.
   15) kernel: lib/idr: update to current 3.18 tree (compat mode).
   16) kernel: net/raeth: small cleanup.
   17) kernel: net: avoid to hang up on sending due to sysctl configuration
   overflow.
   18) kernel: net: ipmr: limit MRT_TABLE identifiers.
   19) kernel: net: net_sched: backport codel/fq_codel from 3.17 kernel tree.
   20) kernel: net: performance fix for process_backlog.
   21) kernel: net: reduce net_rx_action() latency to 2 HZ.
   22) kernel: net: remove wrong initialization for snd_wl1.
   23) kernel: pkt_sched: avoid requeues if possible.
   24) kernel: net_sched: more precise pkt_len computation.
   25) kernel: net_sched: better precise estimation on packet length for
   untrusted packets.
   26) kernel: tcp: allow for bigger reordering level.
   27) kernel: tcp: fix possible NULL dereference in tcp_vX_send_reset().
   28) kernel: tcp: tcp_make_synack() consumes dst parameter.
   29) kernel: tcp: remove unused tw_cookie_values from tcp_timewait_sock.
   30) kernel: tcp: remove TCPCT.
   31) kernel: tcp: use TCP_SKB_CB(skb)->tcp_flags in input path.
   32) kernel: tcp: use tcp_flags in tcp_data_queue().
   33) kernel: tcp: do not copy headers in tcp_collapse().
   34) kernel: tcp: remove bad timeout logic in fast recovery.
   35) kernel: tcp: be more strict before accepting ECN negociation.
   36) kernel: tcp: RFC6298 supersedes RFC2988bis.
   37) kernel: tcp: Increase timeout for SYN segments.
   38) kernel: tcp: ecn: dont delay ACKS after CE.
   39) kernel: tcp: Remove redundant code entering quickack mode.
   40) kernel: ipv4: gso: send_check() & segment() cleanups.
   41) kernel: ipv6: fix 'inet6_rtm_getroute' to release 'rt->dst' in case of
   'alloc_skb' failure.
   42) kernel: ipv6: gso: remove redundant locking.
   43) kernel: netfilter: cttimeout: fix buffer overflow.
   44) kernel: netfilter: nf_conntrack: add nf_ct_timeout_lookup.

   2.1.x
   1) toolchain: update kernel headers and gcc up to 4.8.4 release.
   2) busybox: update to 1.23.0 version.
   3) busybox: sync with upstream (busybox-1.23.0-ash.patch,
   busybox-1.23.0-modprobe.patch, busybox-1.23.0-vi.patch).
   4) busybox: downgrade zcip code to 1.22.x version(easy fix new gcc issue,
   need rewrite later).
   5) busybox: fix create char device /dev/mtdX as block device (child for
   /dev/mtdblockX).
   6) xz: up to 5.0.8 version.
   7) uboot: update to last version.
   8) reg tool: small fixup.
   9) mii tool: fixup and add 7628 support.
   10) gpio tool: fix 9532 mode support.
   11) nvram lib: do not direct read from flash at show.
   12) nvram tool: fix generate wifi config.
   13) switch tool: add igmp snooping managment.
   14) hw_nat: FoE entry range check, entry valid check.
   15) pppd: fix segfault pppol2tp plugin on IPv6 disabled (broken L2TP).
   16) xupnpd: update to 403r.
   17) xupnpd: lua: update to 5.3.0 version.
   18) init.d: more enchange esw/vlan config logic.
   19) init.d: ipv6: only tunnel mode need full deconfig in some situations.
   20) init.d/goahead: add support native ipv6 with dhcp client mode.
   21) dhcp6c: fix duid generate for WAN (temp hack, add read from
   commandline in future).
   22) radvd: update to 2.10 version.
   23) kernel: ralink: prepare 7621 support.
   24) kernel: ralink_spi: add N25Q256A and MT25QL512AB support.
   25) kernel: ralink spi: fix write after unprotect bits clear, fix Winbond
   quad mode.
   26) kernel: ralink_gpio: switch to schedule_work.
   27) kernel: ralink_gpio: fix 9532 mode support.
   28) kernel: ralink_gpio: disable unused interfaces for use more gpio pins.
   29) kernel: ralink_wifi: add drivers for 7610/76x2 pci-e chips.
   30) kernel: ralink_wifi: fix support 7650 chips.
   31) kernel: raeth: add 802.3az EEE control for MT7620 ESW, disable EEE by
   default for all PHY.
   32) kernel: ralink ehci: add workaround for embedded synopsys host
   controller.
   33) kernel: ralink arch: add MT7621 xHCI platform device, add
   MT7621/MT7628 UPHY calibration.
   34) kernel: ralink arch: usb: xhci: add support MT7621 xHCI HC.
   35) kernel: netfilter: nf_conntrack: allow server to become a client in TW
   handling.
   36) kernel: netfilter: conntrack: avoid zeroing timer.
   37) kernel: net: rearrange loop in net_rx_action.
   38) kernel: net: gro: GRO_MERGED_FREE consumes packets.
   39) kernel: net: gro: fix a potential crash in skb_gro_reset_offset.
   40) kernel: net: gro: dev_gro_receive() cleanup.
   41) kernel: net: gro: avoid double copy in skb_gro_receive().
   42) kernel: net: skbuff: don't zero tc members when freeing skb.
   43) kernel: net_dma: simple removal (broken and not used).
   44) kernel: net_dma: revert copied_early.
   45) kernel: ipv4: dst_entry leak in ip_send_unicast_reply().
   46) kernel: mm: fix swapoff hang after page migration and fork.
   47) kernel: tun: fixed unsigned/signed comparison.
   48) kernel: ipv6: stop sending PTB packets for MTU < 1280.

   2.2.x
   1) build_system: add some variants for 7620 based dual band.
   2) libevent: up to 2.0.22 version.
   3) openssl up to 0.9.8ze version.
   4) nvram: add VHT parametrs for AC module.
   5) igmpproxy: optimize retry timeouts.
   6) init.d/goahead: add select mode 2.4GHz/5GHz for mbssid/apcli/wds
   extensions.
   7) goahead: boost ipaddress buffer size.
   8) goahead: tune default parametrs (increase preallocated bufferss and
   others).
   9) goahead: webui: add allow acess to lan from internet by ipv6 option.
   10) goahead: webui: rearrange some parametrs (more consistent).
   11) goahead: fix apply netfilter rules in some situations.
   12) goahead: fix redirect submit-url issue (may be crash or not correct
   redirects).
   13) goahead: fix selected STA disconnect for dual band in connected client
   list.
   14) goahead: fix green ap mode in WebUI.
   15) goahead: fix channel autoselect for 5GHz.
   16) goahead: add support AC modes in connected client list.
   17) goahead: add band 2.4/5GHz highlighting in connected client list.
   18) goahead: add 5GHz band network mode/name parametrs.
   19) goahead: add 5GHz band network central channel parametr.
   20) goahead: add VHT mode parametrs for AC module in WebUI.
   21) kernel: ralink arch: add support SD/MMC driver for
   MT7620/MT7621/MT7628.
   22) kernel: net: skb_share_check() should use consume_skb().
   23) kernel: mips: irq: fix disable_irq on CPU IRQs.
   24) kernel: mips: fix restart of indirect syscalls.
   25) kernel: mips: fix kernel lockup or crash after CPU offline/online.
   26) kernel: mips: remove race window in page fault handling.

   2.3.x
   1) toolchain: gcc up to 4.8.5-20150129 (after 4.8.4 only backport fixes).
   2) dropbear: up to 2015.67 version.
   3) eth_mac: add support wlan/wlan2 mac managment.
   4) apps: add iw tool to build tree.
   5) kernel: up to 3.4.106 version.
   6) kernel: ralink_wifi: up 7610 driver to 3.0.0.8 version.
   7) kernel: ralink_wifi: fix ate work in extpa/extlna mode.
   8) kernel: sched/completion: add lock-free checking of the blocking case.
   9) kernel: mips: allow MIPS_CPU_SCACHE to be used with different line
   sizes.
   10) kernel: mips: smp-mt,smp-cmp: Enable all HW IRQs on secondary CPUs.
   11) kernel: mips: mt: proc: Add support for printing VPE and TC ids.
   12) kernel: mips: synchronize MIPS count one CPU at a time.
   13) kernel: mips: vpe.c: Fix null pointer dereference in print arguments.
   14) kernel: mips: remove gic_{enable,disable}_interrupt().
   15) kernel: mips: gic: remove gic_{pending,itrmask}_regs.
   16) kernel: mips: gic: remove platform irq_ack/irq_eoi callbacks.
   17) kernel: mips: gic: implement commit MIPS: IRQ: Fix disable_irq on CPU
   IRQs.
   18) kernel: mips: gic: fix gic_set_affinity() return value.
   19) kernel: pci: fix P2P bridge I/O port window sign extension.
   20) kernel: pci/portdrv: remove warning about invalid IRQ for hot-added
   PCIe ports.
   21) kernel: ipv4: remove output route check in ipv4_mtu.
   22) goahead: do not set FixedTxMode if MCS not limited/auto.
   23) goahead: hide some VHT options for parametrs fixed at 1T1R.
   24) goahead: split disable wifi modules, TxPower parametrs by band.
   25) goahead: move select band for ViF modes from advanced to basic.
   26) goahead: fix infinitive loop with high cpu usage in websGetInput.
   27) goahead: fix potentional security issue (extend path check in url req
   handler).
   28) goahead: fix info leak in socket reuse code.
   29) goahead: fix return web error code in some case.
   30) goahead: limit request ring length.
   31) init.d: add change wlan/wlan2 macs in factory.

   2.4.x
   1) build_system: add test targets for usb devices.
   2) build_system: correct entry point for 7621 at make image.
   3) libcurl: up to 7.40.0 version.
   4) transmission: up to 2.84.
   5) usb-modeswitch: up to 2.2.1 version (data up to 20150115).
   6) ethtool: up to 3.18 version.
   7) quagga: up to 0.99.23.1 version.
   8) firmware: add factory backup to 7621 dualwan.
   9) libnvram: fix small memleak, full code review and cleanup.
   10) ethtool: disable build vendors extensions (decrease size).
   11) apps: add fuse ntfs-3g (2014.2.15).
   12) dhcpv6: add read ifname for duid generatr from /tmp/wan_if_name
   exported from init.d.
   13) eth_mac: add 7621 dualwan support.
   14) apps: add irqbalance for auto balancing irq by cpu cores (19.02.2015
   git).
   15) nvram_tool: remove all old ralink_init call, use nvram_* commands
   instead(code cleanup).
   16) switch_tool: fix wait timeouts and code cleanup.
   17) busybox: apply busybox-1.23.1-wget.patch,
   busybox-1.23.1-modinfo.patch.
   18) igmpproxy: fix snooping work at 7621 with GMAC2 config.
   19) goahead: fix hide enable 5GHz module issue.
   20) goahead: annotate console error message.
   21) goahead: add 1Gbit link status.
   22) goahead: fix error messages at call external scripts in some case.
   23) goahead: full remove WPS support (very old dead code for hackless
   option).
   24) goahead: add configure vlan double tag (QinQ) support in WebUi.
   25) init.d: cheanup and refactor checkconf, remove unneded backup nvram
   and others.
   26) init.d: rework for support dual phy mode.
   27) init.d: add 7530 switch portmap configure support.
   28) init.d: rework switch part config logic.
   29) init.d: do not insert eth3 to br0 in bridge/apcli modes(fix loop and
   not need switch allready parted as LLLLL).
   30) init.d: rework fullreset and defaults managment logic.
   31) kernel: add mtune options for ralink/mediatek cpus.
   32) kernel: ralink_mtd: fix overflow bug in 'ra_mtd_write_nm', add support
   write to NAND flash, add support write to any partition offset.
   33) kernel: ralink_mtd: fix SPI clock for MT7621.
   34) kernel: ralink mtd: add MT7621 NAND driver (based on kernel NAND
   framework).
   35) kernel: ralink_arch: update MT7621 code.
   36) kernel: ralink_arch: increase PCIe N_FTS for MT7620 too.
   37) kernel: ralink_arch: fix MT7621 performance impact on activate sleep
   mode (use divider 2 instead of 10).
   38) kernel: ralink arch: fix MT7621 GIC init on MIPS_MT disabled.
   39) kernel: ralink arch: fix detect RAM/OCP on MT7621.
   40) kernel: ralink_wifi: align and merge OID structure RT_802_11_MAC_TABLE
   to userspace applications.
   41) kernel: ralink_wifi: update firmware for 76x2 module.
   42) kernel: ralink_wifi: add log connect/disconnect events.
   43) kernel: ralink_wifi: fix build correct without DBG defined.
   44) kernel: ralink_wifi: desintegrate AP_QLOAD and chanbusytime in
   ap_autoChSel.
   45) kernel: ralink_wifi: remove bogus flag VCORECAL_SUPPORT from MT7612E
   profile.
   46) kernel: ralink_wifi: MT7612E/MT7602E: disable eFuse by default.
   47) kernel: ralink_wifi: MT7612E/MT7602E: code cleanup and fix warnings.
   48) kernel: ralink_wifi: MT7612E/MT7602E: fix HT client speed issue
   (backport from MT7603 v4 driver).
   49) kernel: ralink_hw_nat: fix offload from MT7612/MT7602/MT7603
   apcli/wds, add interfaces hash table.
   50) kernel: ralink_hw_nat: fix broken code with MT7621 HW_VLAN_RX raeth
   offload, fix PPPoE offload on MT7621/RT3883 with 2xGMAC + VLAN
   incapsulated.
   51) kernel: ralink_raeth: update MT7621 code & switch control, do not
   hard-coded disabling EEE by default.
   52) kernel: ralink_raeth: serializing MDIO access on multithread
   environment (fix MII registers corruption).
   53) kernel: ralink_raeth: add kernel option for disable preconfigure p5/p6
   at ifup.
   54) kernel: ralink_raeth: switch control: enhance MT7621 ESW MIB counters.
   55) kernel: ralink_raeth: switch control: improve support MT7620/MT7621 HW
   IGMP/MLD snooping, add IGMP static port control for AP mode.
   56) kernel: ralink_usb: fix broken MT7621 USB PHY calibration (SDK bug).
   57) kernel: ralink_sd: MT7620/MT7621/MT7628 SD/MMC driver cleanup, fix
   unload module with debug enabled.
   58) kernel: ralink_gpio: add usb lid blink at usb transfer.
   59) kernel: ralink_nvram: add options for config dualband mode nvram(one
   or different offsets).
   60) kernel: huge update NAND framework from upstream.
   61) kernel: exfat: add module alias for fix automount.
   62) kernel: ipv4: ip_check_defrag should correctly check return value of
   skb_copy_bits.
   63) kernel: ipv6: fix ipv6_cow_metrics for non DST_HOST case.
   64) kernel: igmp: add __ip_mc_{join|leave}_group().
   65) kernel: pci: leave MEM and IO decoding disabled during 64-bit BAR
   sizing, too.
   66) kernel: sg: fix read() error reporting.

   2.5.x
   1) toolchain: apply build root patchset binutils/uclibc.
   2) toolchain: sync uclibc patches, update gcc to 19.02.2015 4.8.5 version
   form git, update headers.
   3) build_system: libs: try build more libs only as shared (do not install
   static libs to romfs if not need).
   4) build_system: libs: add libxml2, libneon.
   5) build_system: libs: use gc section for external libs.
   6) build_system: apps: add davfs2.
   7) uboot: fix recovery work at more then 8Mb flash devices.
   8) libcurl: up to 7.41.0 version.
   9) samba: remove old 2.0 version of samba, always use 3.0.37.
   10) goahead: use fs restore instead of direct call mtd_write erase RW-FS.
   11) goahead: remove drop targets in nat table (new kernel not support
   this, only filter table use).
   12) goahead: fix ipportfilter,portforward not correct save in some cases.
   13) goahead: hide software fastpath elements if not build in kernel.
   14) init.d: unify swicth portmap logic.
   15) init.d: fix vlan enabled check.
   16) init.d: optimize switch reinit procesure.
   17) init.d: more human readable variable name and prevent overwrites in
   dependen logic.
   18) init.d: touch switch in some cases make depend at switch parth instead
   of direct mode check.
   19) init.d: remove switch reinit workarounds after reath and hw_nat
   pathcs.
   20) init.d: fix check vlan and set correct part sitch mode.
   21) init.d: fix drop some variables in full bridge modes.
   22) init.d: send hotplug rescan to background (speedup boot).
   23) init.d: tune irqbalance script for optimum performance.
   24) kernel/uboot: add 25Q*BSIG flash chips support.
   25) kernel: review fastpath section use (save more cpu ~4% up).
   26) kernel: pppoe: use workqueue to die properly when a PADT is received.
   27) kernel: ralink_arch: update cpu-feature-overrides.h.
   28) kernel: ralink_arch: MT7621 move irq function to fastpathsys.
   29) kernel: ralink_arch: add prototype to enable I/O coherency.
   30) kernel: ralink_hw_nat: do not touch MT7620 ESW P6/P7 PCR for case dumb
   switch.
   31) kernel: ralink_raeth: skip redundant dma_cache_sync to coherence
   region of rx_desc.
   32) kernel: ralink_raeth: switch control: fix VLAN filtering on MT7621 ESW
   with GE2->P5 case.
   33) kernel: ralink_wifi: MT7612E/MT7602E: fix rate_pwr_table
   initialization bug.
   34) kernel: mips: avoid mcheck by flushing page range in
   huge_ptep_set_access_flags().
   35) kernel: mips: fix branch emulation of branch likely instructions.
   36) kernel: mips: add option to disable software I/O coherency.
   37) kernel: mips: reduce code size for MIPS32R2 platforms.
   38) kernel: mips: dsp: add assembler support for DSP ASEs.
   39) kernel: mips: dsp: simplify the DSP macros.
   40) kernel: mips: dsp: fix code generation for non-DSP capable CPUs.
   41) kernel: mips: revert remove race window in page fault handling.
   42) kernel: genirq: introduce irq_do_set_affinity() to reduce duplicated
   code.
   43) kernel: genirq: allow forcing cpu affinity of interrupts.
   44) kernel: genirq: provide irq_force_affinity fallback for non-SMP.
   45) kernel: genirq: set initial affinity in irq_set_affinity_hint().
   46) kernel: net: fix stacked vlan offload features computation.
   47) kernel: net: reject creation of netdev names with colons.
   48) kernel: net: tcp: fix tcp_should_expand_sndbuf() to use
   tcp_packets_in_flight().
   49) kernel: net: tcp: tso: remove tp->tso_deferred.
   50) kernel: net: tcp: tso: allow CA_CWR state in tcp_tso_should_defer().
   51) kernel: net: ipv6: addrconf: validate new MTU before applying it.
   52) kernel: net: allow enable/disable XPS/RPS configure.
   53) kernel: net: neigh: don't require dst in neigh_hh_init.
   54) kernel: net: neigh: don't require a dst in neigh_resolve_output.
   55) kernel: net: udp: only allow UFO for packets from SOCK_DGRAM sockets.
   56) kernel: netfilter: FCONE/RCONE optimization (do not compare ifname),
   allow eth3.x as WAN/MAN.
   57) kernel: make READ_ONCE() valid on const arguments.

   2.6.x
   1) toolchain: sync uclibc patches, update gcc to 12.03.2015 4.8.5 version
   form git, update headers.
   2) build system: move gpio config to kernel config.
   3) build system: split defaults for 762x with 7612NE module.
   4) miniupnpd: up to 1.9.20150307 version.
   5) quagga: up to 0.99.24.1 version.
   6) pppd: fix disconnect socket regression after kernel pppoe sockets
   cleanup fix.
   7) goahead: restore factory mac if try set invalid mac from web.
   8) goahead: add button for restore factory mac.
   9) init.d: enchange boot indications.
   10) init.d: ipv6: fix IPOE v6 mode with tunneled WAN for v4.
   11) init.d: irqbalance: tune modes and enable auto by defaults.
   12) init.d: move ripd/zebra config from goahead to init.
   13) init.d: wifi.sh: touch Channel by iwpriv (aplci connect after apply
   workaround).
   14) init.d: fs: add factory_mac command for restore macs in nvram by
   factory.
   15) kernel: fastpaths: add disable nat fastpath option, small optimize.
   16) kernel: fastpaths: fix locks imbalance issue (lost unlock in output).
   17) kernel: fastpaths: fastnat switch use cb[43] for deny flag (more fast
   and safe).
   18) kernel: fastpaths: optimize skip nat offload logic.
   19) kernel: fastpaths: clear in ip_input CB only for loopback packets.
   20) kernel: ralink_raeth: add support GRO offload.
   21) kernel: ralink_raeth: fix potential deadlock on unregister second
   interface.
   22) kernel: ralink_raeth: fix reuse dirty TX descriptor.
   23) kernel: ralink_raeth: use memory barrier instead of double cache sync
   on coherent region.
   24) kernel: ralink_hw_nat: use memory barrier instead of double flush to
   coherent region.
   25) kernel: ralink_hw_nat: change BIND state after update FoE entry.
   26) kernel: mips: allow optimized inliming.
   27) kernel: mips: revert fixrange_init() limiting to the FIXMAP region.
   28) kernel: mips: highmem fixes for cache aliasing and non-DMA I/O.
   29) kernel: mips: fix of reading I-pages from non-DMA FS devices for ID
   cache separation.
   30) kernel: mips: bugfix: missed cache flush of TLB refill handler.
   31) kernel: mips: tlbex: Fix size of area to be flushed.
   32) kernel: mips: iomap: use __mem_{read,write}{b,w,l} for MMIO.
   33) kernel: mips: apply `.insn' to fixup labels throughout.
   34) kernel: net: inet: sanitize inet{,6} protocol demux.
   35) kernel: net: make skb->skb_iif always track skb->dev.
   36) kernel: net: remove protocol from struct dst_ops.
   37) kernel: net: ipv6: make unsolicited report intervals configurable for
   mld.
   38) kernel: net: ipv6: mld: fix v1/v2 switchback timeout to rfc3810, 9.12.
   39) kernel: net: ipv4: disallow non-namespace aware protocols to register
   only if namespaces enabled.
   40) kernel: net: ipv4: raise tcp PMTU probe mss base size.
   41) kernel: net: ipv4: ip_check_defrag should not assume that
   skb_network_offset is zero.
   42) kernel: net: ipv4: use binary search to choose tcp PMTU probe_size.
   43) kernel: net: ipv4: create probe timer for tcp PMTU as per RFC4821.
   44) kernel: net: neigh: keep neighbour cache entries if number of them is
   small enough.
   45) kernel: net: neigh: optimize neighbor entry size calculation.
   46) kernel: net: neigh: no need to call lookup_neigh_parms in
   neigh_parms_alloc.
   47) kernel: net: neigh: disallow un-init_net to change thresh of neigh.
   48) kernel: net: netfilter: nf_conntrack: use RCU safe kfree for conntrack
   extensions.
   49) kernel: net: netfilter: nf_conntrack: fix RCU race in
   nf_conntrack_find_get.
   50) kernel: net: bridge: reset bridge mtu after deleting an interface.
   51) kernel: net: packet: make packet_snd fail on len smaller than l2
   header.
   52) kernel: net: neighbour: fix ndm_type type error issue.
   53) kernel: timekeeping: Fix HRTICK related deadlock from ntp lock
   changes.
   54) kernel: sched/__wake_up_sync_key(): Fix nr_exclusive tasks which lead
   to WF_SYNC clearing.
   55) kernel: sched: fix HRTICK.

   2.6.x
   1) butcheck: add polling WPS press and call umount all script if
   pressed(if support storage configured).
   2) openssl: up to 0.9.8zf version.
   3) init.d: disable EEE by defaults (compat with old boots).
   4) init.d: fix logging if syslog disabled.
   5) xupnpd: switch to 5.1.x lua use (fix compat with last portable upnpd
   sdk with bug utf locale parse).
   6) xupnpd: use mpeg as default mime type (more devices compat whith this
   type).
   7) xupnpd: impliment base profile for Panasonic Viera(need manual default
   mime set to mpeg_ts now).
   8) xupnpd: auto use udpxy if enabled.
   9) goahead: add ldpc to station list.
   10) kernel: ralink_raeth: enable NAPI_GRO for all devices.
   11) kernel: ralink_wifi: unify exported struct.
   12) kernel: ralink_gpio: add config WPS button gpio number.
   13) kernel: ralink_arch: fix reset MT7621 PCIe peripherals.
   14) kernel: ralink_spi: fix SPI clock for MT7621 (bclk is 50MHz).
   15) kernel: netfilter: nf_nat: change sequence number adjustments to 32
   bits.
   16) kernel: nf_conntrack_core: show conntrack limit value on table full.
   17) kernel: net: allow GRO only for local recived packets.
   18) kernel: net: add skb_dst_set_noref_force.
   19) kernel: net: tcp: fix tcp fin memory accounting.
   20) kernel: net: increase sk_[max_]ack_backlog.
   21) kernel: net: validate the range we feed to iov_iter_init() in
   sys_sendto/sys_recvfrom.
   22) kernel: net: separate the close_list and the unreg_list.
   23) kernel: net: fix high overhead of vlan sub-device teardown.

   2.7.x
   1) build_system: small rework DoConfigure.sh scripts.
   2) init.d: six: fix logic dhcpv6/radvd configure if not prefix recived
   (experimental).
   3) init.d: six: always remove sit module in stop path (auto loaded after
   call ip tool).
   4) dhcpv6: fix renewal of IA NA.
   5) dhcpv6: close file descriptors on exec.
   6) dhcpv6: try and generate a default IFID only if an IFID is not
   configured.
   7) dhcpv6: ignore advertise messages with none of requested data and
   missed status codes.
   8) kernel: ralink_wifi: disable 40MHz intolerant support if DRAFT3
   undefined.
   9) kernel: ralink_hw_nat: exclude UDP bug check for MT7621.
   10) kernel: ralink_raeth: fix SG regression.
   11) kernel: net: af_packet: make tpacket_rcv to not set status value
   before run_filter.
   12) kernel: net: ipmr,ip6mr: call ip6mr_free_table() on failure path.
   13) kernel: net: netfilter: bridge: kill nf_bridge_pad.
   14) kernel: net: ipv6: Don't reduce hop limit for an interface.

   2.8.x
   1) toolchain: update gcc to 07.04.2015 4.8.5 version form git, update
   headers.
   2) defaults: set safe VHT options for all 802.11ac modules(disable
   BW_SIG/LDPC/STBC).
   3) init.d: fix usb hotplug/automount.
   4) udhcpc: fix static routes apply in some cases.
   5) goahead: fix lang select race in some situations.
   6) goahead: fix upload firmware error handling.
   7) goahead: set HT_LDPC as VHT_LDPC (unify webUI control).
   8) nvram: fix store old macs.
   9) kernel: ralink_raeth: add support MT7621 QDMA, split PDMA/QDMA code,
   code refactoring.
   10) kernel: ralink_raeth: force up MAC for each ESW PHY.
   11) kernel: ralink_raeth: fix wireless/external offload concurrent with
   BQL (recycle TX to PPE stuck issue).
   12) kernel: ralink_raeth: do not ack INT status on NAPI poll active
   (MT7621 GIC pending INT issue).
   13) kernel: ralink_hw_nat: add support MT7621 QDMA, write FoE descriptors
   by DWORD chunk.
   14) kernel: ralink_hw_nat: add support MT7621 multicast offload.
   15) kernel: ralink_hw_nat: optimize mark/test DPORT_PPE.
   16) kernel: ralink_arch: fix typo in MT7621 PCIe interrupts map.
   17) kernel: ralink_wifi: fix MT7610/12/02/03 bug on set FixedTxMode.
   18) kernel: mips: fix race condition in lazy cache flushing.
   19) kernel: jump_label: split jumplabel ratelimit.
   20) kernel: jump_label: allow asm/jump_label.h to be included in assembly.
   21) kernel: jump_label: allow jump labels to be used in assembly.
   22) kernel: conntrack: fix one way voice issue if SIP ALG enabled.
   23) kernel: netfilter: fix issue of some SIP Providers use only port 5060
   for send/listen calls.
   24) kernel: net: less interrupt masking in NAPI.
   25) kernel: net: move napi polling code out of net_rx_action.
   26) kernel: net: always poll at least one device in net_rx_action.
   27) kernel: net: remove k{un}map_skb_frag().
   28) kernel: net: simple_strtoul cleanup.
   29) kernel: net: dont drop packet but consume it.

   2.9.x
   1) build_system: toolchain: add support auto install needed pkgs in
   ubuntu.
   2) build_system: fix build libext dependency.
   3) build_system: fix build libc headers (use -isystem instead of -I for
   correct dependency).
   4) build_system: fix build flags change for uclibc.
   5) build_system: move nvram/mtd headers include from different make files
   to config.arch.
   6) build_system: enable -Bsymbolic-functions by default for linking shared
   libs.
   7) init.d: global.sh small cleanup.
   8) init.d: move dhcpv6 client config and start to /etc/init.d/six.
   9) init.d: optimize refresh device nodes, hotplug rescan and preinit
   scripts.
   10) init.d: initial support ipv6 dual stack native mode over
   PPPOE/PPTP/L2TP.
   11) init.d: more readable system info export from lldp.
   12) defaults: allow use VHT_STBC/LDPC for MT7612 module.
   13) defaults: allow use VHT_STBC for MT7610 module.
   14) radvd: up to 2.11 version.
   15) dnsmasq: up to 2.73rc7 version.
   16) ntfs-3g: up to 2015.3.14 version.
   17) miniupnpd: up to 1.9.20150427 version.
   18) igmpproxy: use daemon function instead of direct coding.
   19) udpxy: fix work at 3.5.x and more new linux kernels.
   20) pppd: do not build ipx support if not enabled in kernel.
   21) lldpd: up to 0.7.14 version.
   22) dhcp6c: do not open a routing socket that's never used.
   23) dhcp6c: more compath with new uclibc/glibc.
   24) goahead: do not touch HT_LDPC (not support in clients at real world).
   25) goahead: allow select VHT_STBC mode for 7610 module.
   26) goahead: more localization fixes.
   27) goahead: add lan_port variable (default near) for tune ports numbers
   in UI and real box.
   28) kernel: up to 3.4.107 version.
   29) kernel: configs: enable inotify support(now used for dnsmasq for
   detect hosts/resolv files changed).
   30) kernel: ralink_wifi: fix support VHT in apcli mode for MT7612.
   31) kernel: ralink_wifi: disable VHT in WEP encryption mode for apcli(more
   compat with wifi aliance recomendtions).
   32) kernel: ralink_wifi: fix kernel api mismatch u(g)id types to u(g)id_t.
   33) kernel: ralink_wifi: allow mac address changes.
   34) kernel: ralink_wifi: MT7612 fix LastTxRate update.
   35) kernel: ralink_wifi: MT76xx anonse 40MHz SGI only if 40MHz BW enabled.
   36) kernel: ralink_wifi: MT76x2 improve parse 7602/7612 pair as
   first/second card.
   37) kernel: ralink_wifi: MT76x2 exclude debug in release mode.
   38) kernel: ralink_wifi: convert wmode to cfgmode on RT_OID_GET_PHY_MODE
   for MT7610/76x2, fix wmode_2_cfgmode.
   39) kernel: drop bogus check in file_open_root().
   40) kernel: mips: dma-default: fix 32-bit fall back to GFP_DMA.
   41) kernel: mips: hibernate: flush TLB entries earlier.
   42) kernel: mips: bitops.h: Avoid inline asm for constant FLS.
   43) kernel: net: gro: should be ECN friendly.
   44) kernel: net: gro: should aggregate frames without DF.
   45) kernel: net: add address assign type "SET".
   46) kernel: net: init perm_addr in register_netdevice().
   47) kernel: ethtool: set addr_assign_type to NET_ADDR_SET when addr is
   passed on create.
   48) kernel: ethtool: consolidate work with ethtool_ops.
   49) kernel: ethtool: make .get_dump_data() harder to misuse by drivers.
   50) kernel: netfilter: ctnetlink: fix leak in error path of
   ctnetlink_create_expect.
   51) kernel: netfilter: ctnetlink: don't permit ct creation with random
   tuple.
   52) kernel: netlink: validate addr_len on bind.
   53) kernel: netlink: change presentation of portid in procfs to unsigned.
   54) kernel: rtnetlink: fix error return code in rtnl_link_fill().
   55) kernel: bridge: use dev->addr_assign_type to see if user change mac.
   56) kernel: inetpeer: fix token initialization.
   57) kernel: ipv4: use standard iovec primitive in raw_probe_proto_opt.
   58) kernel: mips: fix start of free memory when using initrd.
   59) kernel: pppoe: lacks DST MAC address check.
   60) kernel: ppp: unset skb checksum complete in ppp_receive_frame.
   61) kernel: ppp: mppe: sanity error path rework.
   62) kernel: ppp: mppe: discard late packet in stateless mode.
   63) kernel: ip_forward: drop frames with attached skb->sk.
   64) kernel: tcp: fix possible deadlock in tcp_send_fin().
   65) kernel: dql: dql_queued() should write first to reduce bus
   transactions.

   3.0.x
   1) toolchain: update gcc to 26.05.2015 4.8.5 version form git, update
   headers.
   2) uboot: update to 4.3.2.0 version.
   3) configs: enable hw_nat ipv6 support for all devices.
   4) configs: enable ipt_accounting support for all devices with flash >
   4Mb.
   5) igmpproxy: fix switch managment.
   6) switchtools: add vlan clear command.
   7) miniupnpd: up to 1.9.20150430 version.
   8) libcurl: up to 7.42.1 version.
   9) dnsmasq: up to 2.73rc8 version.
   10) busybox: udhcpc: use RFC2132-compliant T2 expired timer on 7/8 lease
   time.
   11) goahead: in webui add VPN/WAN ipv6 uplink switch.
   12) goahead: cleaning and fixing network web forms.
   13) goahead: move radvd and dhcp6s services to ipv6 page.
   14) goahead: enable ipt_accounting page.
   15) goahead: add decription to dhcp static leases.
   16) goahead: automatic disable pure pppoe at disable/switch type VPN.
   17) goahead: review, cleanup and fix dhcp server page.
   18) goahead: fix nvram_init/commit unconsistent.
   19) goahead: more translation fixes.
   20) goahead: webui some fixes wireless basic.
   21) goahead/init.d: store dhcp static lease to nvram.
   22) init.d: full cleanup vlan parts in restore dumb mode function.
   23) init.d: remove disable_all_ports_eee (already disabled in raeth).
   24) init.d: iptables: split v4 rules generate code for more readable and
   more easy edit.
   25) init.d: fix wan config if pure pppoe enabled and vpn full disabled
   mode.
   26) kernel: add MX25L51245G, MT25QL512AB, N25Q256A spi flashs support.
   27) kernel: ralink_arch: disable MT7621 PCIe Spread Spectrum to avoid Ch14
   Rx De-sense.
   28) kernel: ralink_arch: set MT7628 PCIe PHY to 1.3mA for power saving
   when PCIe port not used.
   29) kernel: ralink_arch: fix MT7628 SDXC clock interferences.
   30) kernel: ralink_arch: fix reset MT7621 PCIe peripherals on disable
   GPIO_PERST def.
   31) kernel: ralink_nvram: fix check part size in commit.
   32) kernel: ralink_hw_nat: add FoE 80b entries workaround on IPv6 offload
   enabled.
   33) kernel: ralink_hw_nat: disable multicast offload on QDMA enabled (CPU
   reason is stripped after FQ).
   34) kernel: ralink_raeth: fix MT7628 EPHY initialization.
   35) kernel: ralink_raeth: always use TX ring size 512 to prevent ring full
   on PPE loopback traffic.
   36) kernel: ralink_raeth: add support MT7621 'clause 45' MDIO control.
   37) kernel: ralink_raeth: fix dump MT7621/MT7530 EPHY registers.
   38) kernel: ralink_raeth: move early ESW init to global unit.
   39) kernel: ralink_raeth: add EEE-related functions, disable EEE by
   default, fix disable EEE on MT7620 ESW, improve EEE support on
   MT7621/MT7530.
   40) kernel: ralink_raeth: add support to disable any EPHY.
   41) kernel: ralink_raeth: improve MT7621 performance on TX path.
   42) kernel: exfat driver: upstream updates.
   43) kernel: driver core: fix race with userland in device_add().
   44) kernel: usb: fix use-after-free bug in usb_hcd_unlink_urb().
   45) kernel: usb: serial: fix potential use-after-free after failed probe.
   46) kernel: usb: xhci: allocate correct amount of scratchpad buffers.
   47) kernel: usb: xhci: fix reporting of 0-sized URBs in control endpoint.
   48) kernel: usb: xhci: handle Config Error Change (CEC) in xhci driver.
   49) kernel: netfilter: nf_nat_h323: fix crash in
   nf_ct_unlink_expect_report().
   50) kernel: netfilter: nf_ct_sip: extend RCU read lock in
   set_expected_rtp_rtcp().
   51) kernel: netfilter: xt_socket: fix a stack corruption bug.
   52) kernel: netfilter: nf_ct_sip: support Cisco 7941/7945 IP phones.
   53) kernel: netfilter: xt_time: add support to ignore day transition.
   54) kernel: netfilter: Implement RFC 1123 for FTP conntrack.
   55) kernel: net: pppoe: drop pppoe device in pppoe_unbind_sock_work.
   56) kernel: net: ipt_accounting portted to 3.4 kernel.
   57) kernel: net: sysctl_net_core: check SNDBUF and RCVBUF for min length.
   58) kernel: net: tcp: update reordering first before detecting loss.
   59) kernel: net: tcp: set SOCK_NOSPACE under memory pressure.
   60) kernel: net: ipv4: kill ip_rt_frag_needed().
   61) kernel: net: ipv4: icmp: fix PMTU handling for rare case.
   62) kernel: net: ipv4: remove unnecessary code from rt_check_expire().
   63) kernel: net: ipv4: route: fix sending IGMP messages with link address.
   64) kernel: net: ipv4: avoid a test in ip_rt_put().
   65) kernel: net: ipv4: speedup ip_idents_reserve().
   66) kernel: net: ipv4: avoid crashing in ip_error.
   67) kernel: net: ipv6: introduce ip6_rt_put().
   68) kernel: net: ipv6: stop /128 route from disappearing after pmtu
   update.
   69) kernel: net: ipv6: check RTF_LOCAL on rt->rt6i_flags instead of
   rt->dst.flags.
   70) kenrel: net: ipv6: stop using NLA_PUT*().
   71) kernel: net: ipv6: fix handling of blackhole, prohibit, throw routes.
   72) kernel: net: ipv6: fib6_rules should return exact return value.
   73) kernel: net: ipv4/6: handle PMTU in all ICMP error handlers.
   74) kernel: net: sit: always notify change when params are updated.
   75) kernel: net: sit: generate icmpv6 error when receiving icmpv4 error.
   76) kernel: net: move away from NLMSG_PUT().
   77) kernel: net: do not use RTA_PUT() macros.
   78) kernel: net: fix pptp regession, use generic tracking for GRE if ALG
   not loaded and PPTP support builtin.
   79) kernel: net: bridge: allow setting hash_max + multicast_router if
   interface is down.
   80) kernel: net: bridge: fix parsing of MLDv2 reports.
   81) kernel: net: bridge: skip fdb add if the port shouldn't learn.
   82) kernel: net: complete remove Token Ring.
   83) kernel: net: ppp: deflate: never return len larger than output buffer.
   84) kernel: net: inet: properly align icsk_ca_priv.

   3.1.x
   1) toolchain: update gcc to 04.06.2015 4.8.5 version form git, update
   headers.
   2) lldpd: up to 0.7.15 version.
   3) dnsmasq: up to 2.73rc10 version.
   4) libnatpmp: up to 20150609 version.
   5) openssl up to 0.9.8zg version.
   6) lldtd: fix wifi speeds for new devices.
   7) mtd_write: blink system led at every erase/write flash access.
   8) nvram: implement nvram_get_copy to copy get variable mode for use in
   nvram_renew.
   9) nvram: use not copy mode get by default (fix small memleak).
   10) nvram: fix nonsplit dualif mode in some cases.
   11) defaults: review and fix parametrs in genwlcofig.
   12) defaults: if enable autoselect channel - autorescan and select free
   channel every 24hour by default (7620 and 7612).
   13) goahead: fix memory leak at wireless->basic page parse.
   14) goahead: fix drop security settings after mode change.
   15) goahead: webui: fix ntp status.
   16) goahead: add NoForwardingMBCast option for isolate client2client BCAST
   traffic.
   17) goahead: add MaxStaNum for limit maximum connection.
   18) goahead: add StationKeepAlive for tune interval to send alive packets
   to clients for detect dead link.
   19) goahead: add IdleTimeout for tune timeout station idle before link set
   as down.
   20) goahead: add select AutoChannel algoritm (1 - select channel by STA
   count now default, 2 - select channel by rssi).
   21) goahead: add ACSCheckTime (rescan interval 0-24h, default 24).
   22) goahead: fix extchannel select.
   23) goahead: fix load defaults from webui.
   24) init.d: cleanup led blink direct calls.
   25) init.d: read sysled gpio from kernel config.
   26) init.d: more early btn reset check start.
   27) init.d: dnsmasq: remove -f (--filterwin2k) no needed now (need only
   for ppp dial-on-demand support now).
   28) init.d: add basic fast roaming parametrs tune support for 76x2
   drivers.
   29) kernel: ralink_wifi: 7610: add AC mode network type (fix modes in
   aplist after scan).
   30) kernel: ralink_wifi: 7610: increase tx ring size to 256.
   31) kernel: ralink_wifi: 7610: add region 22 in a band.
   32) kernel: ralink_wifi: 7610: add check payload length in AES/WEP/TKIP.
   33) kernel: ralink_wifi: 7610: fix set flags in mcs lut.
   34) kernel: ralink_wifi: 7610: for all mcs <= 9 need use 1T1R mode rate
   table.
   35) kernel: ralink_wifi: 7610: cleanup VHT_IE if legacy client connect.
   36) kernel: ralink_wifi: 7610: fix beacon IE cap update.
   37) kernel: ralink_wifi: 7610: add lost Intel IOT workaround.
   38) kernel: ralink_wifi: xxxx: fix potentional null pointer dereference in
   WMM processing.
   39) kernel: ralink_wifi: xxxx: add NoForwardingMBCast option for isolate
   client2client BCAST traffic.
   40) kernel: ralink_wifi: xxxx: review and cleanup dyncvga and microvawe
   oven detect support.
   41) kernel: ralink_gpio: fix use gpio pins shared with extphy/pa.
   42) kernel: ralink_arch: NR_IRQS is no longer dependent from
   BITS_PER_LONG.
   43) kernel: mips: irq: use DECLARE_BITMAP.
   44) kernel: mips: bmips: fix bmips_wr_vec().
   45) kernel: mips: adjust mips highmem offset to avoid the need for
   -mlong-calls on systems with >256M RAM.
   46) kernel: mips: c-r4k: fix typo in probe_scache().
   47) kernel: mips: fix enabling of DEBUG_STACKOVERFLOW.
   48) kernel: jhash: update jhash_[321]words functions to use correct
   initval.
   49) kernel: sfhash: add generic inline helper for more gcc optimize
   effect.
   50) kernel: mm: use clear_page_mlock() in page_remove_rmap().
   51) kernel: mm: remove free_page_mlock.
   52) kernel: mm: remove unevictable_pgs_mlockfreed.
   53) kernel: net: udp: fix behavior of wrong checksums.
   54) kernel: net: bridge: fix multicast router rlist endless loop.

   3.2.x
   1) toolchain: update gcc to 4.8.5 release, update headers.
   2) toolchain: enhance build reproducability.
   3) toolchain: binutils: backport some fixes.
   4) uclibc: backport some fixes.
   5) dnsmasq: up to 2.73 version.
   6) libcurl: up to 7.43.0 version.
   7) usb-modeswitch: up to 2.2.3 2015-06-29 version, usb-modeswitch-data up
   to 2015-06-27.
   8) nvram: add AutoChannelSkipList for skip channels from autoselect result
   (default for 2.4GHz 12;13;14 channel must be skip).
   9) nvram: add BandSteering option.
   10) nvram: fix get bssid_num.
   11) defaults: temp set VHT_BW=20/40MHz for 7610NE, fix issue with some
   broadcom mobile clients.
   12) defaults: tune default QoS rates for currect performane limitts and
   ISP tarifs.
   13) init.d: fix DMZ regression.
   14) init.d: add /etc/ip(6)tables.d hooks (see readme for details).
   15) init.d: sw_qos: add shaper prio by DSCP in complex qos mode.
   16) goahead: unify reboot logic, reboot.sh use always and move to
   /etc/scripts.
   17) goahead: more russian translate fix.
   18) goahead: flush conntrack after apply ipport/mac filter rules for start
   work rules immediately.
   19) goahead: fix ipmacfilter default policy set.
   20) goahead: fix infinitive reboot wait after opmode switch.
   21) goahead: add popup reqest change dhcp settings at lan settings
   changed.
   22) goahead: send SIGUSR2 to udhcpc for ip release before reboot.
   23) goahead: add reboot after apcli changes apply (in SDK reboot to,
   drives issue?).
   24) goahead: add reboot counters at apply new mac and apply apcli changes.
   25) goahead: add DSCP prio values to qos page.
   26) goahead: add auto channel select (auto connect) to apcli page.
   27) kernel: up to 3.4.108 base version.
   28) kernel: ralink_hw_nat: add module param to control TTL.
   29) kernel: ralink_wifi: 7610: fix clean NDP announces.
   30) kernel: ralink_wifi: 7610: do not agregate low rate pkts.
   31) kernel: ralink_wifi: 7610: fix txburst in AC mode.
   32) kernel: ralink_wifi: 7610: apply 3.0.0.8 post pathces from MTK.
   33) kernel: ralink_wifi: 76x2: apply 3.0.3.2 post pathces from MTK.
   34) kernel: ralink_wifi: 76x2: add band steering options.
   35) kernel: ralink_wifi: xxxx: allow SNMP for all drivers.
   36) kernel: ralink_wifi: xxxx: fix bandsteering build.
   37) kernel: ralink_wifi: xxxx: move dyncvga and microwave oven detect
   support to MT***_AP_INTERFERENCE_REDUCE kernel options.
   38) kernel: ralink_wifi: xxxx: use macros from rt_linux.h for skb->tail
   manipulations instead of direct coding.
   39) kernel: ralink_raeth esw control: FCS bytes really not included to MIB
   counters.
   40) kernel: ralink_raeth esw control: add IOCTL to fetch port bytes.
   41) kernel: locking: Remove atomicy checks from {READ,WRITE}_ONCE.
   42) kernel: mips: Remove unnecessary platform dma helper functions.
   43) kernel: mips: O32/N32: Use compat getsockopt syscall.
   44) kernel: usb: cdc_ncm: add support for moving NDP to end of NCM frame.
   45) kernel: time: jiffies_delta_to_clock_t() helper to the rescue.
   46) kernel: pipe: iovec: fix memory corruption when retrying atomic copy
   as non-atomic (CVE-2015-1805).
   47) kernel: sched/rt: fix memory leak in alloc_rt_sched_group().
   48) kernel: stop using NLA_PUT*().
   49) kernel: netlink: Add nla_put_xx{16,32,64}() helpers.
   50) kernel: net: provide a default dev->ethtool_ops.
   51) kernel: net: force a list_del() in unregister_netdevice_many().
   52) kernel: net: packet: bail out of packet_snd() if L2 header creation
   fails.
   53) kernel: net: ax25: stop using sock->sk_protinfo.
   54) kernel: net: kill sock->sk_protinfo.
   55) kernel: net: remove extranous rcu_read_lock.
   56) kernel: net: ip_gre: fix possible use after free.
   57) kernel: net: ip_gre: remove unnecessary rcu_read_lock/unlock.
   58) kernel: net: netfilter: don't use module_init/exit in core IPV4 code.
   59) kernel: net: netfilter: remove ip_queue support.
   60) kernel: net: netfilter: use kfree_skb() not kfree().
   61) kernel: net: bridge: multicast: start querier timer when running
   user-space stp.
   62) kernel: net: bridge: multicast: restore router configuration on port
   link down/up.
   63) kernel: net: bridge: fix br_stp_set_bridge_priority race conditions.
   64) kernel: net: bridge: skip BROUTE hook if BRIDGE_EBT_BROUTE module is
   not enabled.
   65) kernel: net: bridge: fix broken ebtables on BRIDGE_NETFILTER disabled.
   66) kernel: net: bridge: netfilter: optimization by exclude unused
   modules.
   67) kernel: net: bridge: group bridge code closer with netcore and
   netfilter (improve performance).
   68) kernel: net: bridge: avoid OOPS if root port not found.
   69) kernel: net: bridge: disable softirqs around br_fdb_update to avoid
   lockup.
   70) kernel: net: fix race condition in several drivers when reading stats.
   71) kernel: net: tcp: shrink tcp6_timewait_sock by one cache line.
   72) kernel: net: tcp: fix get_timewait4_sock() delay computation on 64bit.
   73) kernel: net: tcp: remove redundant checks.
   74) kernel: net: flow_dissector: Pre-initialize ip_proto in
   __skb_flow_dissect().
   75) kernel: net: cleanup unsigned to unsigned int.
   76) kernel: net: inet: remove BUG_ON() in twsk_destructor().
   77) kernel: net: skb_defer_rx_timestamp should check for phydev before
   setting up classify.
   78) kernel: net: avoid gcc miss optimization regression in data rx path.
   79) kernel: net: ipv6: fix possible use after free of dev stats.

   3.3.x
   1) toolchain: apply some regressions fix backport to gcc, update headers.
   2) uclibc: nptl/allocatestack.c: fix stack mprotect alignment for
   STACK_GROWS_UP.
   3) uclibc: use position independent code for crt1, slightly red/uces size
   of all executables.
   4) uclibc: use gai.conf for configure compliant with RFC 3484 ipv4 prio
   for tunneled ipv6.
   5) nvram: add auto MacAddress set in dat files (not more need set as
   module param in init.d).
   6) nvram: fix Wireless mode in MBSSID generate to dat file.
   7) enable 802.11H and DFS support by default (need for sertifications test
   and more compat with apple products).
   8) add 802.1x wireless radius authentification support.
   9) add uqmi tool (need for dongle use qmi protocol).
   10) add hotspot mode support (basic CoovaChilli port version 1.3.1.3
   commit: Aug 19, 2015 1ef09b0).
   11) usb-modeswitch: up to 2.2.5 2015-07-16 version.
   12) miniupnpd: up to 1.9.20150721 version.
   13) dnsmasq: up to 2.75 version.
   14) dropbear: up to 2015.68 version.
   15) libpcap: up to 1.7.4 version.
   16) tcpdump: up to 4.7.4 version.
   17) libcurl: up to 7.44.0 version.
   18) xz: up to 5.2.1 version.
   19) libusb: up to 1.0.19 version.
   20) xl2tpd: sync with devel tree 12 Aug 2015 (commit 5674a58).
   21) xl2tpd: fix double free regression at death signal.
   22) xl2tpd: fix redial regression.
   23) init.d: make more safe and optimize stop vpn path.
   24) init.d: remove unneded delete generated by goahead scripts logic.
   25) init.d: do not need full disable rp_filter (use rp_filer=2 by
   default).
   26) init.d: scripts start, mkdevs and rcS split and use run-parts for
   start S* servies.
   27) init.d: wan: cleanup and fix zcip restart in some cases.
   28) init.d: qos: fix warnings with vpn mode enabled and small rearrange.
   29) init.d: do not touch all.forward sysctl from dhcp script.
   30) init.d: do not more need wait before start udhcpc.
   31) inif.d: iptables: v6: add rules for allow dnsmasq work as ipv6
   nameserver.
   32) init.d: fix vpn server work regression.
   33) init.d: fix wan restart in apcli_gw mode.
   34) init.d: fix xl2tp client/server restart infinity stop at some cases.
   35) igmpproxy: silence downstream interface igmp messages.
   36) igmpproxy: use monotic clock instead of time of day.
   37) igmpproxy: fix multiple downlink interfaces leave.
   38) igmpproxy: fix wifi snooping code to work with new drivers and use
   legacy oid header.
   39) goahead: fix rebuild some script.
   40) goahead: use 3600 secs as default rekey interval for new BSSIDs.
   41) goahead: add ipv6 interfaces adresses to statisctic page.
   42) goahead: show dgw interface name if dgw add over if without ip adress
   at next hop.
   43) goahead: snmp add allow request from WAN&LAN and community change.
   44) goahead: wireless securuty default select AES for all WPA modes.
   45) goahead: allow dhcpVendorClass set for DHCP client (need for IpTV work
   in some case at some ugly ISP).
   46) goahead: add hardware traffic counters from switch to WebUI.
   47) goahead: add basic fast roaming parametrs tune (only 76x2 drivers).
   48) goahead: add BandSteering option.
   49) goahead: add IEEE 802.11h option (enable 802.11h include DFS support).
   50) goahead: add: IGMP Fast Leave control option.
   51) kernel: ralink_nvram: fix nvram small lock imbalance.
   52) kenrel: ralink_mtd: add Micron MT29F1G08ABAEA (128MB) to MT7621 NAND
   table.
   53) kernel: ralink_arch: disable MT7621 PCIe clock if PCI not builded.
   54) kernel: ralink_arch: fix MT7621 sleep mode clock (1/4 on sleep, 4/4
   under load).
   55) kernel: ralink_arch: detect MT7628/MT7688 package type (AN/KN).
   56) kernel: ralink_wifi: 7620: apply post patches (dynvga BBP config fix).
   57) kernel: ralink_wifi: 76x2: update to 3.0.3.2_rev2.
   58) kernel: ralink_wifi: 76x2: fix rssi feedback work.
   59) kernel: ralink_wifi: 76x2: fix mt76x2_get_current_temp() periodic
   calls.
   60) kernel: ralink_wifi: 76x2: fix RSSI calculation on iLNA scheme
   61) kernel: ralink_wifi: 76x2: fix null pointer dereference in aplcli mode
   on SMP devices.
   62) kernel: ralink_wifi: 76x2: fix ie recived channel width at apcli
   connect process.
   63) kernel: ralink_wifi: 76x2: temporarily disable buggy QuickInitMCSRate
   RateCtrl algorithm (periodic drop to CCK issue).
   64) kernel: ralink_wifi: 7610: update to 3.0.0.9 version.
   65) kernel: ralink_wifi: 7610: do not agregate low rate pkts.
   66) kernel: ralink_wifi: 7610: fix compat with draft2 802.11ac
   specifications.
   67) kernel: ralink_wifi: 7610: fix txBurst operations with multiple
   clients connected.
   68) kernel: ralink_wifi: 7610: fix build channel list in 80Mhz mode.
   69) kernel: ralink_wifi: 7610: fix central channel select in DFS mode.
   70) kernel: ralink_wifi: 7610: remove bogus vht_sgi_80 check.
   71) kernel: ralink_wifi: 7610: backport autoselect channel fixes.
   72) kernel: ralink_wifi: xxxx: backport low traffic detect fix in rate
   alg.
   73) kernel: ralink_wifi: xxxx: move bandsteering options from driver code.
   74) kernel: ralink_wifi: xxxx: add max clients kernel options.
   75) kernel: ralink_wifi: xxxx: apply post mlme fixes.
   76) kernel: ralink_wifi: xxxx: fix country code for RU region (fix scan
   issue, allow active mode scan for all channel).
   77) kernel: ralink_wifi: xxxx: fix fallback to 20MHz in some cases.
   78) kernel: ralink_wifi: xxxx: fix mpdu default settings in some cases.
   79) kernel: ralink_wifi: xxxx: fix AP-Client reconnect issue on timeout
   Root-AP beacons (update last time on RX activity).
   80) kernel: ralink_wifi: xxxx: fix some potentional null pointer
   dereference.
   81) kernel: ralink_wifi: xxxx: fix ht_width set.
   82) kernel: ralink_wifi: xxxx: tune rate_ctl TrainUpHighThrd (110->100).
   83) kernel: ralink_wifi: xxxx: ability to obtain WDS and AP-Client
   connection info.
   84) kernel: ralink_wifi: xxxx: show correct AP-Client interface name.
   85) kernel: config: enable xt_match_time module build by default.
   86) kernel: sched/fair: fix RCU stall upon -ENOMEM in
   sched_create_group().
   87) kernel: mm: place preemption point in do_mlockall() loop.
   88) kernel: lib/int_sqrt.c: optimize square root algorithm.
   89) kernel: time: make *secs_to_jiffies static always inline (small
   optimize).
   90) kernel: irq: warn when shared interrupts do not match on NO_SUSPEND.
   91) kernel: mips: fix sched_getaffinity with MT FPAFF enabled.
   92) kenrel: mips: fix HIGHMEM crash in __update_cache().
   93) kernel: mips: fix cpu_has_mips_r2_exec_hazard.
   94) kernel: mips: make set_pte() SMP safe.
   95) kernel: mips: handle page faults of executable but unreadable pages.
   96) kernel: jump_label: rename JUMP_LABEL_{EN,DIS}ABLE to
   JUMP_LABEL_{JMP,NOP}.
   97) kenrel: jump_label: locking/static_keys: rename JUMP_LABEL_TYPE_* and
   related helpers to the static_key* pattern.
   98) kernel: jump_label: locking/static_keys: rework update logic.
   99) kernel: jump_label: add jump_entry_key() helper.
   100) kernel: jump_label: module: fix module locking.
   101) kernel: net: inet: frags: fix defragmented packet's IP header for
   af_packet.
   102) kernel: net: socket: fix the wrong returns for recvmsg and sendmsg.
   103) kernel: net: neigh: do not modify unlinked entries.
   104) kernel: net: avoid gcc miss optimization regression in data rx path.
   105) kernel: net: bridge: ability to fast isolation any port w/o ebtables.
   106) kernel: net: bridge: mcast: give fast leave precedence over multicast
   router and querier.
   107) kernel: net: do not process device backlog during unregistration.
   108) kernel: net: call rcu_read_lock early in process_backlog.
   109) kernel: net: clone skb before setting peeked flag.
   110) kernel: net: fq_codel: fix return value of fq_codel_drop().
   111) kernel: net: ppp: fix device unregistration upon netns deletion.
   112) kernel: net: fix skb_set_peeked use-after-free bug.
   113) kernel: net: fix race condition in store_rps_map.
   114) kernel: net: arp: fix a lockdep splat in arp_solicit().
   115) kernel: net: arp: fix a regression in arp_solicit().
   116) kernel: net: arp: inherit metadata dst when creating ARP requests.
   117) kernel: net: arp: remove special case to give AX25 it's open arp
   operations.
   118) kernel: net: arp: filter NOARP neighbours for SIOCGARP.
   119) kernel: net: tcp: don't abort splice() after small transfers.
   120) kernel: net: tcp: splice: fix an infinite loop in tcp_read_sock().
   121) kernel: net: tcp: remove obsolete check in tcp_set_skb_tso_segs().
   122) kernel: net: tcp: avoid merging segments on the OOO queue into a
   cloned SKB.
   123) kernel: net: tcp: tso: allow deferring under reordering state.
   124) kernel: net: tcp: fix recv with flags MSG_WAITALL | MSG_PEEK.
   125) kernel: net: tcp: allow segment with FIN in tcp_try_coalesce().
   126) kernel: net: ipv4: be more aggressive when probing alternative
   gateways.
   127) kernel: net: ipv4: fix NULL checking in devinet_ioctl().
   128) kernel: net: ipv6: lock socket in ip6_datagram_connect().
   129) kernel: net: ipv6: update flowi6_oif in ip6_dst_lookup_flow if not
   set.
   130) kernel: net: ipv6: flush and refresh nd cache on netdev_change change
   (as ipv4).
   131) kernel: net: ipv6: make ipv6_is_mld() inline and use it from
   ip6_mc_input().
   132) kernel: net: ipv6: make MLD packets to only be processed locally.
   133) kernel: net: ipv6: fix MLD Query message check.
   134) kernel: net: netfilter: ip[6]t_REJECT: fix wrong transport header
   pointer in TCP reset.
   135) kernel: net: netfilter: ip6t_REJECT: skip checksum verification for
   outgoing ipv6 packets.
   136) kenrel: net: netfilter: bridge: don't leak skb in error paths.
   137) kernel: net: packet: read num_members once in packet_rcv_fanout().
   138) kernel: net: packet: avoid out of bounds read in round robin fanout.
   139) kernel: backport new ASIX AX88179/178A and Realtek RTL8152/8153 USB
   3.0/2.0 Ethernet drivers.

   3.4.x
   1) build_system: add new metal 7620a+7612ne internal pa/lna sd usb
   16/128Mb sample.
   2) irqbalance: update to 04.08.2015 git version.
   3) init.d: fix path to passthrouth control files.
   4) init.d: hotplug support automount sd card if exist.
   5) init.d: add entware_install.sh script for fast install entware support
   to sd/hdd.
   6) kernel: ralink_mtd: sync MT7621/MT7628 SPI/NAND flash drivers with SDK
   5.0.0.0.
   7) kernel: ralink_raeth: code refactoring and sync with 5.0.0.0 SDK.
   8) kernel: ralink_arch: sync with SDK 5.0.0.0.
   9) kernel: ralink_arch: drop deprecated RTDEV_XXX params, use
   CONFIG_RT_FIRST_IF_XXX/CONFIG_RT_SECOND_IF_XXX to handle driver features.
   10) kernel: ralink_sdxc: fix MT7628 SDXC init.
   11) kernel: ralink_ppe: sync with 5.0.0.0 SDK.
   12) kernel: ralink_wifi: 7610: always set ldpc field to 0 in CAP_IE (7610
   not support LDCP).
   13) kernel: ralink_wifi: 7610: fix calculate rx amdsu size.
   14) kernel: ralink_wifi: 76x2: driver update to 3.0.4.0 universal
   (7620+7602+7612 chisp support) version.
   15) kernel: ralink_wifi: 76x2: fix microwave oven detect support.
   16) kernel: ralink_wifi: xxxx: fix mcs7 cap parse.
   17) kernel: ralink_wifi: xxxx: fix txring full in some cases(high noise
   level or if client lost connect).
   18) kernel: ralink_wifi: xxxx: prepare to full migrate to 3.0.4.0 for all
   7620 devices (now build new driver only for 7620A/7621+7612 devices).
   19) kernel: mips: do not need PERCPU_SECTION in vmlinux if not SMP kernel
   build.
   20) kernel: mips: uapi: fix unrecognized opcode WSBH/DSBH/DSHD when using
   MIPS16.
   21) kernel: net: skb_free_datagram_locked() doesnt drop all packets.
   22) kernel: net: bridge: multicast-to-unicast: fix echoes on STA.
   23) kernel: net: bridge: multicast-to-unicast: use src from original skb
   (not from clone).
   24) kernel: net: tcp: fix slow start after idle vs TSO/GSO.
   25) kernel: net: tcp: speedup SIOCINQ ioctl.
   26) kernel: net: igmp: inhibit reports for local multicast groups.
   27) kernel: net: add function to allocate sk_buff head without data area.
   28) kernel: net: fix sk_buff head without data area.
   29) kernel: net: sock_flag() cleanup.
   30) kernel: net: ping: prevent NULL pointer dereference on write to
   msg_name.
   31) kernel: net: ipv6: send NEWLINK on RA managed/otherconf changes.
   32) kernel: net: ipv4: don't report neigh uptodate state in rtcache
   procfs.
   33) kernel: net: implement ipv6 passthrouth logic.

   3.5.x
   1) build_system: add iappd demon for basic roaming support (disabled by
   default).
   2) build_system: rework defaults and rf calibs factory/backups install.
   3) build_system: rework link and install depended libs.
   4) kernel: up to 3.4.109 version.
   5) userapps: add nodogsplash (stabalone simple captive portal support
   commit dd8e4a6).
   6) defaults: add fast roaming and radio resource managment parametrs.
   7) defaults: enable WMM support by default (this long time ready for
   production).
   8) libusb: up to 1.0.20 version.
   9) coovachilli: up to version 1.3.1.3 commit: commit 7d86cd7).
   10) miniupnpd: up to 1.9.20150922 version.
   11) lldpd: up to 0.7.17 version.
   12) dropbear: generate host key only if reqest (speedup first boot and
   more security in some cases).
   13) iproute2: allow config l2tpip tunnels if configured in kernel.
   14) goahead: fix fast roaming extensions enable/disable options.
   15) goahead: add IDS parametrs to WebUI.
   16) goahead: review txmode set for new drivers notation.
   17) goahead: fix 80211.x start if server adress unset.
   18) goahead: fix wds configure.
   19) goahead: allow roaming extensions tune for all drivers.
   20) goahead: rework wds page.
   21) goahead: add type of QOS in webui (WAN/VPN/WAN+VPN).
   22) goahead: add EntryLifeCheck option (how pkts TX fail before connection
   drop, default 512).
   23) goahead: add tx beamforming parametrs.
   24) goahead: add irqbalance in WebUI.
   25) init.d: preconfigure igmpsnooping for all ports.
   26) init.d: add WdsNum variable and use in wds up interface code (no up
   unused wds ifaces).
   27) init.d: allow set dgw in bridge mode (for internet acess from AP).
   28) init.d: base shaper work in bridge mode.
   29) init.d: review complex qos logic for more fast and easy use.
   30) init.d: complex qos now auto limit maxrate for low prio tubes at
   90/80% of prio tube.
   31) kernel: configs: disable ralink QoS netfiler tables rearrange (break
   captive portals work).
   32) kernel: configs: enable IDS for all devices.
   33) kernel: configs: switch MT7620 to 76x2 driver for all devices.
   34) kernel: ralink_ppe: fix reset pre-bind register on MT7621/MT7623 with
   pre-bind enabled.
   35) kernel: ralink_wifi: 76x2: do not alloc skb buffers for unsupported
   second RX ring on MT7620 (save more RAM).
   36) kernel: ralink_wifi: 76x2: improve kick STA by low RSSI.
   37) kernel: ralink_wifi: 7620: fix HTMIX mode work if MBSSID enabled.
   38) kernel: ralink_wifi: xxxx: backport some actual for all fixes from v4
   driver.
   39) kernel: ralink_wifi: xxxx: fix modulation down to CCK in MBSSID mode
   regression.
   40) kernel: ralink_wifi: xxxx: port basic roaming optons support to all
   drivers.
   41) kernel: ralink_wifi: xxxx: fix uncorrect drop clietns in roma path if
   RTMPMaxRssi return 0.
   42) kernel: usb: usbnet: fix a race between usbnet_stop() and the BH.
   43) kernel: usb: net: qmi_wwan: Sierra Wireless MC73xx -> Sierra Wireless
   MC7304/MC7354.
   44) kernel: usb: qcserial: add HP lt4111 LTE/EV-DO/HSPA+ Gobi 4G Module.
   45) kernel: net: net_sched: sfq: put sfq_unlink in a do - while loop.
   46) kernel: net: net_sched: Pass the skb into change so it can access
   NETLINK_CB.
   47) kernel: net: net_sched: fix error return code in fw_change_attrs().
   48) kernel: net: net_sched: sch_htb: let skb->priority refer to non-leaf
   class.
   49) kernel: net: ipv6: ip6_fragment: fix headroom tests and skb leak.
   50) kernel: net: route: prevent oops.
   51) kernel: net: tcp_cubic: better follow cubic curve after idle period.
   52) kernel: net: fix crashes on pppoe disconnect/reconnect.
   53) kernel: ppp: fix lockdep splat in ppp_dev_uninit().

   3.6.x
   1) uboot: up to 5.0.0.3 version.
   2) busybox: update to 1.24.1 version.
   3) busybox: enable strings, tr and less applets.
   4) lldpd: up to 0.7.19 version.
   5) libcurl: up to 7.45.0 version.
   6) coovachilli: up to version 1.3.1.3 (commit: 0469a60e).
   7) nodogsplash: up to version 0.9 (commit: 1a9c0f).
   8) usb-modeswitch: up to 2.2.6 2015-11-01 version.
   9) xupnpd: up to 1.033 version commit 5c3ff1.
   10) xl2tpd: sync with devel tree 06 Nov 2015.
   11) miniupnpd: workaround issue with Windows 10 (UDA 2.0 devices and
   control points SHALL implement IPv4 and IPv6).
   12) miniupnpd: up to 1.9.20151118 version.
   13) wireless_tool: sync with internal x86 router tree.
   14) 802.1x: add support MediatekIE and small cleanup and add base syslog
   support.
   15) ralinkiappd: add basic support syslog.
   16) add netcwnmp - basic tr_069 agent support.
   17) busybox: allow user RPC, and add /etc/rpc for compat with classic
   distro apps.
   18) goahead: make delay rssi check before kick configurable.
   19) goahead: add chilispot/nodog configure and profiles for auth services.
   20) goahead: always set wan_static_dns to on in bridge mode.
   21) goahead: add signal qality calculation in station list.
   22) goahead: fix lost iptfilter default policy accept rule.
   23) goahead: review and fix all UI logic.
   24) defaults/goahead/init: remove RadioOff variable, diret use RadioOn
   instead.
   25) defaults: increase max clients to 56 for 7620 and to 72 for 7621 based
   AP.
   26) init.d: fix chillispot work (now work ok tested with
   hotspotsystem.com, commit 2a36dfd).
   27) init.d: udhpd add dhcpARPPTimeout options for conflict adresses check
   time tune.
   28) init.d: serialize network->services reconfigure scripts run.
   29) init.d: reset all port and restore defaults particion (workaround eee
   bug at some samples in AP bridge mode).
   30) init.d: fix mmc mount speed.
   31) init.d: iptables: rework ipv6 rules generate (more readable).
   32) init.d: refactoring checkconf logic.
   33) init.d: dyndns: for dnsafraid not need set and use DDNSAccount, only
   key in DDNSPassword used for login.
   34) init.d: checkconf: add workaround for stupids china engeeneers from
   fabric (WLAN macs must be individual to).
   35) init.d: fix M2U and snooping work in some modes and cases.
   36) init.d: do not reload wifi drivers every iterations.
   37) init.d: ralinkiappd: fix select interface for recive data.
   38) kernel: up to 3.4.110 version.
   39) kernel: ralink_ppe: fix FOE handle (AI=HIT_BIND_MULTICAST_TO_CPU with
   SP=6 on MT7620).
   40) kernel: ralink_spi: increase output driving strength to 50% for
   Winbond SPI flash chips.
   41) kernel: ralink_spi: fix calculate MT7621 SPI clock and update
   dividers.
   42) kernel: ralink_spi: cleanup SPI flash drivers, improve performance for
   4byte mode chips (>=32MB).
   43) kernel: ralink_arch: add two memory regions for MT7621 with 512M
   (Normal + Highmem).
   44) kernel: ralink_arch: fix MT7621 SYS_CLK calculation, show separated
   OCP/SYS frequency.
   45) kernel: ralink_arch: add MT7688 detection, expand MT7628/MT7688 CPU
   clock detection.
   46) kernel: ralink_raeth: add support MT7621/MT7530 GSW EPHY LED control.
   47) kernel: ralink_raeth: allow override MT7621/MT7530 GSW port forward
   mask.
   48) kernel: ralink_wifi: 76x2: driver update to 3.0.4.0.p1 universal
   (7620+7602+7612 chips support) version.
   49) kernel: ralink_wifi: 76x2: DRS_TX_QUALITY_WORST_BOUND set to 8 as all
   others (this mix rate at train down).
   50) kernel: ralink_wifi: 76x2: fix dynvga enable procedure.
   51) kernel: ralink_wifi: 76x2: decrease memory usage for Andes RX1 ring.
   52) kernel: ralink_wifi: 76x2: allways use mcs_0/6 for managment frames
   (depended by band) for compat.
   53) kernel: ralink_wifi: 76x2: enable 802.11K (radio resource managment by
   default).
   54) kernel: ralink_wifi: 76x2: 802.11k use channel power information form
   US table to RU region (need for work RRM).
   55) kernel: ralink_wifi: 76x2: assoc reqest packets - fix duplicated mgmt
   frame to host.
   56) kernel: ralink_wifi: xxxx: optimize reschedule Tx cleanup timer.
   57) kernel: ralink_wifi: xxxx: fix regression in APChkCls2Cls3Err
   implemented by shiang (3.0.0.x and later drivers).
   58) kernel: ralink_wifi: xxxx: kick sta at rssi low rework with avgRssi
   and RssiSample.
   59) kernel: ralink_wifi: xxxx: reject/ignore roaming parametrs now rework
   with average RSSI instead of max.
   60) kernel: ralink_wifi: xxxx: add configurable delay in kick STA by low
   RSSI (if in this interval all data frames have low rssi - kick STA).
   61) kernel: ralink_wifi: xxxx: fix potentional null pointer dereference in
   MlmeNewTxRate.
   62) kernel: ralink_wifi: xxxx: fix DROP_MASK race condition.
   63) kernel: ralink_wifi: xxxx: backport some fixes from 3.0.4.0.p1 to all.
   64) kernel: ralink_wifi: xxxx: allow set rates for multicast.
   65) kernel: ralink_wifi: xxxx: enable dfs,rrm support by default.
   66) kernel: ralink_wifi: xxxx: fix speed regression at multiclient aptune
   logic.
   67) kernel: ralink_wifi: xxxx: enable Clear-Channel Assessment (CCA)
   Monitor Support in test targets with new drivers.
   68) kernel: ralink_wifi: xxxx: fix very old CountryCode read from profile
   bug.
   69) kernel: ralink_wifi: xxxx: add correct regulatory table to Russia.
   70) kernel: ralink_wifi: xxxx: fix compath with 802.11d.
   71) kernel: ralink_wifi: xxxx: fix end enabled by default bss_qload
   (without alarm) for use in autochannel select and AP load annonse in
   beacons.
   72) kernel: ralink_wifi: xxxx: backport OID_802_DOT1X_QUERY_STA_AID ioctl
   support for full compath with new 802.1x daemon.
   73) kernel: ralink_wifi: xxxx: fix transit power setting in profile takes
   no effect.
   74) kernel: vfs: remove incorrect debugging WARN in prepend_path.
   75) kernel: jump label: remove static_branch().
   76) kernel: optimize net_get_random_once on CONFIG_JUMP_LABEL is not set.
   77) kernel: mm: make sendfile(2) killable.
   78) kernel: sd: clear PS bit before Mode Select.
   79) kernel: drivers/net: convert compare_ether_addr to ether_addr_equal.
   80) kernel: drivers/core: fix unregistration path of platform devices.
   81) kernel: mips: use ARCH_USE_BUILTIN_BSWAP.
   82) kernel: mips: vmlinux: discard .MIPS.abiflags.
   83) kernel: mips: fix PAGE_MASK definition.
   84) kernel: usb: xhci: follow upstream.
   85) kernel: usb: xhci: backports from 3.10 tree.
   86) kernel: usb: option: add ZTE PIDs.
   87) kernel: usb: core: update power budget for SuperSpeed.
   88) kernel: usb: asix: fix crash on skb alloc failure.
   89) kernel: net: initialize flow flags in input path.
   90) kernel: net: unix/caif: sk_socket can disappear when state is
   unlocked.
   91) kernel: net: ipip, sit: fix ipv4_update_pmtu calls.
   92) kernel: net: route: fix behaviour of unreachable, blackhole and
   prohibit routes.
   93) kernel: net: fix skb csum races when peeking.
   94) kernel: net: fib_rules: fix fib rule dumps across multiple.
   95) kernel: net: af_key: net: fix RCU splat.
   96) kernel: net: remove sk_init() helper.
   97) kernel: net: tcp: generate CA_EVENT_TX_START on data frames.
   98) kernel: net: xps: fix calculation of initial number of xps queues.
   99) kernel: net: avoid NULL deref in inet_ctl_sock_destroy().
   100) kernel: net: fix a race in dst_release().
   101) kernel: net: add dev_loopback_xmit() to avoid duplicate code.
   102) kernel: net: use skb_clone to avoid alloc_pages failure.
   103) kernel: net: netfilter: add SMB fastpath module.
   104) kernel: net: netfilter: ip[6]t_REJECT: tcp-reset using wrong MAC
   source if bridged.
   105) kernel: net: netfilter: incorrect hash calculation in some cases.
   106) kernel: net: ppp: fix pppoe_dev deletion condition in
   pppoe_release().
   107) kernel: net: ppp: slip: validate VJ compression slot parameters
   completely.
   108) kernel: net: ppp: don't set sk_state to PPPOX_ZOMBIE in
   pppoe_disc_rcv(), remove PPPOX_ZOMBIE socket state.
   109) kernel: net: neighbour: use source address of last enqueued packet
   for solicitation.
   110) kernel: net: neighbour: add mcast_resolicit to configure the number
   of multicast resolicitations in PROBE state.
   111) kenrel: net: af_packet: fix regression if pppd sends packets with
   only a header and no payload.
   112) kernel: net: af_packet: infer protocol from ethernet header if unset.
   113) kernel: net: af_packet: allow packets defragmentation not only for
   hash fanout type.
   114) kernel: net: af_inet: only check perm protocol when register proto.
   115) kernel: net: af_unix: return data from multiple SKBs on recv() with
   MSG_PEEK flag.
   116) kernel: net: af_unix: fix logic about sk_peek_offset.
   117) kernel: net: af_unix: do not report POLLOUT on listeners.
   118) kernel: net: ipv4/icmp: redirect messages can use the ingress daddr
   as source.
   119) kernel: net: ipv4/6: compute net once in some cases.
   120) kernel: net: ipv6: add RT6_LOOKUP_F_IFACE flag if oif is set.
   121) kernel: net: ipv6: dont add RT6_LOOKUP_F_IFACE flag if saddr set.
   122) kernel: net: ipv6: add labels for site-local and 6bone testing
   addresses (RFC6724).
   123) kernel: net: ipv6: add anti-spoofing checks for 6to4 and 6rd.
   124) kernel: net: ipv6: only apply anti-spoofing checks to not-pointopoint
   tunnels.
   125) kernel: net: ipv6: nat: do not drop DNATed 6to4/6rd packets.
   126) kernel: net: ipv6: remove redundant oif checks in rt6_device_match.
   127) kernel: net: ipv6: drop frames with attached skb->sk in forwarding.
   128) kernel: net: ipv6: protect mtu calculation of wrap-around and
   infinite loop by rounding issues.
   129) kernel: net: ipv6: recreate ipv6 link-local addresses when increasing
   MTU over IPV6_MIN_MTU.
   130) kernel: net: ipv6: fix a potential use after free in sit.c.
   131) kernel: net: ipv6: select fragment id during UFO segmentation if not
   set.
   132) kernel: net: ipv6: fix fragment id assignment on LE arches.
   133) kernel: net: ipv6: call ipv6_proxy_select_ident instead of
   ipv6_select_ident in udp6_ufo_fragment.
   134) kernel: net: ipv6: RTAX_FEATURE_ALLFRAG causes inefficient TCP
   segment sizing.
   135) kernel: net: ipv6: fix IPv6 UDP fragmentation issue.
   136) kernel: net: ipv6: nf_conntrack_ipv6: fix tracking of ICMPv6 error
   messages containing fragments.

   3.7.x
   1) uboot: add profile for ME2 7621 sample.
   2) toolchain: rebuild with current kernel headers.
   3) add 7621+7602+7612_USB_SD_SIM_16_512 metal sample support.
   4) defaults: allow greenfield mode by default.
   5) openssl up to 0.9.8zh version.
   6) coovachilli: up to version 1.3.1.3 (commit: 10a04da2).
   7) xl2tpd: sync with devel tree 26 Nov 2015.
   8) dropbear: up to 2015.70 version.
   9) irqbalance: update to 23.11.2015 git version.
   10) butcheck: set dir per gpio instead of all.
   11) dnsmasq: fix crash when empty address from DNS overlays A record from
   hosts.
   12) nodogsplash: fixed segfault in httpd_thread.c under high load (commit
   251e61db).
   13) xupnpd: move TTK-IPTV to feed and cleanup RTK-TV.
   14) goahead: remove private copy of wireless.h, now allways use system
   header.
   15) init.d: netfilter add ForwardSesLimit (use for limit forward sessions
   per user).
   16) init.d: do not disable logging in cooava chilli.
   17) init.d: chillispot - increase txqueuelen to 1000 and rcvbuf/sndbuf to
   128Kb (save ~5% cpu load).
   18) init.d: kext - add Lan2Wifi isolate mode, isolate LAN network
   resourses for WLAN user, allow only internet use.
   19) init.d: fix ports physmode set regression.
   20) init.d: add one rgmii mode support for MT7621.
   21) kernel: ralink_arch: i2c busses: add support MT7621 and MT7628.
   22) kernel: ralink_ppe: allow dynamic set FoE 64/80b in runtime, use FoE
   80b only IPv6 offload enabled.
   23) kernel: ralink_wifi: xxxx: prevent little/big endian issue. and let
   asic_write_bcn_buf() handle it.
   24) kernel: ralink_wifi: xxxx: fix potentional null pointer dereference.
   25) kernel: ralink_wifi: xxxx: Mpdu Density all time must be > 0.
   26) kernel: ralink_wifi: xxxx: HT green AP operation support all >=2T2R
   chips at not depend from GREENAP_SUPPORT config option.
   27) kernel: ralink_wifi: 76x2: small fix WDS.
   28) kernel: ralink_gpio: cleanup and small fixup.
   29) kernel: ralink_gpio: switch JTAG and GE2 (if not support) to GPIO
   mode.
   30) kernel: div64.h: optimize divide operations.
   31) kernel: exfat: upstream updates.
   32) kernel: devres: fix a for loop bounds check.
   33) kernel: mtd: blkdevs: fix potential deadlock + lockdep warnings.
   34) kernel: ipc,sem: fix use after free on IPC_RMID after a task using
   same semaphore set exits.
   35) kernel: splice: sendfile() at once fails for big files.
   36) kernel: vfs: avoid softlockups with sendfile(2).
   37) kernel: vfs: make sendfile(2) killable even better.
   38) kernel: usb: add new devives support to serial drivers.
   39) kernel: usb: MT7621 xHCI: fix memory leak, add losted workarounds from
   MTK SDK.
   40) kernel: usb: option: add support TS-UM6602 modem (aka MOTIV 4G).
   41) kernel: mips: revert: make CAC_ADDR and UNCAC_ADDR account for
   PHYS_OFFSET.
   42) kernel: mips: revert: adjust mips highmem offset to avoid the need for
   -mlong-calls on systems with >256M RAM.
   44) kernel: mips: revert: fix race condition in lazy cache flushing.
   45) kernel: mips: fix work highmem at 7621 samples.
   46) kernel: mips: fix highmem crash in __update_cache.
   47) kernel: mips: autodetect memsize not support high memory (limit detect
   to 448Mb on mips boards).
   48) kenrel: mips: allow long calls on highmem support builds.
   49) kernel: net: add length argument to skb_copy_and_csum_datagram_iovec.
   50) kernel: net: neighbour: fix crash at dumping device-agnostic proxy
   entries.
   51) kernel: net: increase conntrack size depend by ram_size.
   52) kernel: net: tunnel: implement 64 bits statistics.
   53) kernel: net: fq_codel: fix cpu load with higher speed.
   54) kernel: net: tcp: initialize tp->copied_seq in case of cross SYN
   connection.
   55) kernel: net: tcp: connect() from bound sockets can be faster.
   56) kernel: net: ipv4: igmp: allow removing groups from a removed
   interface.
   57) kernel: net: ipmr: fix static mfc/dev leaks on table destruction.
   58) kernel: net: ipmr: fix possible race resulting from improper usage of
   IP_INC_STATS_BH() in preemptible context.
   59) kernel: net: ipmr, ip6mr: fix vif/tunnel failure race condition.
   60) kernel: net: ipv6: fix tunnel error handling.
   61) kernel: net: ipv6: fix the use of pcpu_tstats in ip6_tunnel.
   62) kernel: net: packet: allow to transmit +4 byte in TX_RING slot for
   VLAN case.
   63) kernel: net: packet: tpacket_snd(): fix signed/unsigned comparison.
   64) kernel: net: packet: only allow extra vlan len on ethernet devices.
   65) kernel: net: packet: fix tpacket_snd max frame len.
   66) kernel: net: packet: fixed TPACKET V3 to signal poll when block is
   closed rather than every packet.
   67) kernel: net: packet: don't pass empty blocks for PACKET_V3.

   3.8.x
   1) uboot: up to 5.0.0.4 version.
   2) miniupnpd: up to 1.9.20151212 version.
   3) coovachilli: up to version 1.3.1.3 (commit: f5dd12b8).
   4) xupnpd: up to 1.034 version commit 97b8a7ef (use old style ui).
   5) xupnpd: fix feeds for INSIS and CONVEX ISPs.
   6) init.d: fix double vlan tag support.
   7) init.d: if Lan2Wifi isolate and MBSSID isolate mode - enable full
   isolate MBSSID interfaces in bridge.
   8) init.d: add support VLAN isolated GW to AP`s/ZONE support (isolated
   vlans for LAN in router mode and recive vlans for internet in AP mode).
   9) init.d: refactoring VLAN for TV/SIP ports (split linked to esw vlans,
   bridge create and WAN/LAN vlans).
   10) init.d: vlan isolate use vids list instead one value for all, more
   flexible.
   11) kernel: ralink_arch: disable NAND, SDXC, SPDIF when unused (more power
   save).
   12) kernel: ralink_arch: SDXC: add power control, decrease debug.
   13) kernel: ralink_raeth: temp disable recive checksumm offload in MT7621
   (break mroute).
   14) kernel: devres: fix devres_get().
   15) kernel: sched/core: remove false-positive warning from
   wake_up_process().
   16) kernel: sched/core: clear the root_domain cpumasks in
   init_rootdomain().
   17) kernel: fuse: break infinite loop in fuse_fill_write_pages().
   18) kernel: usblp: do not set TASK_INTERRUPTIBLE before lock.
   19) kernel: ubi: fix use of "VID" vs. "EC" in header self-check.
   20) kernel: ubi: fix return error code.
   21) kernel: usb: fix invalid memory access in hub_activate().
   22) kernel: usb: xhci: fix config fail of FS hub behind a HS hub with MTT.
   23) kernel: usb: use the USB_SS_MULT() macro to decode burst multiplier
   for log message.
   24) kernel: net: remove martian_source_keep_err goto label.
   25) kernel: net: cdc_mbim: add "NDP to end" quirk for Huawei E3372.
   26) kernel: net: usb: cdc_ncm: Adding Dell DW5812 LTE Verizon/DW5813 LTE
   AT&T Mobile Broadband Card.
   27) kernel: net: qmi_wwan: MDM9x30 specific power management.
   28) kernel: net: qmi_wwan: remove 1199:9070 device id.
   29) kernel: net: qmi_wwan: support "raw IP" mode.
   30) kernel: net: qmi_wwan: ignore bogus CDC Union descriptors.
   31) kernel: net: add validation for the socket syscall protocol argument.
   32) kernel: net: tunnels: improve implement 64 bits statistics.
   33) kernel: net: tun: honor IFF_UP in tun_get_user().
   34) kernel: net: ppp: define "ppp" device type.
   35) kernel: net: pppoe: fix memory corruption in padt work structure.
   36) kernel: net: pppox: use standard module auto-loading feature.
   37) kernel: net: pptp: verify sockaddr_len in pptp_bind() and
   pptp_connect().
   38) kernel: net: ipv6: restrict hop_limit sysctl setting to range [1;
   255].
   39) kernel: net: ipv6: only act upon NETDEV_*_TYPE_CHANGE if we have ipv6
   addresses.
   40) kernel: net: sit: hide noisy 6to4/6rd spoofing warnings.
   41) kernel: net: af_unix: avoid use-after-free in ep_remove_wait_queue.
   42) kernel: net: af_packet: fix match_fanout_group().
   43) kernel: net: fix __netdev_update_features return on ndo_set_features
   failure.
   44) kernel: net: scm: fix PaX detected msg_controllen overflow in
   scm_detach_fds.
   45) kernel: net: snmp: Remove duplicate OUTMCAST stat increment.
   46) kernel: net: ip6mr: call del_timer_sync() in ip6mr_free_table().
   47) kernel: net: fix regression in short UDP reads caused by "net: Fix skb
   csum races when peeking".
   48) kernel: net: revert "net: add length argument to
   skb_copy_and_csum_datagram_iovec".
   49) kernel: net: udp: properly support MSG_PEEK with truncated buffers.

   3.9.x
   1) toolchain: sync uclibc patches and kernel headers.
   2) build_system: add qdma tool (need for hw_qos support in future).
   3) build_system: cleanup supported libs in config.arch.
   4) build_system: use mtune=1004kc for MT7621.
   5) build_system: do not remove hotspot.asp if nodogsplash build without
   chillispot.
   6) uboot: add UART baud rate 115200/57600 configuration.
   7) uclibc: mips: switch float_t to float.
   8) dropbear: up to 2015.71 version.
   9) dropbear: small revert fix regression break work in inetd mode.
   10) dropbear: add force proto famaly set (IPv4/6).
   11) dropbear: fix signature check.
   12) dropbear: increase kex hash cache size.
   13) dropbear: allow 3des,rsa,ecdsa,ecdh for compat.
   14) wide-dhcpv6: fix bind control socket error handle.
   15) miniupnpd: up to 1.9.20160209 version.
   16) iptables: some upstream backports.
   17) coovachilli: up to version 1.3.1.3 (commit: dd05c1b3).
   18) ethtool: up to 4.2 version.
   19) lldpd: up to 0.9.0 version.
   20) libcurl: up to 7.47.0 version.
   21) irqbalance: update to 16.12.2015 git version.
   22) xl2tpd: avoid problems with bad avp lengths.
   23) usb-modeswitch: up to 2.3.0 version.
   24) radvd: up to 2.12 version.
   25) dnsmasq: up to 2.76test8 version.
   26) pppd: rp-pppoe: update to 3.12 version.
   27) pppd: libpptp: small fix and cleanup.
   28) xl2tpd: fix #98 by checking if a valid PID is being killed.
   29) busybox: truncate: always set mode when opening file to avoid fortify
   errors.
   30) goahead: add wifisystem.ru profile in hotspot page.
   31) goahead: add show function name to all error messages.
   32) goahead: fix crash at long time port status view.
   33) goahead: fix error handle in read data from ethool over pipe.
   34) goahead: fix potentional division by zero in get cpu usage and
   put_ulong code.
   35) goahead: fix potentional null pointer dereferens in isdigit,
   getSysDateTime, getMaxVol and get_LANAUTHState.
   36) goahead: rewrite get cpu, mem usage code more safe and readable.
   37) goahead: allways use doSystem() instead off call system() in exec sh
   scripts.
   38) goahead: rewrite getAllNICStatisticASP for safe and readable.
   39) goahead: use more safe strncpy instead of strcpy in ioctl reqests.
   40) goahead: remove dead getIfLive, getIfLiveWeb, getIfIsUpWeb and
   getLanIfNameWeb, getField.
   41) goahead: log errors to syslog for easy debug.
   42) goahead: fix system and internal syslog functions conflict.
   43) goahead: ignore USR1,USR2,HUP signals.
   44) goahead: rewrite getPortStatus function for direct get data from
   kernel ethtool via ioctl.
   45) goahead: cleanup req struct before ioctl use.
   46) goahead: disable balloc use for MT7621 (balloc not multithread safe).
   47) goahead: fix varios crashes.
   48) goahead: rewrite scale bytes to multipliers names (more safe and
   standart strong output).
   49) goahead: add auto daemonize at start support.
   50) goahead: add restore mode without call full reinit if pid file exist
   (need for quiet restart).
   51) goahead: add -h/r/f command line arguments for
   help/restore/foreground.
   52) goahead: ipv6 page fix reset to defaults.
   53) goahead: use tcp_nodelay for root socket.
   54) switch: add support egress tag/untag.
   55) libnvram: add nvram_fromdef function for load selected value from
   defaults to nvram.
   56) libnvram: remove nvram_buf_get function, allways read from nvram_get
   allrady buffered.
   57) init.d: vpnserver: remove unneded second dgw to clients network
   (unused).
   58) init.d: config-vlan: fix portmap mask for esw in one RGMII mode.
   59) init.d: config-vlan: skip port 5 from config not used and linkdown.
   60) init.d: do not turn off vpn client in irmware update case.
   61) init.d: rename wifi_unload.sh to unload_all.sh, review and cleanup.
   62) init.d: remove unneded chilli_dynip param (fix chilli dhcp ip pool
   range).
   63) init.d: allow print some minimal information about userspace segfaults
   to the kernel console.
   64) kernel: ralink_raeth: switch to qdma for MT7621.
   65) kernel: ralink_raeth: fetch MT7621/MT7530 PauseFrame MIB counters.
   66) kernel: ralink_raeth: add MT7628 switch control API.
   67) kernel: ralink_raeth: add support MT762x/MT7530 per-VLAN untag.
   68) kernel: ralink_raeth: MT7620 rev 0204 has CDM bug too (workload tests
   FAILED).
   69) kernel: ralink_sdxc: fix MT7621 unstable write issue and cleanup.
   70) kernel: ralink_sdxc: set sample crc by clock falling edge.
   71) kernel: mips: fix bitrot in __get_user_unaligned().
   72) kernel: mips: sync-r4k: reduce skew while synchronization.
   73) kernel: mips: rewrite csum_fold to plain C.
   74) kernel: mips: changed current_thread_info() to an equivalent supported
   by both clang and GCC.
   75) kernel: mips: spinlock: Adjust arch_spin_lock back-off time.
   76) kernel: mips: fall back to generic implementation of cmpxchg64 on
   32-bit platforms.
   77) kernel: mips: remove a temporary hack for debugging cache flushes in
   SMTC configuration.
   78) kernel: mips: call find_vma with the mmap_sem held.
   79) kernel: mips: ensure FCSR cause bits are clear after invoking FPU
   emulator.
   80) kernel: mips: mm: add debug information for userland SIGSEGV signals.
   81) kernel: mips: fix race condition in lazy cache flushing.
   82) kernel: mips: smp-cmp: remove incorrect core number probe.
   83) kernel: mips: disable MIPS_MT_FPAFF and clean up resume declaration.
   84) kernel: driver-core: move kobj_to_dev from genhd.h to device.h.
   85) kernel: driver-core: use kobj_to_dev instead of re-implementing it.
   86) kernel: crypto: skcipher - copy iv from desc even for 0-len walks.
   87) kernel: mmc: upstream updates.
   88) kernel: err.h: add (missing) unlikely() to IS_ERR_OR_NULL().
   89) kernel: err.h: allow IS_ERR_VALUE to handle properly more types.
   90) kernel: tty: fix GPF in flush_to_ldisc().
   91) kernel: tty: n_tty: fix SIGIO for output.
   92) kernel: usb-storage: update unusual_devs from upstream.
   93) kernel: usb-storage: add quirk for mandatory READ_CAPACITY_16.
   94) kernel: usb_usual: fix US_FL_BROKEN_FUA flag before upstream commit
   'usb: remove libusual', it masked by USB_US_ORIG_FLAGS.
   95) kernel: usb_usual: expand JMicron quirk US_FL_BROKEN_FUA to rev 1.17.
   96) kernel: usb: serial: option: fix Cinterion AHxx enumeration.
   97) kernel: usb: serial: option: adding support for Telit LE922.
   98) kernel: usb: serial: cdc_acm: ignore Infineon Flash Loader utility,
   exclude Samsung phone 04e8:685d.
   99) kernel: usb: serial: cdc-acm: add support for Denso cradle CU-321.
   100) kernel: usb: serial: cdc-acm: send zero packet for intel 7260 modem.
   101) kernel: usb: serial: cdc-acm: kill unnecessary messages.
   102) kernel: net: packet: don't check frames_per_block against negative
   values.
   103) kernel: net: change pseudohdr argument of inet_proto_csum_replace* to
   be a bool.
   104) kernel: net: simplify napi_synchronize() to avoid warnings.
   105) kernel: net: cdc_ncm: avoid changing RX/TX buffers on MTU changes.
   106) kernel: net: add scheduling point in recvmmsg/sendmmsg.
   107) kernel: net: possible use after free in dst_release.
   108) kernel: net: bridge: use kobj_to_dev instead of to_dev.
   109) kernel: net: pptp: fix illegal memory access caused by multiple
   bind()s.
   110) kernel: net: netfilter: xt_TCPMSS: handle CHECKSUM_COMPLETE in
   tcpmss_tg6().
   111) kernel: net: sched: drr: check for NULL pointer in drr_dequeue.
   112) kernel: net: inet: frag: always orphan skbs inside ip_defrag().
   113) kernel: net: qmi_wwan: add WeTelecom-WPD600N.
   114) kernel: net: qmi_wwan: add SIMCom 7230E.
   115) kernel: net: core: revert net: fix__netdev_update_features return and
   add comment.
   116) kernel: net: ipv6: addrlabel: fix ip6addrlbl_get().
   117) kernel: net: ipv6: honor ifindex in case we receive ll addresses in
   router advertisements.
   118) kernel: net: ipv6: update skb->csum when CE mark is propagated.
   119) kernel: net: ipv6: always add flag an address that failed DAD with
   DADFAILED.
   120) kernel: net: ipv6: keep existing flags when setting IFA_F_OPTIMISTIC.
   121) kernel: net: ipv6: fib6: install fib6 ops in the last step.
   122) kernel: net: ipv6: fix the incorrect return value of throw route.
   123) kernel: net: ipv6: udp: use sticky pktinfo egress ifindex on
   connect() (RFC 3542 section 6.7).
   124) kernel: net: ipv6: proc: fix error handling.
   125) kernel: net: ipv4: no CHECKSUM_PARTIAL on MSG_MORE corked sockets.
   126) kernel: net: ipv4: revert 'ipv4/icmp: redirect messages can use the
   ingress daddr as source'.
   127) kernel: proc: return -ENOMEM when inode allocation failed.
   128) kernel: proc: no need to initialize proc_inode->fd in
   proc_get_inode().
   129) kernel: proc: check vma->vm_file before dereferencing.
   130) kernel: proc: don't show nonexistent capabilities.
   131) kernel: proc: fix inconsistent lock state.
   132) kernel: proc: allow proc_free_inum to be called from any context.
   133) kernel: proc: make proc_fd_permission() thread-friendly.
   134) kernel: proc: fix the potential use-after-free in first_tid().
   135) kernel: mm: do not invoke OOM killer on kernel fault OOM.
   136) kernel: mm: account the total_vm in the vm_stat_account().
   137) kernel: mm: fix potential anon_vma locking issue in mprotect().
   138) kernel: mm: count the number of pages affected in
   change_protection().
   139) kernel: mm: optimize the TLB flush of sys_mprotect() and
   change_protection() users.
   140) kernel: mm: account for a THP NUMA hinting update as one PTE update.
   141) kernel: mm: do not flush TLB during protection change if !pte_present
   && !migration_entry.

   4.0.x
   1) project: sync with 5.0.1.0 SDK.
   2) uboot: up to 5.0.0.5 version.
   3) build_system: add strace v4.11 for easy debug.
   4) lldpd: up to 0.9.1 version.
   5) uclibc: enable relro,now,noexecstack options.
   6) switch: fix signed integer overflow for expressions.
   7) wide-dhcpv6, cpdtool, igmpproxy, lldt, pppd, xupnpd, udpxy, samba,
   p910nd fix some issues found by cppcheck.
   8) dnsmasq: up to 2.76test12 version.
   9) miniupnpd: up to 1.9.20160222 version.
   10) xl2tpd: sync with devel tree 10 Mar 2016.
   11) xupnpd: generic plugin fix.
   12) bndstrg: add daemon and init for support bandsteering.
   13) utils: switch: show ports PVID and matrix.
   14) system: add remote managment user for ISP device managment.
   15) goahead: fix types convert in value.
   16) goahead: replace min/max macros to new with type check.
   17) goahead: fix potentional data corrupt in socketWrite/Read.
   18) goahead: fix 64-bit js functions.
   19) goahead: fix sanity buffsizes.
   20) goahead: check data size before send.
   21) goahead: fix some errore find by cppcheck analizer.
   22) goahead: fix dhcp ip range calc on lan ip change.
   23) goahead: fix potentional crash at url decode.
   24) goahead: fix potentional use after free.
   25) goahead: fix uncorecrt socket reuse in socketSelect.
   26) goahead: cleanup socket code, remove unused flags and type of sockets.
   27) goahead: implement socket reservice for correct connection reuse.
   28) goahead: cleanup and refactoring sockets alloc logic.
   29) goahead: zero mem at first heap allocate.
   30) goahead: remove dead unicode code.
   31) init.d: irqbalance skip ipi irq`s.
   32) init.d: add support wlan2vlan over LAN/WAN bridges.
   33) init.d: rename LANVlans to VlanLan and LANVlansIsolate to
   VlanLanIsolate variables, for name consistent.
   34) init.d: add restart goahead if unexpected stopped (temp workaround for
   MIPS_MT_SMP).
   35) init.d: fix vlan with vid > 6 issue, add vlan map to 7620.
   36) init.d: fix vlan hw2sw mode switch.
   37) init.d: start band steering daemon only if SSID1=SSID1INIC.
   38) kernel: ralink_arch: rework memautodetect in mt7621 case.
   39) kernel: ralink_arch: more power save on unused MT7621 PCIe PHY.
   40) kernel: ralink_arch: tune MT7621 PCIe PHY SSC (Spread Spectrum) to
   reduce interference.
   41) kernel: ralink_arch: hardcode MT7621 GIC IPI offsets as U-Boot. VPE0
   always 56 and 60 (for MT7621S too).
   42) kernel: ralink_nvram: make nvram driver SMP safe.
   43) kernel: ralink_gpio: fix mt7621 gpio disable interrupts.
   44) kernel: ralink_wifi: sync with mt7612e_20160219 version driver.
   45) kernel: ralink_wifi: tune band steering timeouts (fix very long time
   wait connect at one band clients).
   46) kernel: ralink_wifi: mt7620 driver fix build band steering support.
   47) kernel: ralink_wifi: backport band_steering support from mt76x2 driver
   to mt7620 and mt7610 drivers.
   48) kernel: ralink_wifi: mt76x2 allow VgaClamp control to 5GHz.
   49) kernel: ralink_raeth: switch_control: fix calculate untag VID from
   unused rules.
   50) kernel: ralink_raeth: switch_control: allow set isolation mode
   concurrent with vlan filtering.
   51) kernel: ralink_raeth: switch_control: support reset MIB couters for
   MT7620/MT7628 ESW.
   52) kernel: ralink_raeth: switch_control: move MAC control functions to
   appropriate modules.
   53) kernel: ralink_raeth: switch_control: add support software mode
   IGMP/MLD snooping, add configure selector.
   54) kernel: ralink_raeth: switch_control: add support up to 6 Eth ports,
   code refactoring, update IOCTL table.
   55) kernel: ralink_raeth: switch_control: add support control concurrent
   with MT7621 MCM.
   56) kernel: ralink_raeth: improve external GPHY support, add support
   Realtek RTL8211 GPHY family.
   57) kernel: ralink_raeth: fix MT7621 with GE2 to external GPHY case.
   58) kernel: ralink_raeth: fix MT7620 with P5 to external GPHY case.
   59) kernel: ralink_raeth: use special hook to notify ESW/GSW port link
   changed.
   60) kernel: ralink_raeth: add support swap GDMA1<->GDMA2 ports on
   RT3883/MT7621.
   61) kernel: ralink_raeth: fix update VLAN dev features.
   62) kernel: ralink_raeth: fix autopoll external EPHY on MT7620.
   63) kernel: ralink_raeth: fix coherentio (corrupt last 2 bytes on 1536
   bytes real data received) on MT7620/MT7621.
   64) kernel: ralink_raeth: QDMA: add 4 reserved buffers for all QDMA pipes,
   increase QDMA SW pool.
   65) kernel: mm/highmem: reimplement make kmap cache coloring aware.
   66) kernel: kernel-wide: fix missing validations on
   __get/__put/__copy_to/__copy_from_user().
   67) kernel: usb: qmi_wwan: add 4G LTE usb-modem U901, add Dell Wireless
   5809e Gobi 4G HSPA+ Mobile Broadband Card (rev3).
   68) kernel: usb: serial: option: add support for Telit LE922 PID 0x1045,
   add support for Quectel UC20.
   69) kernel: usb: xhci: fix list corruption in urb dequeue at host removal.
   70) kernel: smp: make smp_call_function_many() use logic similar to
   smp_call_function_single().
   71) kernel: smp: remove cpumask_ipi.
   72) kernel: mips: highmem: turn flush_cache_kmaps into a no-op.
   73) kernel: mips: fix use highmem without long calls.
   74) kernel: mips: rework core number correction.
   75) kernel: mips: fix 64k page support for 32 bit kernels.
   76) kernel: mips: fix FPU disable with preemption.
   77) kernel: mips: remove memset/memcpy prefetch hack (may be not safe in
   SMP).
   78) kernel: mips: fix get_user_page_fast() for mips with cache alias.
   79) kernel: mips: smp: remove call to ipi_call_lock()/ipi_call_unlock().
   80) kernel: mips: smp: kill redundant call of
   generic_smp_call_function_single_interrupt().
   81) kernel: mips: smp: don't increment irq_count multiple times for call
   function IPIs.
   82) kernel: mips: smp: fix uninitialised temp_foreign_map.
   83) kernel: mips: revert ensure FCSR cause bits are clear after invoking
   FPU emulator.
   84) kernel: mips: fix obsolete cpumask_of_cpu usage.
   85) kernel: mips: support CPU topology files in sysfs.
   86) kernel: mips: c-r4k: fix cache flushing for MT cores.
   87) kernel: mips: scache: fix scache init with invalid line size.
   88) kernel: math-emu: fix floating-point to integer unsigned saturation.
   89) kernel: math-emu: fix floating-point to integer overflow detection.
   90) kernel: net: use new condition when both GMAC's of RT3883/MT7621 is
   really used.
   91) kernel: net: compat: fix minor information leak in
   siocdevprivate_ioctl().
   92) kernel: net: ppp: clarify parsing of user supplied data in
   ppp_set_compress().
   93) kernel: net: ppp: release rtnl mutex when interface creation fails.
   94) kernel: net: pppoe: fix reference counting in PPPoE proxy.
   95) kernel: net: af_unix: don't set err in unix_stream_read_generic unless
   there was an error.
   96) kernel: net: af_unix: guard against other == sk in unix_dgram_sendmsg.
   97) kernel: net: socket: get_empty_filp()/alloc_file() leave both ->f_pos
   and ->f_version zero.
   98) kernel: net: socket: sock_close() couldn't have been called with NULL
   inode since at least 2.1.early.
   99) kernel: net: socket: use SYSCALL_DEFINEx for sys_recv.
   100) kernel: net: vlan: turn on unicast filtering on vlan device.
   101) kernel: net: ipv4: only create late gso-skb if skb is already set up
   with CHECKSUM_PARTIAL.

   4.1.x
   1) kernel: up to 3.4.111 LTS version.
   2) coovachilli: bstring: sync with git 13.03.2016 (commit ec15981d).
   3) dropbear: up to 2016.72 version.
   4) quagga: up to 1.0.20160315 version.
   5) ntfs-3g: up to 2016.2.22 version.
   6) lldpd: up to 0.9.2 version.
   7) libcurl: up to 7.48.0 version.
   8) busybox: update to 1.24.2 version and apply post patches.
   9) xl2tpd: sync with devel tree 01 Apr 2016 (1.3.7 version).
   10) netcwnmp: rewrite for support cwmp 1.0.0 (tested with
   acs-test_1.0.14.01_amd64).
   11) libnvram: always use safe version of free.
   12) busybox: udhcpd: keep expired leases at startup.
   13) system: enable ripd support (fixed in last quagga).
   14) utils: switch: fix dump on switch workload.
   15) init.d: shaper prio fix regression (do not use dst hash in sfq with
   root priomap class).
   16) init.d: iptables: prevent allow forward for all at portmap enable
   without NAT enabled.
   17) init.d: portforward allow forward packets only for needed ports and
   ip, if nat enabled and portforward rules really generate.
   18) init.d: rewrite select SNAT/MASQRADE NAT mode (default allways try use
   SNAT).
   19) init.d: move l2tp server form S to W runlevel for correct restart
   after apply new changes.
   20) goahead: allways use free verions of free/bfree.
   21) goahead: fix b_stats debugging option work.
   22) goahead: more safe internal strdup implementation.
   23) goahead: generate /etc/portforward_access for forward allow only for
   needed ip of portforward activate.
   24) kernel: ralink_arch: fix build without pci-e port2 enabled (tube
   sample).
   25) kernel: ralink_arch: move MT7621 GIC interrupts to base 8 (do not
   overlap with MIPS 0..7). Prepare to GIC timer support.
   26) kernel: ralink_arch: MT7621: add support vectored interrupts.
   27) kernel: ralink_arch: add CLKSRC_MIPS_GIC param for MT7621 and enable
   GIC timer by default.
   28) kernel: ralink_arch: irq-legacy: fix broken masked MIPS c0_status on
   Timer, FE, PCIe, WLAN irq.
   29) kernel: ralink_arch: irq-legacy: use chained interrupts for INTC
   HW0/HW1 lines.
   30) kernel: ralink_arch: irq-legacy: route time-critical INTC interrupts
   to MIPS HW1 (IP3) interrupt line with higher priority.
   31) kernel: ralink_arch: fix R2P IRQ description on GIC map.
   32) kernel: ralink_raeth: apply GRO changes for our 3.4 tree.
   33) kernel: ralink_raeth: disable VLAN Leaky on TO_CPU operations, enable
   CPU port for MT7621/MT7530 GSW.
   34) kernel: ralink_raeth: switch control: improve SW IGMP/MLD logic, allow
   fast leave for used groups.
   35) kernel: ralink_raeth: switch control: disable forcing IGMP/MLD TO_CPU
   for 2xGMAC case (fix IPTV regression).
   36) kernel: ralink_wifi: do not hardcode RBUS irq.
   37) kernel: bitops: do not default to __clear_bit() for
   __clear_bit_unlock().
   38) kernel: force inlining of buffer head flag operations
   inbufferhead,swab,unaligned,atomic-long.h,page-flags.h (fix new gcc issue)
   39) kernel: add cryptodev-linux driver 1.8 (http://cryptodev-linux.org).
   40) kernel: add AES Engine driver for MT7628 (fully code refactoring).
   41) kernel: pipe: Fix buffer offset after partially failed read.
   42) kernel: mips: traps: fix SIGFPE information leak from `do_ov' and
   `do_trap_or_bp'.
   43) kernel: mips: c-r4k: reapply fix cache flushing for MT cores.
   44) kernel: mips: cache flush functions are reworked.
   45) kernel: mips: fix bug in using flush_cache_vunmap.
   46) kernel: mips: new GIC clocksource. Add new GIC clockevent driver.
   47) kernel: mips: lost GIC CEVT/CSRC commits (fix switch to GIC timer
   issue).
   48) kernel: mips: complete disable MIPS CEVT_R4K on enable CEVT_GIC.
   49) kernel: mips: irq-gic: disable GIC local compare interrupt on CEVT_GIC
   not used.
   50) kernel: mips: flush dcache for flush_kernel_dcache_page.
   51) kernel: mips: flush highmem pages in __flush_dcache_page.
   52) kernel: mips: handle highmem pages in __update_cache.
   53) kernel: mips: partially disable RIXI support.
   54) kernel: mips: REVERT: fix race condition in lazy cache flushing.
   55) kernel: usb: qmi_wwan: add Sierra Wireless EM74xx device ID, Gemalto's
   Cinterion PHxx.
   56) kernel: usb: usbnet: cleanup after bind() in probe().
   57) kernel: usb: xhci: use non-interruptible sleep for XHCI commands.
   58) kernel: usb: cdc_ncm: toggle altsetting to force reset before setup,
   do not call usbnet_link_change from cdc_ncm_bind.
   59) kernel: usb: qcserial: add Sierra Wireless EM74xx device ID.
   60) kernel: usb: xhci: correct the usage of USB_CTRL_SET_TIMEOUT.
   61) kernel: usb: option: add support for SIM7100E.
   62) kernel: net: fastpaths: remove old ugli hack and move flags to end of
   cb (fix compath with new GRO logic).
   63) kernel: net: csum: update csum_block_add to use rotate instead of
   byteswap.
   64) kernel: net: ppp: ensure file->private_data can't be overridden.
   65) kernel: net: vlan: propagate gso_max_segs.
   66) kernel: net: gro: selective flush of packets.
   67) kernel: net: gro: fix possible panic in skb_gro_receive().
   68) kernel: net: gro: add checksuming helpers.
   69) kernel: net: gro: only verify TCP checksums for candidates.
   70) kernel: net: gro: clean up tcpX_gro_receive checksum verification.
   71) kernel: net: gro: change GRO overflow strategy.
   72) kernel: net: ipv4: fix memory leaks in ip_cmsg_send() callers.
   73) kernel: net: ipv6: gro: fix IPV6_GRO_CB(skb)->proto problem.
   74) kernel: net: netfilter: nf_defrag_ipv4: drop redundant
   ip_send_check().
   75) kernel: net: bridge: update max_gso_segs and max_gso_size.
   76) kernel: net: bridge: multicast: notify eth switch on every leave
   event.
   77) kernel: net: mld, igmp: fix reserved tailroom calculation.
   78) kernel: sunrpc/cache: fix off-by-one in qword_get().
   79) kernel: ubi: fix out of bounds write in volume update code.
   80) kernel: libata: align ata_device's id on a cacheline.

   4.2.x
   1) band steering: review managment code, fix dissalow 5GHz connect in some
   cases and more smooth transit 5->2.4 and back.
   2) dropbear: up to 2016.73 version.
   3) radvd: up to 2.13 version.
   4) samba: fix CVE-2010-2063.
   5) tcpdump: fix build at some systems.
   6) igmpproxy: code review and some fixups.
   7) igmpproxy: more accurate timeouts in sync mac tables with switch.
   8) igmpproxy: fix skip unused and unknown records in switch mac table.
   9) igmpproxy: fix dump mac table.
   10) igmpproxy: refactor buildIfVc function with fix error path.
   11) igmpproxy: use reuse address and no_check flags in sendUDP.
   12) igmpproxy: fix snooping in dualrgmii with vlans parts mode.
   13) igmpproxy: remove unneded member insert to table at route activate,
   allrady inserted in request recive.
   14) igmpproxy: fix type mismatch in interfaceInRoute.
   15) igmpproxy: hybrid snooping add sanitycheck the group adress before
   insert member.
   16) netcwnmp: fix settings apply on the fly.
   17) netcwnmp: fix socket close of services restart.
   18) netcwnmp: fix wireless mode set.
   19) netcwnmp: fix vpn managment.
   20) netcwnmp: workarround for arrange fields d-link acs issue.
   21) coovachilli: sync with git 16.04.2016 (commit b56d3b05).
   22) coovachilli: fix error in loading binary status file.
   23) coovachilli: fix sequence number in the TCP RESET.
   24) coovachilli: fix AC_DEFUN call more compliant with modern autoconf.
   25) coovachilli: fix size_t data wants %zu format string.
   26) coovachilli: disable SSLv2 and SSLv3 protocol. Add sslciphers option.
   27) coovachilli: add layer3 support to kmod_coova_sync.
   28) goahead: fix setNthValue split strings.
   29) goahead: fix rebuild portforward access rules.
   30) goahead: fix check wds key in some cases.
   31) init.d/goahead: add support KickStaRssiLowPSM.
   32) init.d/goahead: allow force only HW mode (default hibryd mode) for
   igmpsnooping.
   33) init.d: move tune roaming and advanced wifi parametrs to internet.sh
   (fix apply params by external logic reconfigure, as vlans and others).
   34) init.d: wifi params apply linerazed, remove unneded sleeps and avoid
   call for not existent interfaces.
   35) init.d: fix snooping in TV/SIP ports modes, use pure HW snooping
   (hibryd not support this modes now).
   36) init.d: fix race in ipv6 reconfigure logic.
   37) init.d: move ipv6 restart to true place.
   38) init.d: fix apply settings regression after ipv6 serialize.
   39) init.d: l2tp server ip-up: split and fix masqrade rules, review for
   more secure.
   40) init.d: fix portforward regression in wan_if without real address
   case.
   41) kernel: fs: cifs: fix erroneous return value.
   42) kernel: fs: ext4: fix bh->b_state corruption.
   43) kernel: ralink_wifi: add KickStaRssiLowPSM to allow different set
   levels for kick PSM clietns (prevent infinitive kick/reuse at some mobile
   clients).
   44) kernel: ralink_wifi: fix coexistence roaming and band steereing
   auth/probe reqests filter code.
   45) kernel: ralink_wifi: allow show band steering info with iwpriv.
   46) kernel: ralink_wifi: fix some errors founded by cppcheck.
   47) kernel: mips: cpu_name_string: Use raw_smp_processor_id().
   48) kernel: mips: upstream RIXI changes.
   49) kernel: mips: fix race condition in lazy cache flushing.
   50) kernel: mips: sync icache & dcache in set_pte_at.
   51) kernel: mips: c-r4k: sync icache when it fills from dcache.
   52) kernel: mips: revert: cache flush functions are reworked.
   53) kernel: mips: revert: fix bug in using flush_cache_vunmap.
   54) kernel: mips: module: fix incorrect IS_ERR_VALUE macro usages.
   55) kernel: mips: remove aliasing alignment if HW has antialising support.
   56) kernel: mips: avoid using unwind_stack() with usermode.
   57) kernel: mips: don't unwind to user mode with EVA.
   58) kernel: mips: make PCI_DMA_BUS_IS_PHYS=1 constant.
   59) kernel: usb: qmi_wwan: add D-Link DWM-221 B1 device id.
   60) kernel: usb: cdc_ncm: adding Telit LE910 V2 mobile broadband card.
   61) kernel: net: ipv4: l2tp: fix a potential issue in l2tp_ip_recv.
   62) kernel: net: sock: convert sk_peek_offset functions to WRITE_ONCE.
   63) kernel: net: bridge: fix incorrect variable assignment on error path
   in br_sysfs_addbr.
   64) kernel: net: wext: fix message delay/ordering.
   65) kernel: net: fix use after free in the recvmmsg exit path.
   66) kernel: net: force inlining of netif_tx_start/stop_queue, sock_hold,
   __sock_put.
   67) kernel: net: route: do not cache fib route info on local routes with
   oif.

   4.3.x
   1) kernel: up to 3.4.112 LTS version.
   2) toolchain: update kernel headers and rebuild.
   3) build_system: fix cleanup libext and optimize cleanup userdir.
   4) build_system: port and add libtalloc (need for free radius).
   5) build_system: add SNR-CPE-AP2-5GHZ-MT outdor AP support.
   6) build_system: add SNR-CPE-AP1 celling AP support.
   7) build_system: add SNR-CPE-ME3-5GHZ-MT gigabit router support.
   8) build_system: review some logic and cleanup.
   9) build_system: review gcc compiler flags for uckibc.
   10) defaults: add base openspace roaming profile for help start configure
   at the current place.
   11) coovachilli: bstring: sync with git 21.04.2016 (commit 9a86b71).
   12) coovachilli: refactor radius packet send function (sync with git
   02.05.2016 commit 10a73639).
   13) miniupnpd: up to 2.0 version.
   14) irqbalance: update to 27.04.2016 git version.
   15) dnsmasq: up to 2.76 version.
   16) openssl: up to 1.0.1t version (0.9.8 EOL).
   17) ralinkiappd: fix segfault in debug mode with level trace.
   18) ralinkiappd: add support send messages to seconf wlan module.
   19) ralinkiappd: fix ioctl to wlan in some cases.
   20) freeradius: porting 3.0.11 freeradius (need for standalone EAP auth
   for 802.1x support need).
   21) freeradius: strip configs and not install not used libs for save flash
   size.
   22) init.d: add logic for radius server start.
   23) init.d: fix dns for l2tp server clients work.
   24) init.d: udhcpc-script: fix parse routes in some case.
   25) init.d: udhcpc-script: add workaound for ISP with DGW over others net.
   26) init.d: udhcpc-script: flush route cache after route table
   modifications.
   27) init.d: udhcpc-script: add route stubs with low cost metric for prio
   real work routes.
   28) init.d: fix udhcpc stop procedure.
   29) init.d: six: always deconfig ipv6 ifaces at service stop.
   30) init.d: six: serialization stop=>start operation for avoid race.
   31) init.d: prevent stard 802.1x and iappd daemon if radio off.
   32) fastroaming: fix work 802.1x preauth (use iappd daemon for client
   migrations events).
   33) band_steering: add support read parametrs from nvram.
   34) uboot/kernel: add support EN25Q128 flash chip.
   35) init.d/goahead: add delta threshold rssi level for 5GHz band parametr
   for tune 5GHz band roaming.
   36) nvram: fix smart carrier support enable in mt7603.
   37) goahead: add band steering options.
   38) goahead: add contol dynamic adaptive LNA gain.
   39) goahead: add clamp and skip long range vga options for 7602/7612
   modules (USB3/HDMI interference reduce).
   40) goahead: add support ap-only mode.
   41) goahead: fix wds disable.
   42) goahead: remove not needed route deadloop workaround.
   43) netcwnmp: fix apply some params (full support
   acs-test_1.0.14.01_amd64).
   44) configs: disable VGA for long distance clients and clamp VGA of -4dB
   for all per default for 7602/7612 modules.
   45) kernel: ralink_arch: raeth: fixes & code refactoring.
   46) kernel: ralink_wifi: fix build warnings if build with -Wall flag.
   47) kernel: ralink_wifi: backport some fixes to MT7620 and MT7610 stable
   drivers.
   48) kernel: ralink_wifi: fix variables type used as irqlock flags (MT7620
   and MT7610 stable drivers).
   49) kernel: ralink_wifi: mt76x2 driver add workaround for DEASSOC PSM bug.
   50) kernel: ralink_wifi: print PA/LNA modes to syslog (for easy fabric
   control).
   51) kernel: ralink_wifi: fix replace iappd pid from ioctl.
   52) kernel: ralink_wifi: add mt7603 driver support.
   53) kernel: ralink_wifi: mt76x3: driver update to 4.1.0.0 pre version.
   54) kernel: ralink_wifi: mt76x3: fix build warnings.
   55) kernel: ralink_wifi: mt76x3: fix ate build and work.
   56) kernel: ralink_wifi: mt76x3: port auto handover logic (basic roaming).
   57) kernel: ralink_wifi: mt76x3: port spectrum fixes.
   58) kernel: ralink_wifi: mt76x3: allow some getinfo from iwpriv without
   DBG build flag.
   59) kernel: ralink_wifi: mt76x3: allow log connect/disconnect and others
   info.
   60) kernel: ralink_wifi: mt76x3: fix band steering defaults.
   61) kernel: compiler-gcc: disable -ftracer for __noclone functions.
   62) kernel: compiler.h: add support for malloc attribute.
   63) kernel: mm: fix page_group_by_mobility_disabled breakage.
   64) kernel: ext4: fix NULL pointer dereference in ext4_mark_inode_dirty().
   65) kernel: bio: return EINTR if copying to user space got interrupted.
   66) kernel: fs/exec.c: fix minor memory leak.
   67) kernel: mips: reimplement get_cycles().
   68) kernel: mips: mm: c-r4k: panic if IL or DL fields have a reserved
   value.
   69) kernel: mips: allow emulation for unaligned [LS]DXC1 instructions.
   70) kernel: usb: option: add D-Link DWM-221 B1 device id.
   71) kernel: usb: cdc_mbim: apply NDP to end quirk to all Huawei devices.
   72) kernel: usb: cdc-acm: more sanity checking.
   73) kernel: net: ipv6: count in extension headers in skb->network_header.
   74) kernel: net: ipv6: recursive check rt->dst.from when call
   rt6_check_expired.
   75) kernel: net: xfrm: fix crash observed during device unregistration and
   decryption.
   76) kernel: net: ethtool: fix phy adress get from user.
   77) kernel: net: ethtool: issue with querying phy settings.
   78) kernel: net: fix net_gso_ok for new GSO types.
   79) kernel: net: netfilter: x_tables: fix unconditional helper.
   80) kernel: net: netfilter: x_tables: make sure e->next_offset covers
   remaining blob size.
   81) kernel: net: make *sfhash and real small functions in conntrack always
   inline (small optimize).
   82) kernel: net: fq_codel: explicitly reset flows in ->reset().
   83) kernel: net: ppp: take reference on channels netns.
   84) kernel: net: bridge: fix old ioctl unlocked net device walk.
   85) kernel: net: bridge: fix igmp / mld query parsing.
   86) kernel: net: bridge: fix igmpv3 / mldv2 report parsing.
   87) kernel: net: bridge: fix potential use-after-free when hook returns
   QUEUE or STOLEN verdict.
   88) kernel: net: revert - mld, igmp: fix reserved tailroom calculation.

   4.4.x
   1) uboot: up to 5.0.1.0-6 version.
   2) toolchain: kernel headers up and rebuild.
   3) libcurl: up to 7.49.1 version.
   4) lldpd: up to 0.9.3 version.
   5) irqbalance: update to 28.06.2016 git version.
   6) build_system: add libmicrohttpd 0.9.50 (need for new version
   nodogsplash).
   7) coovachilli: up to 1.3.1.4 version from git 09.06.2016 (commit
   ac1543ad).
   8) nodogsplash: up to version 1.0.0 (commit: 5c9154c2).
   9) usb-modeswitch: up to 2.4.0 version (data up to 20160612).
   10) nvram: allways copy values as string, not need convert str->int->str.
   11) defaults: fix fast roaming defaults and add check this.
   12) init.d: six: add wait release procedure end in dhcp6c stop path.
   13) init.d: six: fix static ipv6 support.
   14) netcwmpd: fix reboot afer firmware update in some cases.
   15) pppd: pptp plugin: use global debug flag in pptp_ctrl.
   16) goahead: use direct call to kernel if need fast reboot.
   17) goahead: add Rx/Tx bytes per client in WebUI.
   18) goahead: add wait apply settings counter.
   19) goahead: fix check input values in some places.
   20) goahead: fix busy wait on socket disconnect.
   21) goahead: refactor administrator status page.
   22) goahead cgi and mtd_write must be link with libgcc as static to
   (prevent freez after write before reboot).
   23) nodogsplash: web pages: use meta tag viewport for more usable at
   mobile browsers.
   24) busybox/udhcpc: fix T2 time to be 0,875 of duration lease per RFC2132.
   25) ralinkiappd: temp disable crypt for iappd frames (need for debug,
   compat with dual radio and others iappd implementations).
   26) ralinkiappd: fix encrypt/decrypt function for dual band operations (if
   used).
   27) ralinkiappd: fix potentioanl null pointer dereference.
   28) kernel: ralink_arch: allow highmem region for 512M devices.
   29) kernel: ralink_arch: fix memory size autodetect with highmmem.
   30) kernel: ralink_arch: fix parse uboot cmdline.
   31) kernel: ralink_wifi: mt76x2: fix apcli phymode regression after
   3.0.5.0 up.
   32) kernel: ralink_wifi: mt76x2: fix build driver options in 7620 2.7
   driver + 7612 3.0.5 driver config.
   33) kernel: ralink_wifi: mt76x2: fix sanity check in RtmpEnqueueNullFrame.
   34) kernel: ralink_wifi: mt76x2: fix ed cca disable in bbp if build
   without ed_monitor support.
   35) kernel: ralink_wifi: mt76x2: fix drop to BW_20 regression.
   36) kernel: ralink_wifi: mt76x2: fix lost beacons at high noise level.
   37) kernel: ralink_wifi: mt76x2: fix drop Main-AP to BW 20MHz after
   AP-Client connected to 20MHz Root-AP.
   38) kernel: ralink_wifi: mt76x2: update to 3.0.5.0_DPA_20160229 version.
   39) kernel: ralink_wifi: mt7603: set ring sizes for lab tested results.
   40) kernel: ralink_wifi: mt7603: fix proc path name.
   41) kernel: ralink_wifi: mt7603: fix set enq_done in drop path of
   rtmp_enq_req.
   42) kernel: ralink_wifi: mt7603: avoid not needed flush txring at try
   insert managment reqests.
   43) kernel: ralink_wifi: mt7603: fix rtmp_ee_prom_read16.
   44) kernel: ralink_wifi: mt7603: improve apcli autoconnect.
   45) kernel: ralink_wifi: mt7603: use full rescan on AP-Client
   auto-connect.
   46) kernel: ralink_wifi: mt7603/mt76x2: allow get rrminfo and ftinfo
   without debug.
   47) kernel: ralink_wifi: mt7603/mt76x2: allow RRM Quiet IE support.
   48) kernel: ralink_wifi: mt7610: backport support 802.11K/R from 3.0.5.0
   76x2 driver.
   49) kernel: ralink_wifi: mt7610: fix disable secondary EDCCA.
   50) kernel: ralink_wifi: mt7610: add lost drop burst flag in
   RtmpPCIMgmtKickOut.
   51) kernel: ralink_wifi: fix rekey interval allways exeed at preauth
   clients.
   52) kernel: ralink_wifi: set max mcast pkt`s in psq=16 (as mt7620 2.7.2.0
   production drivers).
   53) kernel: ralink_wifi: convert all IrqFlags to ulong.
   54) kernel: ralink_wifi: fix throughput issue for some vendor AP with AES
   mode.
   55) kernel: ralink_wifi: fix default set MsduLifeTime at startup.
   56) kernel: ralink_wifi: fix set channel width in HT_CAP.
   57) kernel: ralink_wifi: fix potentional null pointer dereference in some
   case.
   58) kernel: ralink_wifi: do not disable HT protect if only one station
   connected to AP.
   59) kernel: ralink_wifi: in RT_802_11_MAC_ENTRY add Rx/TxBytes for read in
   UI.
   60) kernel: ralink_wifi: fix mlme request success handle.
   61) kernel: ralink_wifi: fix apcli lost beacon timeout.
   62) kernel: ralink_wifi: prevent drop 5GHz clients to CCK mode.
   63) kernel: ralink_wifi: more readable log for apcli connect procedure.
   64) kernel: ralink_wifi: fix fastroaming coexistence with band steering
   and handover logic.
   65) kernel: ralink_wifi: ap-cli HT-40 connection fixes.
   66) kernel: ralink_wifi: backport AP-Client auto-connect ability from
   4.1.X.X tree.
   67) kernel: ralink_wifi: backport some fixes from 3.0.4.0.P2, 3.0.5.0 and
   4.1.0.0 drivers to stable tree versions.
   68) kernel: fix build with gcc5 (soft/hardfloat issue workaround).
   69) kernel: backport RTC_SYSTOHC from upstream.
   70) kernel: locking, compiler.h: Cast away attributes in the WRITE_ONCE()
   magic.
   71) kernel: kernel/relay.c: fix potential memory leak.
   72) kernel: splice: handle zero nr_pages in splice_to_pipe().
   73) kernel: nfs: fix nfs_size_to_loff_t.
   74) kernel: rcu: make rcu_is_cpu_rrupt_from_idle helper functions static.
   75) kernel: wait: allow sys_waitid() to accept
   __WNOTHREAD/__WCLONE/__WALL.
   76) kernel: sched: always inline context_switch().
   77) kernel: sections: fix section conflicts in mm/percpu.c.
   78) kernel: sg: fix dxferp in from_to case.
   79) kernel: mm/mlock: prepare params outside critical region.
   80) kernel: mm: reorder can_do_mlock to fix audit denial.
   81) kernel: mm/msync.c: sync only the requested range in msync().
   82) kernel: mm/msync: fix incorrect fstart calculation.
   83) kernel: mm/mempool: add @gfp_mask to mempool_create_node().
   84) kernel: mm/mempool: convert kmalloc_node(...GFP_ZERO...) to
   kzalloc_node(...).
   85) kernel: mips: make flush_thread and exit_thread always inline.
   86) kernel: mips: lib: mark intrinsics notrace.
   87) kernel: mips: fix accessing to per-cpu data when flushing the cache.
   88) kernel: mips: fix forgotten preempt_enable() when CPU has inclusive
   pcaches.
   89) kernel: usb: xhci: fix wild pointers in xhci_mem_cleanup.
   90) kernel: usb: serial: option: add more ZTE device ids.
   91) kernel: usb: serial: option: add support for Cinterion PH8 and AHxx.
   92) kernel: usb: net: cdc_ncm: update datagram size after changing mtu.
   93) kernel: usb: core: fix crash on unlink urb.
   94) kernel: usb: retry reset if a device times out.
   95) kernel: net: ipv4: don't do expensive useless work during inetdev
   destroy.
   96) kernel: net: bridge: fix incorrect re-injection of STP packets.
   97) kernel: net: ethtool: use kcalloc instead of kmalloc for
   ethtool_get_strings.
   98) kernel: net: netfilter: x_tables: don't move to non-existent next rule
   (CVE-2016-4997).
   99) kernel: net: ipmr/ip6mr: Initialize the last assert time of mfc
   entries.

   4.5.x
   1) xz: up to 5.2.2 version.
   2) busybox: update to 1.25.0 version.
   3) xupnpd: up to 1.034 version commit dffe9c55 (use old style ui).
   4) radvd: up to 2.14 version.
   5) build_system: add libwive for move reused functions from
   goaead/netcwmpd/snmpd/etc to one place.
   6) build_system: enable build FT/RRM support for all chips.
   7) defaults: allow 80MHz channel width for MD1 devices per default.
   8) full remove redumentary LAN2 alias support.
   9) netcwmpd: rework debug messages and start use libwive functions.
   10) libwive: add portstatus,portscounts function sfor easy get port status
   and counts info (future use in cli,goahead and netcwmpd).
   11) goahead: auto update station list.
   12) goahead: full refactoring station list, apcli page.
   13) goahead: fix timezone for Novosibirsk.
   14) goahead: merge wireless basic and advanced page.
   15) goahead: add input values check to ipv6 page.
   16) goahead: add ipv6 dns options.
   17) goahead: add use default password warnings.
   18) goahead: move select band for apcli/wds to true places.
   19) goahead: refactoring firewall/dmz/wds pages.
   20) goahead: add lost buffer alocation checks (prevent null pointer
   dereference in come cases).
   21) goahead: add TX Rate show in station list.
   22) libnvram: move rebuild script logic from goahead to this place
   (prepare drop dependency and more code reuse).
   23) nvram: add genstaticroutes and geniptablesrules commands for use from
   init instead of direct call from goahead (drop dependency
   routes/netfilters by goahead).
   24) init.d: direct call regenerate route/iptables rules and switch
   bootlevel instead iptables call.
   25) init.d: rename web init to switchstage and drop goahead dependency
   start second init stage.
   26) init.d: use user configured ipv6 dns in static mode and as fallback
   for dhcp mode.
   27) init.d: fix not set MTU to WAN regression.
   28) init.d: fix unload unused conntrack helpers modules.
   29) init.d: fix buffers overflow trouble chillispot with 76x2 driver.
   30) kernel: ralink_wifi: fix potentional crash in AllocateNdisPacket.
   31) kernel: ralink_wifi: prevent new gcc overoptimization.
   32) kernel: ralink_wifi: lost zero tx_block RxRing1DoneInterruptHandle.
   33) kernel: ralink_wifi: fix padding in AMSDU frames.
   34) kernel: ralink_wifi: fix potentional null pointer dereference in
   RTMPSendPackets.
   35) kernel: ralink_wifi: fix set and use country code (need for RRM).
   36) kernel: ralink_wifi: fix set mcast BW from profiles.
   37) kernel: ralink_wifi: AP-Client: use new format of ApCliWPAPSK.
   38) kernel: ralink_wifi: AP-Client: AP-Client: autoconnect fixes.
   39) kernel: ralink_wifi: AP-Client: reset SSID value on init.
   40) kernel: ralink_wifi: improve drop dead STA clients and clean TX rings.
   41) kernel: ralink_wifi: igmp_snoop: do not perform M2U for
   excluded/reserved multicast group.
   42) kernel: ralink_wifi: use 64bit counters for per clients rx/tx bytes
   statistic.
   43) kernel: ralink_wifi: mt7620: fix bogus set pci_dev context for RBUS
   mode.
   44) kernel: ralink_wifi: mt7610: add VTH mode for multicast phy mode set.
   45) kernel: ralink_wifi: mt7610: fix mcast BW set with BW=80Mhz.
   46) kernel: ralink_wifi: mt7610: add lost 140,144 channels in N_Check.
   47) kernel: ralink_wifi: mt76x2: fix AutoTxRateSwitch in some cases.
   48) kernel: ralink_wifi: mt76x2: fixed broken iwpriv RadioOn=1.
   49) kernel: ralink_wifi: mt76x2/mt7603: fix hwHdrLen calculation
   regression after china refactoring.
   50) kernel: ralink_wifi: mt7620/mt7610/mt76x2: clear TXWI ack flags in Tx
   Ring before send disconnect to clients.
   51) kernel: ralink_wifi: mt7603: fix broken AP -> AP-Client forwards on
   NoForwardingBTNBSSID=1.
   52) kernel: ralink_wifi: mt7620/mt7610: fix IoT issue with Macbook. (AP
   Don't send BAOriSessionTearDown).
   53) kernel: ralink_wifi: mt7620/mt7610: check our BSSID on receive DEAUTH
   frame.
   54) kernel: mips: fix possible corruption of cache mode by mprotect.
   55) kernel: mips: fix siginfo.h to use strict posix types.
   56) kernel: mips: remove cpu_has_safe_index_cacheops.
   57) kernel: mips: dma-default: defend against NULL dev in
   massage_gfp_flags.
   58) kernel: mips: prevent hitting do_notify_resume() with
   !user_mode(regs).
   59) kernel: mips: fix harmlessly missing else statement.
   60) kernel: mips: tlbex: avoid duplicated single_insn_swpd.
   61) kernel: mips: uasm: handle low values in uasm_in_compat_space_p().
   62) kernel: mips: traps: return correct si code for accessing nonmapped
   addresses.
   63) kernel: mips: c-r4k: fix sigtramp SMP call to use kmap.
   64) kernel: mips: c-r4k: avoid dcache flush for sigtramps.
   65) kernel: mips: c-r4k: add r4k_on_each_cpu cache op type arg.
   66) kernel: mips: c-r4k: fix valid ASID optimisation.
   67) kernel: mips: c-r4k: exclude sibling CPUs in SMP calls.
   68) kernel: mips: c-r4k: split r4k_flush_kernel_vmap_range().
   69) kernel: mips: c-r4k: local flush_icache_range cache op override.
   70) kernel: mips: c-r4k: avoid small flush_icache_range SMP calls.
   71) kernel: mips: smp: clear ASID without confusing has_valid_asid().
   72) kernel: mips: smp: update cpu_foreign_map on CPU disable.
   73) kernel: mips: smp: drop stop_this_cpu() cpu_foreign_map hack.
   74) kernel: cdc_ncm: workaround for EM7455 silent data interface.
   75) kernel: rndis_host: Set valid random MAC on buggy devices.
   76) kernel: cdc_ether: improve ZTE MF823/831/910 handling.
   77) kernel: usb: serial: option: add support for Telit LE910 PID 0x1206.
   78) kernel: net: tcp: increase size at which tcp_bound_to_half_wnd bounds
   to > TCP_MSS_DEFAULT.
   79) kernel: net: net/core: revert net: fix __netdev_update_features
   return.. and add comment.
   80) kernel: net: neigh: only allow init_net to change the default
   neigh_parms.
   81) kernel: net: neigh: netlink notification for administrative NUD state
   change.
   82) kernel: net: neigh: directly goto out after setting nud_state to
   NUD_FAILED.
   83) kernel: net: neigh: recompute reachabletime before returning from
   neigh_periodic_work().
   84) kernel: net: neigh: disallow transition to NUD_STALE if lladdr is
   unchanged in neigh_update().
   85) kernel: net: ppp: defer netns reference release for ppp channel.
   86) kernel: net: netfilter: nf_conntrack_h323: fix off-by-one in
   DecodeQ931.
   87) kernel: net: ipv4: af_inet: make it explicitly non-modular.
   88) kernel: net: graceful exit from netif_alloc_netdev_queues().
   89) kernel: net: bridge: Fix incorrect re-injection of LLDP packets.
   90) kernel: net: ipv6: slight optimization in ip6_dst_gc.
   91) kernel: net: ipv6: make ip -6 route get mark xyz work.
   92) kernel: net: ipv6: update Destination Cache entries when gateway turn
   into host.
   93) kernel: net: ipv6: fix RTPROT_RA markup of RA routes w/nexthops.
   94) kernel: net: ipv6: pass neighbours and dest address into
   NETEVENT_REDIRECT events.
   95) kernel: net: netfilter: h323: Use mod_timer instead of
   set_expect_timeout.
   96) kernel: mm: prevent setting of a value less than 0 to min_free_kbytes.

   4.6.x
   1) toolchain: update kernel headers and rebuild.
   2) libwive: add more functions and document it (~60% work end).
   3) libnvram: move nvram_load_default and gen_wifi_config from nvram tool
   (for code reuse).
   4) libtalloc: update to 2.1.8 version.
   5) libcurl: up to 7.50.1 version.
   6) nodogsplash: up to version 2.0.0 (commit: b79e1163).
   7) xl2tpd: update to 1.3.8 version (sync with devtree commit: 6fe1ed52).
   8) dropbear: up to 2016.74 version.
   9) lldpd: up to 0.9.4 version.
   10) iappd: fix driver crash by long encrypted ioctl after not correct RRB
   packets get (Android 6.x at Samsung Galaxy S5).
   11) busybox: apply busybox-1.25.0-ip.patch, busybox-1.25.0-gzip.patch,
   busybox-1.25.0-ntpd.patch.
   12) busybox: udhcpc: run deconfig script in manual renew state too.
   13) busybox: ash: do not leave SIGQUIT ignored on exec CMD.
   14) coovachilli: up to 1.3.1.4 from git (commit 374af0af).
   15) coovachilli: rewiev build options for maximum decrease memory
   footprint.
   16) libmicrohttp/nodogsplash: fix regression after add SO_REUSE_PORT
   support (3.4.x kernel not support this - rewrite to address reuse).
   17) bstrlib: sync with git (commit f5af8c88).
   18) build_system: add templates for support SFP router.
   19) init.d: add limited support GSW port5 connect to external phy in one
   rgmii mode.
   20) init.d: fix wds regression and coex with apcli mode.
   21) init.d: vpn: do not remove autoroute if dgw not enabled.
   22) init.d: unifi readdif_to_br and delif_from_br functions.
   23) init.d: fix deconfig second apcli interface.
   24) init.d: chillispot: rework parse options (prepare for multilan
   support).
   25) init.d: chillispot: iptables: drop depend from lan_if variable
   (prepare for multilan support).
   26) init.d: six: do not use dhcpv6 for client adresses configuration, only
   RA use for this, dhcpv6 only DNS send to clients if enabled.
   27) init.d: six: set AdvOtherConfigFlag to on only if dhcp6s enabled,
   instead send dns in RA.
   28) init.d: chillispot: start with high prio for prevent drop packets.
   29) nvram/goahead: split WPAPSK1 and WPAPSK1INIC for allow set differents
   passwords to 2.4/5GHz radio.
   30) libnvram: fix put unneded divider in mbssid.
   31) goahead: more usable station list extended info.
   32) goahead: add apcli connection status.
   33) goahead: fix reboot after managment port change regression.
   34) goahead: avoid full reboot after misc page applly.
   35) goahead: add apscan support.
   36) goahead: fix segfault on apcli page settings apply.
   37) goahead: avoid reboot at apcli change settings.
   38) goahead: refactoring service misc page.
   39) cli: initial implementation (wl scan/stalist/status, sw
   lan/wan/vpn/dhcp/status/switch, st show,dhcp,l2tp,ntp,ddns,samba,vpn).
   40) kernel: ralink_wifi: fix set mcast rate from profile.
   41) kernel: ralink_wifi: remove bogus fill IE_COUNTRY block (MTK copy-past
   bug).
   42) kernel: ralink_wifi: fix beacons IE_COUNTRY power constraint value
   (swing 16 <-> 20).
   43) kernel: ralink_wifi: DMA remove bogus play with TXD block for
   Little-Endian in RTMPFreeTXDUponTxDmaDone().
   44) kernel: ralink_wifi: mt76x2: remove redundant select pci_dev pointer
   for RBUS.
   45) kernel: ralink_wifi: mt76x2/mt76x3: fix and refactor force announse
   critical ampdu.
   46) kernel: ralink_wifi: mt76x2/mt76x3: fix wrong parse ICMP type in data
   queue reserve.
   47) kernel: ralink_wifi: mt76x2/mt76x3: fix double free on
   RTMPFreeTXDUponTxDmaDone().
   48) kernel: ralink_ppe: fix hang MT7621 PPE on manual unbind entry.
   49) kernel: mips: fix memory regions reaching top of physical.
   50) kernel: mips: fix r4k clockevents registration.
   51) kernel: mips: ralink system tick counter: use
   clockevents_config_and_register.
   52) kernel: mips: RM7000: Double locking bug in rm7k_tc_disable().
   53) kernel: mips: KEYS: 64-bit MIPS needs to use compat_sys_keyctl for
   32-bit userspace.
   54) kernel: mips: Lantiq: Fix build failure.
   55) kernel: mips: move identification of VP(E) into proc.c from smp-mt.c.
   56) kernel: mips-gic: use clockevents_config_and_register.
   57) kernel: mips: dma: Fix BUG due to smp_processor_id() in preemptible
   code.
   58) kernel: mips: provide nice way to access boot CPU's data.
   59) kernel: mips: ptrace: avoid smp_processor_id() in preemptible code.
   60) kernel: mips: oprofile: fix a preemption issue.
   61) kernel: mips: fix definition of KSEGX() for 64-bit.
   62) kernel: sched/loadavg: fix loadavg artifacts on fully idle and on
   fully loaded systems.
   63) kernel: usb: xhci: fix panic if disconnect.
   64) kernel: usb: core: buffer: avoid NULL pointer dereferrence.
   65) kerenl: usb: cdc-acm: fix wrong pipe type on rx interrupt xfers.
   66) kernel: usb: serial: option: add support for Telit LE920A4.
   67) kernel: usb: serial: option: add D-Link DWM-156/A3.
   68) kernel: tun: don't look at current when non-blocking.
   69) kernel: net: core: inline dev_alloc_skb() call.
   70) kernel: net: flow_dissector: support L2 GRE.
   71) kernel: net: decrease size of skb_shared_info (prevent page allocation
   failure on wireless path).
   72) kernel: net: rps: inspect PPTP encapsulated by GRE to get flow hash.
   73) kernel: net: pptp: refactor the struct and macros of PPTP codes.
   74) kernel: net: l2tp: fix the connect status check in pppol2tp_getname.
   75) kernel: net: l2tp: correctly return -EBADF from pppol2tp_getname.
   76) kernel: net: l2tp: refactor the codes with existing macros instead of
   literal number.
   77) kernel: net: packet: improve socket create/bind latency in some cases.
   78) kernel: net: packet: race condition in packet_bind.
   79) kernel: net: ipv6: don't call fib6_run_gc() until routing is ready.
   80) kernel: net: ipv6: update ip6_rt_last_gc every time GC is run.
   81) kernel: net: tcp: make challenge acks less predictable
   (CVE-2016-5696).
   82) kernel: net: tcp: md5: fix lockdep annotation.
   83) kernel: net: tcp: consider recv buf for the initial window scale.
   84) kernel: net: tcp: fix use after free in tcp_xmit_retransmit_queue().
   85) kernel: net: netfilter: replace strnicmp with strncasecmp.
   86) kernel: net: netfilter: avoid race with exp->master ct.
   87) kernel: net: netfilter: conntrack: only need first 4 bytes to get
   l4proto ports.
   88) kernel: net: netfilter: conntrack: don't attempt to iterate over empty
   table.
   89) kernel: net: netfilter: nf_conntrack_sip: CSeq 0 is a valid CSeq.
   90) kernel: net: netfilter: xt_mark, xt_connmark: do not skip HW_NAT on
   RA_HW_NAT_QDMA enabled.
   91) kernel: net: netfilter: nf_ct_h323: do not re-activate already expired
   timer.
   92) kernel: net: netfilter: ctnetlink: reject new conntrack request with
   different l4proto.
   93) kernel: net: netfilter: gre: Use consistent GRE_* macros instead of
   ones defined by netfilter.
   94) kernel: net: netfilter: gre: Use consistent GRE and PTTP header
   structure instead of the ones defined by netfilter.
   95) kernel: net: netfilter: ftp: Remove the useless dlen==0 condition
   check in find_pattern.
   96) kernel: net: netfilter: ftp: Remove the useless code.
   97) kernel: net: netfilter: nf_ct_sip: correct parsing of continuation
   lines in SIP headers.
   98) kernel: net: netfilter: nf_ct_sip: correct allowed characters in
   Call-ID SIP header.
   99) kernel: net: netfilter: nf_ct_sip: allow tab character in SIP headers.

   4.7.x
   1) toolchain: gcc: use the proper rtx cost model for the selected CPU,
   even when optimizing 2 for size.
   2) configs: mt7621: enable highmem support, work and tests ok now.
   3) configs: enable freeradius build.
   4) busybox: update to 1.25.1 version.
   5) busybox: apply libbb:/send_to_from: do not require that "to" should
   have the same AF. Closes 9146.
   6) coovachilli: enable openssl support.
   7) coovachilli: do not limit start and end ip adresses in pool per default
   (limit by chilli_net network range).
   8) coovachilli: up to 1.3.2 from git (commit 078ed2df).
   9) openssl: update to 1.0.1u.
   10) radvd: update to 2.15 version.
   11) xl2tpd: update to 1.3.8 version (sync with devtree commit: 5b0c9993).
   12) freeradius: up to 3.0.12 version.
   13) lldpd: up to 0.9.5 version.
   14) libmicrohttpd: up to 0.9.51 version.
   15) libcurl: up to 7.50.3 version.
   16) libcurl: fix build with openssl and zlib support.
   17) nodogsplash: fix resourse leak after migrate to libmicrohttpd.
   18) bandsteering: fix command line options parse.
   19) bandsteering: tune timeouts and increase mac table size to 128.
   20) bandsteering: send UNSPECIFY_FAIL if need auth reject.
   21) bandsteering: fix calc and copy rssi to daemon.
   22) bandsteering: fix band report to daemon.
   23) bandsteering: cleanup table after band steering disable.
   24) busybox: ash: in heredoc code, fix access past the end of allocated
   memory. Closes 9276.
   25) goahead: implement vlan page and switch status refactoring.
   26) goahead: webui: fix TV/SIP ports with vlans configured.
   27) goahead: webui: rework vpn server page.
   28) goahead: webui: add profile for hotspot.ots-net.ru in chillipage.
   29) goahead: webui: add radius server page.
   30) init.d: split set_vlan_map to set_port_vlan_prio_map and
   set_vlan_ingress_prio_map functions.
   31) init.d: coova-chilli: setup clients for /32 network (client2client
   traffic isolate).
   32) init.d: split sip/tv vlans logic, prevent create unused vlan bridges.
   33) init.d: add qos prio for vlan based tv/sip ports.
   34) init.d: write logic for radiusd user managment.
   35) init.d: radiusd: try reload configs without full restart if possible.
   36) cli: add report mode for easy remote get and parse info.
   37) cli: read current used channel from driver over ioctl.
   38) kernel: ralink_arch: pci: refactoring PCR code.
   39) kernel: ralink_spi: use last stub item if flash chip not recognized.
   40) kernel: ralink_spi: increase rwfs partsize to 640Kb for 8Mb flash
   devices and 1Mb for 16/32Mb flash devices.
   41) kernel: ralink_raeth: fix lost disable EEE for 7350 gsw on link down.
   42) kernel: ralink_raeth: increase napi_weith for fix speed dropdown at
   stress flood test without PPE.
   43) kernel: ralink_wifi: disallow fallback per default.
   44) kernel: ralink_wifi: decrase optimistic rate TrainUP (more
   interference immunity).
   45) kernel: ralink_wifi: smallest rate adaptation interval for decrease
   packets drop at high interference.
   46) kernel: ralink_wifi: prevent mode dropdown to CCK in pure OFDM modes.
   47) kernel: ralink_wifi: sanity check for apd daemon ioctl.
   48) kernel: ralink_wifi: prevent some potentional null pointer
   dereferences.
   49) kernel: ralink_wifi: do not need require ACK for probe requests.
   50) kernel: ralink_wifi: update regional channel lists.
   51) kernel: ralink_wifi: fix restore burst mode in txop tune.
   52) kernel: ralink_wifi: rrm: fix Voice Enterprise : Item V-E-4.3, case2
   still need to include the SSID sub filed even SsidLen is 0.
   53) kernel: ralink_wifi: rrm: send rrm report from managment ring.
   54) kernel: ralink_wifi: rrm: fix report if auto channel select use.
   55) kernel: ralink_wifi: rrm: fix padding/limit ie ext cap.
   56) kernel: ralink_wifi: rrm: add channel report list req support.
   57) kernel: ralink_wifi: rrm: fix send power constraint element at 2.4GHz.
   58) kernel: ralink_wifi: mt7620: add very simple support of RRM (only
   TPC/Regulatore/APChannel reports).
   59) kernel: ralink_wifi: mt7620: fix set quick rate adapt interval.
   60) kernel: ralink_wifi: mt76x2: fix reset idle timeout and retransmits
   counter on broadcast/multicast activity.
   61) kernel: ralink_wifi: mt76x2: disable buggy play with auto fallback in
   ra_alg_grp.
   62) kernel: ralink_wifi: mt7610: fix set Entry CurrTxRateIndex in rate
   adapt logic.
   63) kernel: ktime: add __must_check prefix to ktime_to_timespec_cond.
   64) kernel: sched/core: fix a race between try_to_wake_up() and a woken up
   task.
   65) kernel: softirq: let ksoftirqd do its job.
   66) kernel: kernel.h: make abs() work with 64-bit types and remove
   abs64().
   67) kernel: kernel.h: change abs() macro so it uses consistent return
   type.
   68) kernel: asm-generic headers: uaccess.h to conditionally define
   segment_eq().
   69) kernel: asm-generic: uaccess s/might_sleep/might_fault/.
   70) kernel: asm-generic: uaccess: Allow arches to over-ride
   __{get,put}_user_fn().
   71) kernel: asm-generic: {get,put}_user ptr argument evaluate only 1 time.
   72) kernel: asm-generic: make copy_from_user() zero the destination
   properly.
   73) kernel: asm-generic: make get_user() clear the destination on errors.
   74) kernel: mips: barrier: add definitions of SYNC stype values.
   75) kernel: mips: c-r4k: fix size calc when avoiding IPIs for small icache
   flushes.
   76) kernel: mips: asm-offset.c: delete unused irq_cpustat_t struct
   offsets.
   77) kernel: mips: fix possibility of deadlock when bringing CPUs online.
   78) kernel: mips: squash lines for simple wrapper functions.
   79) kernel: mips: c-r4k: split user/kernel flush_icache_range().
   80) kernel: mips: cacheflush: use __flush_icache_user_range().
   81) kernel: mips: fix detection of unsupported highmem with cache aliases.
   82) kernel: mips: use struct list_head lists.
   83) kernel: mips: pci: make pcibios_set_cache_line_size an initcall.
   84) kernel: mips: pci: inline pcibios_assign_all_busses.
   85) kernel: net: packet: minor: add generic tpacket_uhdr to access packet
   headers.
   86) kernel: net: packet: tx timestamping on tpacket ring.
   87) kernel: net: vlan: unnecessary to check if vlan_pcpu_stats is NULL.
   88) kernel: net: vlan: free percpu stats in device destructor.
   89) kernel: net: netfilter: nf_nat: handle routing changes in MASQUERADE
   target.
   90) kernel: net: netfilter: nf_nat: also handle non-ESTABLISHED routing
   changes in MASQUERADE.
   91) kernel: net: xfrm: invalidate dst on policy insertion/deletion.
   92) kernel: net: xfrm/xfrm_replay: avoid division by zero.
   93) kernel: net: xfrm: use xfrm direction when lookup policy.
   94) kernel: net: xfrm: make xfrm_state timer monotonic.
   95) kernel: net: xfrm: announce deleation of temporary SA.
   96) kernel: net: xfrm: force SA to be lookup again if SA in acquire state.
   97) kernel: net: xfrm: simplify SA looking up when using wildcard source.
   98) kernel: net: xfrm: decode sessions with output interface.
   99) kernel: net: xfrm: fix null pointer dereference when decoding
   sessions.
   100) kernel: net: xfrm: reload skb header pointers after calling
   pskb_may_pull.
   101) kernel: net: xfrm: make local error reporting more robust.
   102) kernel: net: xfrm: choose protocol family by skb protocol.
   103) kernel: net: ipv6: correctly add local routes when lo goes up.
   104) kernel: net: ipv6: do not increment mac header when it's unset.
   105) kernel: net: ipv6: avoid taking locks at socket dismantle.
   106) kernel: net: udp: must lock the socket in udp_disconnect().
   107) kernel: net: tune route/arp caches timeouts for more suitable default
   values.
   108) kernel: net: get rid of an signed integer overflow in
   ip_idents_reserve().
   109) kernel: net: fix sk_mem_reclaim_partial().
   110) kernel: net: avoid sk_forward_alloc overflows.
   111) kernel: net: socket: move ktime2ts to ktime header api.
   112) kernel: net: introduce netdev_alloc_pcpu_stats() for drivers.
   113) kernel: usb: serial: option: add WeTelecom WM-D200.
   114) kernel: usb: serial: option: add WeTelecom 0x6802 and 0x6803
   products.
   115) kernel: usb: cdc-wdm: return correct error codes.
   116) kernel: usb: cdc-wdm: unify error handling in write.
   117) kernel: usb: cdc-wdm: error returns need to be translated.
   118) kernel: usb: cdc-wdm: fix out-of-sync due to missing notifications.
   119) kernel: usb: cdc-wdm: clear read pipeline in case of error.
   120) kernel: usb: cdc-wdm: cleanup debug messages.
   121) kernel: usb: cdc-wdm: add terminating newline.
   122) kernel: usb: qmi_wwan: add support for Quectel EC21 and EC25.
   123) kernel: usb: hub: fix unbalanced reference count/memory
   leak/deadlocks.
   124) kernel: usb: hub: fix up early-exit pathway in hub_activate.
   125) kernel: usb: hub: change the locking in hub_activate.
   126) kernel: usb: remove race condition in usbfs/libusb when using
   reap-after-disconnect.
   127) kernel: usb: avoid left shift by -1.
   128) kernel: usb: usbip: fix potential out-of-bounds write.
   129) kernel: usb: usb-storage: add support for write cache quirk.
   130) kernel: usb: usb-storage: update usb devices for write cache quirk in
   quirk list.
   131) kernel: usb: usb-storage: scsiglue: limit USB3 devices to 2048
   sectors.
   132) kernel: usb: usb-storage: scsiglue: further describe our 240 sector
   limit.
   133) kernel: sd: set to WCE if usb cache quirk is present.
   134) kernel: sd: notify block layer when using temporary change to
   cache_type.
   135) kernel: mm, gup: close FOLL MAP_PRIVATE race (CVE-2016-5195).

   4.8.x
   1) kernel: update to 3.4.113.
   2) toolchain: kernel headers update and rebuild.
   3) uboot: update binary for all currect supported devices.
   4) coovachilli: up to 1.3.2 from git (commit faeb8a81).
   5) coovachilli: ability to configure the Syslog Identity.
   6) coovachilli: fix answer buffer size to avoid chilli crash.
   7) coovachilli: fix chilli.c check if the flag MF is set or not.
   8) nodogsplash: up to version 2.0.0 (commit: c3a1cf0f).
   9) quagga: up to 1.1.0 version.
   10) libcurl: up to 7.51.0 version.
   11) libmicrohttpd: up to 0.9.52 version.
   12) strace: up to 4.14 version.
   13) xupnpd: update hls and add vsetv.net plugins.
   14) netcwmpd: add support ER-Telecom ("tr-098 1.8.0 compat) ACS.
   15) netcwmpd: fix build with ssl support if openssl present on project.
   16) 802.1x: update to new version (5020 SDK).
   17) iappd: update to 1.1.0 version (5020 SDK).
   18) usb-modeswitch-data: update to 2016-08-03.
   19) iappd: use set encrypt key from daemon.
   20) iappd: fix FT client table parse infinitive loop issue.
   21) iappd: add IAPPDebug variable for easy enable/disable debug.
   22) iappd: fix handle destination adress in recv RRB.
   23) bndstr: update to new version (5020 SDK).
   24) bndstr: fix userspace vs kernel space client tables unconsystent.
   25) bndstr: add BandSteeringDebug variable for easy enable/disable debug.
   26) busybox: udhcpc: check read of option length byte to be within packet.
   27) busybox: udhcpc: check read of overload option data byte to be within
   packet.
   28) goahead: more correct standart http code decode use.
   29) goahead: send internal server error if not found error code.
   30) goahead: allways use HTTP1.1 by default.
   31) goahead: fix webheader format (parse issue by antiviral filters).
   32) goahead: fix radius secret check.
   33) goahead: move max clients option to Basic Roaming section (for AP load
   balance tune).
   34) goahead: rework switch status, config page.
   35) goahead: fix regulatory tables for RU.
   36) goahead: add link for download firmware.
   37) goahead: fix set BasicRate in some cases.
   38) goahead: optimize for use of small resolution devices.
   39) goahead: fix timezones for some regions.
   40) goahead: add preamble type auto.
   41) goahead: rework tr069 support.
   42) goahead: fix hide unused services.
   43) goahead: add one/two/three ports only devices.
   44) kernel: ralink_wifi: do not disable tx_burst for multiclients mode
   (fix small slowdown).
   45) kernel: ralink_wifi: improve tx speed at only one client connected.
   46) kernel: ralink_wifi: mt7603: do not set 4K rts thres for MT_MAC
   (support only 2k amsdu agregation, fix speed issue with LG G2 and
   similar).
   47) kernel: ralink_wifi: mt7610: fix rx sens tuning for long range.
   48) kernel: ralink_wifi: mt7610: disable ACK to prevent retry 0x1f for
   deauth.
   49) kernel: ralink_wifi: mt7610: fix subchannel select after scan for
   80MHz mode.
   50) kernel: ralink_wifi: mt76x2: remove IPhone6 IOT hack, this not correct
   and allready fixed in new IOS update.
   51) kernel: ralink_wifi: fix set legacy rate support for pure OFDM modes.
   52) kernel: ralink_wifi: fix announse AMSDU supported.
   53) kernel: ralink_wifi: fix Update_Rssi_Sample for ApCfg.RssiSample (use
   for high power chip tune and dynvga).
   54) kernel: ralink_wifi: fix regulatory table to Russia (add lost range).
   55) kernel: ralink_wifi: fix announce band freq ranges.
   56) kernel: ralink_wifi: fix set TxPreamble auto from profile (used per
   default, not need replace this).
   57) kernel: ralink_wifi: avoid tx_rate dropdown in low traffic case
   (HT/VHT).
   58) kernel: ralink_wifi: rrm: fix limit freq subbands if need.
   59) kernel: ralink_wifi: auto_ch_select: add some sanity checks.
   60) kernel: ralink_wifi: fix skip beacon from different channel.
   61) kernel: ralink_wifi: allow 30dBm tx power for ext PA devices and some
   country.
   62) kernel: ralink_wifi: skip DEAUTH with all zero mac addr.
   63) kernel: ralink_wifi: set HT_MpduDensity=4, fix MT7603 slowdown and
   compat with some clients.
   64) kernel: ralink_wifi: fix ack req of req block ack managment frame
   send.
   65) kernel: ralink_wifi: small tune trainup threshold for more stable
   link.
   66) kernel: ralink_raeth: fix init RTL8211F GPHY, allow read PHY EEE
   status.
   67) kernel: ralink_raeth: fix init IC+ IP1001 GPHY.
   68) kernel: ptrace: fix regs_return_value for kernel context.
   69) kernel: mips: fix max_low_pfn with disabled highmem.
   70) kernel: mips: irq gic: mask IRQ on handle_percpu_irq (IPI case) to
   prevent race condition.
   71) kernel: net: udp: avoid one cache line miss in recvmsg().
   72) kernel: net: clear sk_err_soft in sk_clone_lock().
   73) kernel: net: make default TX queue length a defined constant.
   74) kernel: net: mangle zero checksum in skb_checksum_help().
   75) kernel: net: fix bogus cast in skb_pagelen() and use unsigned
   variables.
   76) kernel: net: ipsec: add prototypes to support RALINK_HWCRYPTO.
   77) kernel: net: igmp: do not remove igmp souce list info when set link
   down.
   78) kernel: net: l2tp: fix negative assignment to unsigned int.
   79) kernel: net: l2tp: fix racy SOCK_ZAPPED flag check in l2tp_ip_bind().
   80) kernel: net: tcp: fix wrong checksum calculation on MTU probing.
   81) kernel: net: tcp: fix overflow in __tcp_retransmit_skb().
   82) kernel: net: netfilter: xt_multiport: use switch case instead of
   multiple condition checks.
   83) kernel: net: netfilter: cone_nat: use switch case instead of multiple
   condition checks.
   84) kernel: net: netfilter: nfnetlink_log: use GFP_NOWARN for skb
   allocation.
   85) kernel: net: netfilter: nfnetlink_queue: reject verdict request from
   different portid.
   86) kernel: net: netfilter: xt_multiport: fix wrong unmatch result with
   multiple ports.
   87) kernel: net: xfrm: fix error return code.
   88) kernel: net: xfrm: convert several xfrm policy match functions to
   bool.
   89) kernel: net: xfrm: use ipv6_addr_equal() where appropriate.
   90) kernel: net: xfrm: convert xfrm_addr_cmp() to boolean
   xfrm_addr_equal().
   91) kernel: net: xfrm: simplify SA looking up when using wildcard source.
   92) kernel: net: xfrm: fix unexpected SA hard expiration after changing
   date.
   93) kernel: net: xfrm: fix freed block size calculation in
   xfrm_policy_fini().
   94) kernel: net: xfrm: force a garbage collection after deleting a policy.
   95) kernel: net: xfrm: fix unlink race when policies are deleted.

   4.9.x
   1) build_system: pregenerate CA certs at build time.
   2) build_system: cleanup and improve build speed.
   3) busybox: apply post busybox-1.25.1-setfiles.patch.
   4) miniupnpd: up to 2.0.20161216 version.
   5) nodogsplash: up to version 2.0.0 (commit: 2731ffc9).
   6) nodogsplash: rework basic splashpage.
   7) coovachilli: up to 1.4 from git (commit 261659f6).
   8) coovachilli: use sslredir if prebuilded or uploaded CA keys exist in
   /etc/certs.
   9) coovachilli: decrease chilli_lease to 4min (save mem and sync with
   default silence time in wifi).
   10) netcwmpd: use prebuilded/uploaded CA cert from /etc/certs by default.
   11) netcwmpd: add support last version of D-Link ACS (1.1.5).
   12) netcwmpd: increase poll size (upstream patch). 13) irqbalance: update
   to 05.12.2016 git version (commit af39d140).
   14) libpcap: up to 1.8.1 version.
   15) tcpdump: up to 4.8.1 version.
   16) libnfnetlink: sync local header with kernel headers.
   17) igmpproxy: try fix timeouted req with big size mac table in switch.
   18) init.d: move isolated mode and chilli_dnsparanoia for chillispot to
   nvram.
   19) init.d: iptables: use xt_coova only for tcp/udp traffic (fix icmp
   issue).
   20) init.d: iptables: add support redirect all DNS requests to local dns
   proxy.
   21) init.d: kext: allow use skip filters and route fastpath in nodogsplash
   mode (after last kernel fastpaths fix).
   22) init.d: six: rework tune ipv6 mtu logic for avoid fragmentation and
   add IPv6ManualMTU variable.
   23) goahead: update profile for hotspotsystem.com.
   24) goahead: rework chillispot page.
   25) goahead: add profiles for google/sky/open/yandex dns services in
   static mode.
   26) goahead: rework reboot counter.
   27) goahead: l2tp_server/radius_server: fix infinitive starting if users
   not added.
   28) goahead: add ipv6 manual mtu option.
   29) kernel: linux/types.h: enable endian checks for all sparse builds.
   30) kernel: block: ioc_task_link() can't fail.
   31) kernel: cls_cgroup: allow classifier cgroups to have their classid
   reset to 0.
   32) kernel: cgroup: net_cls: move sock_update_classid() declaration to
   cls_cgroup.h.
   33) kernel: mm: add PHYS_PFN, use it in __phys_to_pfn().
   34) kernel: ralink_wifi: mt7620/mt7610: fix lookup client adress for some
   managment frames.
   35) kernel: ralink_wifi: mt7620/mt7610: remove use ext fifo counters in
   rate_alg.
   36) kernel: ralink_wifi: mt7610: fix unrequested LUT enable.
   37) kernel: ralink_wifi: mt7610: fix read FixTxMode for VHT from reg.
   38) kernel: ralink_wifi: mt7610: fix announce supported MCS rate in some
   cases.
   39) kernel: ralink_wifi: mt7610: fix announce wide channel switch element.
   40) kernel: ralink_wifi: mt7620: fix lost clean isCached flag at AMPDU
   frame TX.
   41) kernel: mips: return -ENODEV from weak implementation of
   rtc_mips_set_time.
   42) kernel: mips: ensure bss section ends on a long-aligned address.
   43) kernel: mips: fix mem=X@Y commandline processing.
   44) kernel: mips: init: ensure reserved memory regions are not added to
   bootmem.
   45) kernel: mips: init: ensure bootmem does not corrupt reserved memory.
   46) kernel: mips: c-r4k: treat physically indexed dcaches as not aliasing.
   47) kernel: mips: sc-mips: L2 cache is inclusive of L1 dcache for CM3.
   48) kernel: pci: fix devfn for VPD access through function 0.
   49) kernel: pci: use function 0 VPD for identical functions, regular VPD
   for others.
   50) kernel: locking/rtmutex: prevent dequeue vs. unlock race.
   51) kernel: locking/rtmutex: use READ_ONCE() in rt_mutex_owner().
   52) kernel: fork: remove the weak insanity.
   53) kernel: fork: move thread info gfp flags to header.
   54) kernel: fork: move the real prepare_to_copy() users to
   arch_dup_task_struct().
   55) kernel: fork: call complete_vfork_done() after clearing child_tid and
   flushing rss-counters.
   56) kernel: fork: report pid reservation failure properly.
   57) kernel: net: cleanups in sock_setsockopt().
   58) kernel: net: set SK_MEM_QUANTUM to 4096.
   59) kernel: net: avoid signed overflows for SO_{SND|RCV}BUFFORCE.
   60) kernel: net: check segs for NULL in some cases (prevent potentional
   null pointer dereference).
   61) kernel: net: eliminate no_check from protosw.
   62) kernel: net: set skb->protocol properly for local output.
   63) kernel: net: inet: fix IP(V6)_RECVORIGDSTADDR for udp sockets.
   64) kernel: net: packet: fix race condition in packet_set_ring.
   65) kernel: net: bridge: set error code on failure.
   66) kernel: net: socket: preferred __aligned(size) for control buffer.
   67) kernel: net: sock: remove skb argument from sk_rcvqueues_full.
   68) kernel: net: sock: reorganize struct sock for decrease size and chache
   miss.
   69) kernel: net: netfilter: ipv6: expand skb head in ip6_route_me_harder
   after oif change.
   70) kernel: net: netfilter: ipv4/6: propagate routing errors from
   ip_route_me_harder().
   71) kernel: net: fastpath: use ip_route_input instead of noref version.
   72) kernel: net: fastpath: fix work with IMQ/NF_QUEUE/SMB_FASTPATH.
   73) kernel: net: fastpath: use switch case instead of multiple condition
   checks.
   74) kernel: net: tcp: do not create inetpeer on SYNACK message.
   75) kernel: net: tcp: warn on bogus MSS and try to amend it.
   76) kernel: net: tcp: tcp_mtu_probe() is likely to exit early.
   77) kernel: net: ipv6: set skb->protocol on tcp, raw and ip6_append_data
   genereated skbs.
   78) kernel: net: ipv6: allow IPv4-mapped address as next-hop.
   79) kernel: net: ipv6: ip6_tunnel: disable caching when the traffic class
   is inherited.
   80) kernel: net: ipv6: check route protocol when deleting routes.
   81) kernel: net: ipv6: protect protocols not handling ipv4 from v4
   connection/bind attempts.
   82) kernel: net: ipv6: introduce ip6_sk_dst_hoplimit.
   83) kernel: net: ipv6: use inet6_iif instead of IP6CB()->iif.
   84) kernel: net: ipv6: handle -EFAULT from skb_copy_bits.

   5.0.x
   1) build_system: add SNR-CPE-WI2 device support.
   2) build_system: rework gen serts for radius and move to /etc/serts to.
   2) build_system: add arpwatch (for monitoring system use).
   3) build_system: build tcpdump per default at >= 8Mb flash devices.
   4) defaults: tune roaming defaults for 5GHz preffer and avoid band jam.
   5) libnvram: split HT_BW to two variables HT_BW and HT_BWINIC.
   6) u-boot: add prebuilt and config for WI2 device.
   7) busybox: update to 1.26.2 version.
   8) busybox: mdev: back to use /sys/block (fix create block devices nodes
   in WO usb builds).
   9) radvd: update to 2.16 version.
   10) strace: up to 4.15 version.
   11) libcurl: up to 7.52.1 version.
   12) zlib: up to 1.2.10 version.
   13) tcpdump: up to 4.9.0 version.
   14) nodogsplash: up to git version 2.0.0 (commit: 6a1ff4b5).
   15) arpwatch: skip zeronet and some small fixes.
   16) init.d: allow skip long range vga logic for MT7610.
   17) goahead: add cwmpd_inform_periodic_enable and
   cwmpd_inform_periodic_interval options.
   18) goahead: rework security page.
   19) goahead: fix portstatus for AP1/WI2 device.
   20) goahead: add arpwatch to webui.
   21) 802.1x: fix regression after up to new sdk version.
   22) libnvram: allow send log message through wireless event for debug
   purpose.
   23) wireless_tools: fix iwevent work in multicall build.
   24) kernel: ralink_wifi: fix potentional null pointer dereference.
   25) kernel: ralink_wifi: fix seqence nubmer jam issue when Rx
   fragmentation.
   26) kernel: ralink_wifi: shure avoid uncorrect reordered packets send to
   AMSDU.
   27) kernel: ralink_wifi: fix FT GTK state after rekey set.
   28) kernel: ralink_wifi: add syslog support in not debug builds.
   29) kernel: ralink_wifi: fix max txpwr envelope in VHT_IECAP.
   30) kernel: ralink_wifi: check probe rsp ignore rssi before band steering
   logic (save table size in BNDSTR logic).
   31) kernel: ralink_wifi: more detail log of deassoc events.
   32) kernel: ralink_wifi: fix EAPOL timer set in PMKID not found (fix
   802.1x ressoc issue).
   33) kernel: ralink_wifi: fix wpa retry timers (more compliant 802.11n
   specs).
   34) kernel: ralink_wifi: fix parse some IE EXT/HT/VHT ops.
   35) kernel: ralink_wifi: fix overload channel utilization calculation
   issue.
   36) kernel: ralink_wifi: fix edca timeouts.
   37) kernel: ralink_wifi: mt7610: fix ajust per rate TxPower regression.
   38) kernel: ralink_wifi: mt7620: fix legacy only B mode support.
   39) kernel: ralink_wifi: mt76x2/mt7610: fix tune tx power for VHT MCS2/3.
   40) kernel: ralink_wifi: mt7620/mt7610: fix MT5396 based STB crash issue
   when Rx fragmentation.
   41) kernel: ralink_wifi: mt7620/mt7610: fix wpa auth msg retry procedure.
   42) kernel: ralink_wifi: mt7620/mt7610: fix class2_3 error handle.
   43) kernel: ralink_wifi: mt7603: skip check dublicate frame for NULL
   frames.
   44) kernel: ralink_wifi: mt76x2: fix set packet wdev before really sent
   out to air.
   45) kernel: ralink_wifi: mt7610: implement long range VGA support (extend
   range).
   46) kernel: linux/kernel.h: fix DIV_ROUND_CLOSEST to support negative
   divisors.
   47) kernel: wext: handle NULL extra data in iwe_stream_add_point better.
   48) kernel: mips: syscall: return directly in 32_mmap2() and mips_mmap().
   49) kernel: mips: fix special case in 64 bit IP checksumming.
   50) kernel: percpu_counter: switch the protection of percpu_counter list
   to spinlock.
   51) kernel: percpu_counter: __this_cpu_write() doesn't need to be
   protected by spinlock.
   52) kernel: percpu_counter: make APIs irq safe.
   53) kernel: percpu_counter: fix __percpu_counter_add().
   54) kernel: percpu_counter: make percpu_counters_lock irq-safe.
   55) kernel: percpu_counter: percpu_counter_hotcpu_callback() cleanup.
   56) kernel: usb: cdc_ether: fix handling connection notification.
   57) kernel: usb: cdc-ether: usbnet_cdc_zte_status() can be static.
   58) kernel: usb: qmi_wwan: add support for Telit LE922A PID 0x1040.
   59) kernel: usb: serial: option: add support for Telit LE922A PIDs 0x1040,
   0x1041.
   60) kernel: usb: serial: option: add dlink dwm-158.
   61) kernel: net: limit tx queue len for Ralink/MTK chipsetd (wireless
   slowdown and not stable FDX speed fix).
   62) kernel: net: remove bh disabling around percpu_counter accesses.
   63) kernel: net: remove bh disabling around percpu_counter accesses.
   64) kernel: net: change init_inodecache() return void.
   65) kernel: net: inet: remove now unused flag DST_NOPEER.
   66) kernel: net: netfilter: help gcc inline some functions.
   67) kernel: net: sched: fix soft lockup in tc_classify.
   68) kernel: net: drop secpath on free after gro merge.
   69) kernel: net: netfilter: nf_conntrack: fix tcp_in_window for Fast Open.
   70) kernel: net: ipv4: remove disable of bottom half in inet_rtm_getroute.
   71) kernel: net: ipv4: tcp: dont cache output dst for syncookies.
   72) kernel: net: ipv6: remove skb_reserve in getroute.
   73) kernel: net: ipv6: remove __sk_dst_reset() in tcp_v6_connect().
   74) kernel: net: ipv6: addrconf: avoid addrconf_disable_change() using RCU
   read-side lock.
   75) kernel: net: ipv6: set protocol to kernel for local routes.
   76) kernel: net: igmp: make igmp group member RFC 3376 compliant.
   77) kernel: net: ipmr: drop ip_mr_init() mrt_cachep null check as we'll
   panic if it fails.
   78) kernel: net: tcp: accept RST for rcv_nxt - 1 after receiving a FIN
   (fix compliant RFC 5961 3.2).
   79) kernel: net: gro: enter slow-path if there is no tailroom.
   80) kernel: net: gro: use min_t() in skb_gro_reset_offset().
   81) kernel: net: gro: disable frag0 optimization on IPv6 ext headers.

   5.1.x
   1) toolchain: kernel headers update and rebuild.
   2) quagga: up to 1.2.0 version.
   3) nodogsplash: up to git version 2.0.0-1 (commit: 1dff66e7).
   4) usb-modeswitch: up to 2.5.0 version (data up to 20170205).
   5) xl2tpd: up to 1.3.9 version.
   6) sysctl.conf: increase max_syn_backlog to 256 (prevent bad syn flood
   detect on iapp processing).
   7) init.d: first up 5GHz module. Fix Band steering at hot reboot.
   8) goahead: add skip long range VGA option for MT7610 radio.
   9) goahead: fix webstr content filter work.
   10) goahead: webui consolidate get parameters from nvram to one place.
   11) goahead: webui fix some webui regressions.
   12) goahead: webui fix defaults values.
   13) band steering: tune parametrs for faster band detect.
   14) band steering: more safe allowed 5GHz logic.
   15) band steering: increase mac table size to 512 entry.
   16) band steering: fix enable procedure.
   17) band steering: fix auto mode work.
   18) band steering: more human readable debug messages in syslog (loglevel
   >= 3).
   19) band steering: allow force back from 2.4GHz to 5GHz.
   20) band steering: allow connect to 2.4GHz for all if rssi very low.
   21) kernel: ralink_wifi: band steering: fix bndstr debug.
   22) kernel: ralink_wifi: band steering: fix bndstr on/off by daemon.
   23) kernel: ralink_wifi: band steering: fix garbage collector work.
   24) kernel: ralink_wifi: band steering: collect probe req info from long
   range clients (ProbeRspRssi - 10dB).
   25) kernel: ralink_wifi: band steering: add AllowStaConnectInHt check
   (more compat with new API of daemon).
   26) kernel: ralink_wifi: band steering: fix rssi array init.
   27) kernel: ralink_wifi: band steering: skip android randomized mac probe
   req from process (da:a1:19:xx:xx:xx).
   28) kernel: ralink_wifi: band steering: add safe delta thres for fix
   unneded kick 5GHz clietns.
   29) kernel: ralink_wifi: band steering: fix delete entry if auth check
   fail.
   30) kernel: ralink_wifi: mt7610: fix channel offset in eeprom.
   31) kernel: ralink_wifi: mt7610: fix insert MDIE element at probe req
   action.
   32) kernel: ralink_wifi: mt7610: fix handle FT assoc req.
   33) kernel: ralink_wifi: mt7620: fix DMA idle wait on init rings.
   34) kernel: ralink_wifi: mt76x2/mt7610: fix limit mcast ps queue size.
   35) kernel: ralink_wifi: mt76x2/mt7610: fix mcs_lut work at tx_adapt
   enabled.
   36) kernel: ralink_wifi: mt7620/mt7610: fix small rekey timer regression.
   37) kernel: mips: sync-r4k: fix KERN_CONT fallout.
   38) kernel: mips: disable stack checks on MIPS kernels.
   39) kernel: mips: end spinlocks with .insn.
   40) kernel: mips: mt7621: fix coherent Manager CMP & CPC memory mapped
   size.
   41) kernel: sched/core: fix an SMP ordering race in try_to_wake_up() vs.
   schedule().
   42) kernel: sched/core: better document the try_to_wake_up() barriers.
   43) kernel: tty: limit terminal size to 4M chars.
   44) kernel: usb: xhci_mtk: avoid direct usage wMaxPacketSize (endian
   issue).
   45) kernel: net/llc: avoid BUG_ON() in skb_orphan().
   46) kernel: net: dccp: fix freeing skb too early for IPV6_RECVPKTINFO.
   47) kernel: net: disable fragment reassembly if high_thresh is set to
   zero.
   48) kernel: net: ratelimit warnings about dst entry refcount underflow or
   overflow.
   49) kernel: net: do not block BH while processing socket backlog.
   50) kernel: net: don't call strlen() on the user buffer in
   packet_bind_spkt().
   51) kernel: net: net_enable_timestamp() can be called from irq contexts.
   52) kernel: net: ping: fix a null pointer dereference.
   53) kernel: net: ocfs2, scsi_tcp: block BH in TCP callbacks.
   54) kernel: net: l2tp: avoid use-after-free caused by
   l2tp_ip_backlog_recv.
   55) kernel: net: ipv4: keep skb->dst around in presence of IP options.
   56) kernel: net: igmp: fix memory leak in igmpv3/mld_del_delrec().
   57) kernel: net: rtnl: reset calcit fptr in rtnl_unregister().
   58) kernel: net: ping: check minimum size on ICMP header length.
   59) kernel: net: route: add missing nla_policy entry for RTA_MARK
   attribute.
   60) kernel: net: sock: use USEC_PER_SEC macro instead of literal 1000000.
   61) kernel: net: socket: fix recvmmsg not returning error from sock_error.
   62) kernel: net: packet: round up linear to header len.
   63) kernel: net: tcp: take care of truncations done by sk_filter().
   64) kernel: net: tcp: make tcp_sendmsg() aware of socket backlog.
   65) kernel: net: tcp: guarantee forward progress in tcp_sendmsg().
   66) kernel: net: tcp: tcp_probe: use spin_lock_bh().
   67) kernel: net: tcp/dccp: block BH for SYN processing.
   68) kernel: net: tcp: fix 0 divide in __tcp_select_window().
   69) kernel: net: tcp: avoid infinite loop in tcp_splice_read().
   70) kernel: net: netfilter: restart search if moved to other chain.
   71) kernel: net: netfilter: nf_conntrack_sip: extend request line
   validation.
   72) kernel: net: netfilter: nf_ct_sip: use mod_timer_pending().
   73) kernel: net: ipv6: don't use ufo handling on later transformed
   packets.
   74) kernel: net: ipv6: ip6_tunnel: clear IP6CB in ip6tunnel_xmit().
   75) kernel: net: ipv6: check sk sk_type and protocol early in
   ip_mroute_set/getsockopt.
   76) kernel: net: ipv6: orphan skbs in reassembly unit.
   77) kernel: net: ipv6: ignore null_entry in inet6_rtm_getroute() too.
   78) kernel: net: ipv6: reorder icmpv6_init() and ip6_mr_init().

   5.2.x
   1) build_system: add profile for AP2 dualband celling AP support.
   2) build_system: update backup calibs for MD1/AP2 devices.
   3) uboot: add profile and binary boot for SNR-CPE-ME1-5GHZ-MT-256Mb-USB.
   4) freeradius: up to 3.0.13 version.
   5) xl2tpd: sync with upstrean (commit 4473b036).
   6) pppd: rp_pppoe: allow connect over raX/apcliX ifaces.
   7) cli: add disconnect command for disconnect selected sta.
   8) init.d: disable arp_filter only for lan_if and only if igmpproxy is
   work.
   9) init.d: pppoe_client: fix check connect if in br0.
   10) goahead: chillispot: fix UAM apply in apcli mode.
   11) goahead: chillispot: fix default allow all dns request option.
   12) goahead: fix hide 5Ghz password at W4N.
   13) goahead: move conntrack flush to firewall_rebuild (fix apply some
   rules on the fly).
   14) kernel: ralink_wifi: show band in ap
   assign/kick/ageout/deauth/disassoc messages.
   15) kernel: ralink_wifi: use new mbssid mode per default (now work
   correct).
   16) kernel: ralink_wifi: fix managment frames paraments.
   17) kernel: ralink_wifi: fix check aes block sizes.
   18) kernel: ralink_wifi: decrease channel scan time.
   19) kernel: ralink_wifi: fix os_alloc_mem work in nonatomic context.
   20) kernel: ralink_wifi: rate_ctl: fix fill rate table.
   21) kernel: ralink_wifi: rate_ctl: more agressive rate drop down at high
   PER level.
   22) kernel: ralink_wifi: band_steering: only statistic accumulate from
   5GHz if, do not really block access or kick.
   23) kernel: ralink_wifi: crypt_aes: need fill zero Block_MAC_From_Cipher
   before use.
   24) kernel: ralink_wifi: mt7620: turn on FEQ control by default.
   25) kernel: ralink_wifi: mt76x2: use nullbuff instead bcn for transmit
   null frames.
   26) kernel: ralink_wifi: mt76x2: disable per port pause control.
   27) kernel: ralink_wifi: mt76x2: fix support 1/2,2/1 Tx/Rx streams config.
   28) kernel: ralink_wifi: mt76x2: increase MAC OFDM SIFS from 13 to 14us.
   29) kernel: ralink_wifi: mt76x2: set MCS4 for sounding response.
   30) kernel: ralink_wifi: mt76x2/7610: fix fill TxDecriptor info.
   31) kernel: ralink_wifi: mt7603: ap_autoChSel: fix memory leak.
   32) kernel: ralink_wifi: mt7603: if used BMC need 5 TX_RINGS.
   33) kernel: ralink_wifi: mt7610: rate_ctl: more correct mcs drop down at
   TxError.
   34) kernel: ralink_wifi: mt7610: skip old wps ie fragment from probe rsp.
   35) kernel: ralink_wifi: mt7610: fix central channel freq sanity check.
   36) kernel: ralink_wifi: mt7610: add lost 802.11ac IE in probe req.
   37) kernel: ralink_wifi: mt7610: tune gain and noise floor register for
   more noise immunity.
   38) kernel: ralink_wifi: mt7610: drop 2.4GHz capabyliti flag (MT7610NE not
   support this band).
   39) kernel: ralink_wifi: mt7610: fix tx_filter and mcu_lut settings.
   40) kernel: ralink_wifi: mt7610: fix bandwith adaptation.
   41) kernel: ralink_wifi: mt7610: do not use hardware counters for rate
   adapt (chip firmware bug at interference).
   42) kernel: list: introduce list_first_entry_or_null.
   43) kernel: usb: sierra_net: add support for IPv6 and Dual-Stack Link
   Sense Indications.
   44) kernel: usb: sierra_net: skip validating irrelevant fields for IDLE
   LSIs.
   45) kernel: usb: sierra_net: fix bogus alternate-setting assumption.
   46) kernel: usb: qcserial: add Dell DW5570 QDL.
   47) kernel: usb: qcserial: add Dell DW5811e.
   49) kernel: usb: option: add Quectel UC15, UC20, EC21, and EC25 modems.
   50) kernel: usb: qmi_wwan: add Dell DW5811e.
   51) kernel: usb: option, qmi_wwan: add "D-Link DWM-222 A1" device id,
   Issue #699.
   52) kernel: tty: n_hdlc, fix lockdep false positive.
   53) kernel: tty: n_hdlc: get rid of racy n_hdlc.tbuf.
   54) kernel: net/core: relax BUILD_BUG_ON in netdev_stats_to_stats64.
   55) kernel: net: make in_aton() 32-bit internally.
   56) kernel: net: l2tp: do not use udp_ioctl().
   57) kernel: net: sock: fix sendmmsg for partial sendmsg.
   58) kernel: net: tcp: permit user set TCP_MAXSEG to default value.
   59) kernel: net: tcp: refine the __tcp_select_window.
   60) kernel: net: tun: fix TUN_PKT_STRIP setting.
   61) kernel: net: tun: read vnet_hdr_sz once.
   62) kernel: net: packet: fix races in fanout_add().
   63) kernel: net: packet: call fanout_release, while UNREGISTERING a
   netdev.
   64) kernel: net: packet: do not call fanout_release from atomic contexts.
   65) kernel: net: ipv6: mld: do not remove mld souce list info when set
   link down.
   66) kernel: net: ipv6: mld: fix memory leak in igmpv3/mld_del_delrec().
   67) kernel: net: ipv6: fix ip6_tnl_parse_tlv_enc_lim().
   68) kernel: net: ipv6: pointer math error in ip6_tnl_parse_tlv_enc_lim().
   69) kernel: net: ipv6: set route type for anycast routes.
   70) kernel: net: ipv6: avoid write to a possibly cloned skb.

   5.3.x
   1) build_system: fix install missing files.
   2) build_system: add ME1 supporrt (7621+7603+7610 device).
   3) ntfs-3g: update to 2017.3.23 version.
   4) libtalloc: update to 2.1.9 version.
   5) defaults: tune default roam params for more smooth work at 5GHz.
   6) libnvram/goahead: split BeaconPeriod to two variables and set
   BeaconPeriod=160, BeaconPeriodINIC=80 (for help band steering).
   7) iappd: remove local key entry by key timeouts record.
   8) sysctl: enable ipv6 ndisc_notify per default.
   9) init.d: skip dynvga tune for mt7603 (not suppoted by chip).
   10) init.d: iptables: drop now unneded accept rules for L2TP client mode.
   11) init.d: iptables: increase icmp echo limit to 25 packets/s.
   12) cli: add apclimode and lan mac address show.
   13) cli: add managment functions.
   14) goahead: add DNS profile for AdGuard.
   15) goahead: stalist: fix save stadata.
   16) goahead: stalist: fix clear plot data.
   17) goahead: disable and hide LDPC/STBC for 7610.
   18) goahead: fix model string for MEx devices.
   19) kernel: ralink_arch: fix MT7621 & MT7628 watchdog reset output.
   20) kernel: ralink_gpio: mt7621: swith I2C pins to GPIO mode (need for
   ME1).
   21) kernel: ralink_hwnat: fix IPv6 SIT checksum calculation.
   22) kernel: ralink_wifi: mt76x2: DynamicVGA: fix
   mt76x2_long_range_dync_vga() routine.
   23) kernel: ralink_wifi: mt7603: fix correct set RxBAWinSize and
   AMPDUFactor for pci-e version.
   24) kernel: ralink_wifi: mt7603: remove uncorrect retryve pkt size check.
   25) kernel: ralink_wifi: mt7603: fix set rx from mcu flag.
   26) kernel: ralink_wifi: mt7603: fix extended channel list support build.
   27) kernel: ralink_wifi: mt7603: fix ate mode crash.
   28) kernel: ralink_wifi: mt7603: fix pkt aggregate regression, RX buffer
   must be have one length.
   29) kernel: ralink_wifi: mt7610: FT_R1KHInfoMaintenance move to end of
   APMlmePeriodicExec.
   30) kernel: ralink_wifi: mt7610: fix pkt len for FT-PSK+TKIP mode.
   31) kernel: ralink_wifi: mt7610: use radar detect silence mode for AP.
   32) kernel: ralink_wifi: mt7610: do not support HT/VHT_STBC TX.
   33) kernel: ralink_wifi: wmm: fix incorrect handle AC0 TxOp.
   34) kernel: ralink_wifi: increase FT entry table size to 256 records.
   35) kernel: ralink_wifi: use native skb_*_pointer functions instead of
   direct coding.
   36) kernel: ralink_wifi: fix BAOriEntry size (must be as max table size).
   37) kernel: ralink_wifi: rate_ctl: correct lower mcs to optimal if RSSI
   allow max mcs for link.
   38) kernel: ralink_wifi: rate_ctl: set Quick RA 70 msec after rate change.
   39) kernel: ralink_wifi: rate_ctl: fix rate fast up/down jam at high PER
   issue.
   40) kernel: ralink_wifi: rate_ctl: tune high PER thresh for MCS3/MCS4
   modes.
   41) kernel: keys: guard against null match function in
   keyring_search_aux().
   42) kernel: mmc: block: don't use CMD23 with very old MMC cards.
   43) kernel: scsi: fix use-after-free.
   44) kernel: proc/sysctl: fix the int overflow for jiffies conversion.
   45) kernel: cpumask: add helper and use cpumask_available() for check of
   cpumask variable.
   46) kernel: give up on gcc ilog2() constant optimizations.
   47) kernel: swapfile: fix memory corruption via malformed swapfile.
   48) kernel: ubifs: fix assertion in layout_in_gaps().
   49) kernel: ubifs: fix xattr_names length in exit paths.
   50) kernel: ubifs: abort readdir upon error.
   51) kernel: ubifs: fix regression in ubifs_readdir().
   52) kernel: ubifs: fix journal replay wrt. xattr nodes.
   53) kernel: ext4: fix hang when processing corrupted orphaned inode list.
   54) kernel: ext4: check for extents that wrap around.
   55) kernel: ext4: don't call ext4_should_journal_data() on the journal
   inode.
   56) kernel: ext4: short-cut orphan cleanup on error.
   57) kernel: ext4: fix mballoc breakage with 64k block size.
   58) kernel: ext4: fix stack memory corruption with 64k block size.
   59) kernel: ext4: release bh in make_indexed_dir.
   60) kernel: net: unix: properly re-increment inflight counter of GC
   discarded candidates.
   61) kernel: net: neigh: make ->hh_len 32-bit.
   62) kernel: net: packet: fix overflow in check for priv area size.
   63) kernel: net: ipv4: fix multipath RTM_GETROUTE behavior when iif is
   given.
   64) kernel: net: ipv4: refine the ipv4_default_advmss (RFC 2675, Section
   5.1 compliant).
   65) kernel: net: ipv6: drop non loopback packets claiming to originate
   from ::1.
   66) kernel: net: ipv6: add knob to send unsolicited ND on link-layer
   address change.
   67) kernel: net: ipv6: send unsolicited NA on admin up.
   68) kernel: net: ipv6: dccp: add missing bind_conflict to
   dccp_ipv6_mapped.
   69) kernel: net: netfilter: xt_TCPMSS: refactor the codes to decrease one
   condition check and more readable.
   70) kernel: net: netfilter: xt_TCPMSS: fix use after free in
   tcpmss_mangle_packet.
   71) kernel: net: netfilter: don't track fragmented packets.
   72) kernel: net: netfilter: connmark: ignore skbs with magic untracked
   conntrack objects.

   6.0.x
   1) build_system: full replace old rt2860 driver for 7620 to new mt76x2.
   2) build_system: update backups calibs for new ME1 device.
   3) build_system: toolchain: headers up and rebuild.
   4) dropbear: up to 2016.74 version.
   5) dnsmasq: up to 2.77 version.
   6) nodogsplash: up to git version 2.0.0-1 (commit: 80ace46b).
   7) miniupnpd: up to 2.0.20170421 version.
   8) igmpproxy: fix last memeber query interval to be 1sec per rfc2236.
   9) igmpproxy: rework and increase max multicast origins to 32.
   10) pppd: fix build in some cases.
   11) goahead: add NCM modem type.
   12) goahead: fix status modem connected.
   13) goahead: add qos param for modem connection.
   14) goahead: fix rekey time range.
   15) goahead: fix vlan to wlan page.
   16) goahead: add VHT mode for WDS.
   17) goahead: fix AckPolicy apply for MBSSID.
   18) bandsteering: add support assoc req for steering.
   19) bandsteering: rework fallback from 5GHz to 2.4GHz logic.
   20) bandsteering: more correct fast jump from 2.4GHz to 5GHz.
   21) bandsteering: deduction of the client in 5 GHz range is more correct.
   22) bandsteering: add sanity check for drop value Rssi for 5GHz if 2.4GHz
   allowed.
   23) init.d: power off USB before first stage boot complete.
   24) init.d: fix 3G/4G huawei modems detect and work in ppp mode.
   25) init.d: basic support NCM mode for 3G/4G modems.
   26) init.d: udhcpc: fix add static routes to DNS servers at multiple
   connect.
   27) init.d: iptables: split NAT rules for VPN/MODEMS.
   28) init.d: reimplement dhcp get params from modem.
   29) init.d: fix fallback to cable if modem disconnect.
   30) init.d: tune RPS parametrs for speed.
   31) init.d: iptables fix chilli over VPN/MODEM work.
   32) init.d: iptables add session limit for modemmode.
   33) init.d: add qos support for modem mode.
   34) init.d: small tune txqlen for tun mode.
   35) init.d: fix checks before start iaapd.
   36) kernel: ralink_raeth: allways use NAPI_WEIGHT=128.
   37) kernel: ralink_drivers: set default tx_queue_len to 100 on init.
   38) kernel: ralink_wifi: not allow reserved wcid data to process as client
   data, always return TRUE (Microtik flood uncorrect bcast data frames
   issue).
   39) kernel: ralink_wifi: always set TIM bit for WCID_ALL/RESERVED.
   40) kernel: ralink_wifi: always send deauth on class2/3 error to client.
   41) kernel: ralink_wifi: rate_alg: tune fast up/down thresholds for more
   noise immunity.
   42) kernel: ralink_wifi: tune TxRetry limits for more stable speed.
   43) kernel: ralink_wifi: increase rate adapt interval for ext_fifo mode
   (this mode need fixed time of get error info from BBP).
   44) kernel: ralink_wifi: always use ext_fifo counters for AID 0..8.
   45) kernel: ralink_wifi: always more strong fast rate up limits.
   46) kernel: ralink_wifi: fix lock/unlock in TPC error path.
   47) kernel: ralink_wifi: fix report current TxPwr on TPREQ.
   48) kernel: ralink_wifi: try use MLME_ASSOC_REJ_UNABLE_HANDLE_STA reason
   code in assoc roaming limits via Rssi.
   49) kernel: ralink_wifi: do not kick 5GHz clients by band steering at low
   rssi (roaming issue).
   50) kernel: ralink_wifi: small optimize ap kick in roam/tx_error cases.
   51) kernel: ralink_wifi: check client is assoc in kickout sta roam path
   (more accurate handoff params calc).
   52) kernel: ralink_wifi: fix rateadapt after SMPS mode changed by client.
   53) kernel: ralink_wifi: fix STBC set in ht_mode adjust.
   54) kernel: ralink_wifi: reimplement vht_mode_adjust for AP mode (try fix
   compat with some ugly clients).
   55) kernel: ralink_wifi: more accurate drop clients by txretry error count
   if use ext_fifo.
   56) kernel: ralink_wifi: refactoring and fixup dynamic TxBurst tune.
   57) kernel: ralink_wifi: mt76x2: fix class2/3 error detect (last fix at
   PSM bug series).
   58) kernel: ralink_wifi: mt76x2: ids replay attack check need only for AP
   path in RxPktHandle.
   59) kernel: ralink_wifi: mt76x2: remove PSM bug workaround in BandSteering
   and Roaming code.
   60) kernel: ralink_wifi: mt7610: more accurate RXO_R18 tune.
   61) kernel: ralink_wifi: mt7610: fix RDG disable.
   62) kernel: ralink_wifi: mt7610: add sanity check for VHT mode in
   MlmeUpdateHtTxRates for shure of always true PHY config.
   63) kernel: ralink_wifi: mt7610: fix dynamic TxBurst tune.
   64) kernel: ralink_wifi: mt7610: fix ether type check function.
   65) kernel: ralink_wifi: mt7610: implement and enable data queue reserve
   logic.
   66) kernel: ralink_wifi: mt7610: implement and enable force annonce
   critical AMPDU.
   67) kernel: ralink_wifi: mt7610: reimplement and enable ext tx fifo
   support.
   68) kernel: ralink_wifi: mt7610: limit tx ring size (concurent issue, BBP
   bug?).
   69) kernel: ralink_wifi: mt7610: fix lost EXTIE cap in probe req.
   70) kernel: ralink_wifi: mt7610: fix order some capability in probe req.
   71) kernel: ralink_wifi: mt7610: tune some BBP params for speedup.
   72) kernel: ralink_wifi: mt7610: more correct txretry count calculate by
   fifo.
   73) kernel: ralink_wifi: mt7610: remove play with RTS/CTS (need only for
   STA).
   74) kernel: ralink_wifi: mt7610: fix MPDU tune for bad atheros case.
   75) kernel: ralink_wifi: mt7610: fix potentional nullpointer dereference.
   76) kernel: ralink_wifi: mt7610: fix rate adapt volatile issue.
   77) kernel: ralink_wifi: mt7610: add sanity checks vht mode options.
   78) kernel: ralink_wifi: mt7610: rework rate_adapt tune from ext_fifo.
   79) kernel: ralink_wifi: mt7610: implement periodic channel rescan.
   80) kernel: ralink_wifi: mt7610: basic implement VHT support for WDS.
   81) kernel: ralink_wifi: mt7610: do not add VHT mcs support in non VHT pht
   modes.
   82) kernel: ralink_wifi: mt7610: fix BA ajust.
   83) kernel: ralink_wifi: mt7610: rate_ctl: fix BW ajust for VHT.
   84) kernel: ralink_wifi: mt7620: allow use different queue for data/eapol.
   85) kernel: ralink_wifi: mt7620: allow force annonce critical AMPDU.
   86) kernel: ralink_wifi: mt7603: fix uapsd frames handle.
   87) kernel: ralink_wifi: mt7603: optimize lock/unlock in
   RTMPDeQueuePacket.
   88) kernel: ralink_wifi: mt7603: fix DeQueuePacket of BCM_USE
   (NUM_OF_TX_RING != WMM_NUM_OF_AC).
   89) kernel: ralink_wifi: mt7603: fix sanity check in
   APPeerDisassocReqAction.
   90) kernel: ralink_wifi: mt7603: mgmt_entrytb: fix cap flags set and
   sanity checks.
   91) kernel: ralink_wifi: mt7603: limit number of packets DeQueue at one
   time.
   92) kernel: ralink_wifi: mt7603: fix agregation size limit.
   93) kernel: sched/fair: do not announce throttled next buddy in
   dequeue_task_fair().
   94) kernel: sched/fair: initialize throttle_count for new task-groups
   lazily.
   95) kernel: mips: pci: scan PCI controllers in reverse order.
   96) kernel: mips: pci: add controllers before the specified head.
   97) kernel: mips: mm: fixed mappings: correct initialisation.
   98) kernel: mips: mm: adjust PKMAP location.
   99) kernel: mips: highmem: ensure that we don't use more than one page for
   PTEs.
   100) kernel: usb: net: cdc_ncm: fix TX zero padding.
   101) kernel: usb: net: usb: qmi_wwan: add QMI_QUIRK_SET_DTR for Telit PID
   0x1201.
   102) kernel: usb: net: qmi_wwan: add Telit ME910 support.
   103) kernel: usb: serial: option: add Telit ME910 support.
   104) kernel: net: remove unnecessary carrier status check.
   105) kernel: net: initialize msg.msg_flags in recvfrom.
   106) kernel: net: ping: implement proper locking.
   107) kernel: net: neigh: guard against NULL solicit() method.
   108) kernel: net: ipv4, ipv6: ensure raw socket message is big enough to
   hold an IP header.
   109) kernel: net: ipv6: send unsolicited NA if enabled for all interfaces.
   110) kernel: net: ipv6: ip6mr: fix notification device destruction.
   111) kernel: net: ipv6: check raw payload size correctly in ioctl.
   112) kernel: net: ipv6: initialize route null entry in addrconf_init().
   113) kernel: net: ipv6: reorder ip6_route_dev_notifier after
   ipv6_dev_notf.
   114) kernel: net: packet: fix overflow in check for tp_frame_nr.
   115) kernel: net: packet: fix overflow in check for tp_reserve.
   116) kernel: net: l2tp: take reference on sessions being dumped.
   117) kernel: net: tcp: do not underestimate skb->truesize in
   tcp_trim_head().
   118) kernel: net: make struct dst_entry::dev first member.
   119) kernel: net: llc: add lock_sock in llc_ui_bind to avoid a race
   condition.

   6.1.x
   1) build_system: add profile for new revision of MD1 (MD1.1).
   2) build_system: update backup calibrations for MD1/MD1.1/ME1/AP2.
   3) build_system: split backup calibrations for MD1/MD1.1
   4) init.d: add support TmpBlockAfterKick.
   5) uboot: add config and binary for MD1.1.
   6) uboot: update binary builds for all devices.
   7) coovachilli: up to 1.4 from git (commit 698996d2).
   8) nodogsplash: up to git version 2.0.0-1 (commit: 958944bc).
   9) xupnpd: up to 1.034 version commit fc53f57f.
   10) openssl: up to 1.0.2l version.
   11) switch: add crossover and search mac commands.
   12) iaapd: remove workaround for 2.x.x drivers.
   13) goahead: refactor security page and add warning for unsafe modes.
   14) goahead: fix IE compat.
   15) goahead: add new handoff options to WebUI.
   16) busybox: disable ssl support for wget, not correct work now.
   17) busybox: wget: fix for brain-damaged HTTP servers. Closes 9471.
   18) busybox: less: set max lines to 9999999.
   19) busybox: udhcpd: do not touch arpping if arp timeout set to 0.
   20) kernel: config: disable DFS support, not more need for current cases,
   needed IECAPs introduse by RRM now.
   21) kernel: ralink_arch: mt7621 fix and use zone dma (SDK5030).
   22) kernel: ralink_mtd: add S25FL064L flash chip support (SDK5030).
   23) kernel: ralink_wifi: sync ext_cap_info element with currect RFC.
   24) kernel: ralink_wifi: roam: print real counters in log.
   25) kernel: ralink_wifi: roam: use TIM bit for touch PSM clients before
   disconnect.
   26) kernel: ralink_wifi: roam: implement temporary block probe/assoc req
   from kicked client.
   27) kernel: ralink_wifi: roam: add KickStaRssiLowFT options for independed
   set disonnect rssi for FT supported clients.
   28) kernel: ralink_wifi: add Apple Iphone6, some MacBooks and Huawei P8/P9
   fat channel workaround (for oui 74:1B:B2, 84:89:AD, AC:BC:32, 3C:FA:43,
   7C:11:CB).
   29) kernel: ralink_wifi: limit max phy BW for STA if STA report support
   only 20/40 VHT channel bw.
   30) kernel: ralink_wifi: fix power limits by new gov info.
   31) kernel: ralink_wifi: fix adjust ch_width in build_vht_op_ie.
   32) kernel: ralink_wifi: ft/rrm: fix potentional null pointer dereference.
   33) kernel: ralink_wifi: ft: fix parse RDIE.
   34) kernel: ralink_wifi: ft: prevent rekey for unsupported clients.
   35) kernel: ralink_wifi: fix flush BA reordering.
   36) kernel: ralink_wifi: fix DFS channel desc.
   37) kernel: ralink_wifi: fix Rx AMPDU data frame handle in some cases.
   38) kernel: ralink_wifi: prefetch RXDATA to enhance throughput.
   39) kernel: ralink_wifi: move back to short rate_adat interval.
   40) kernel: ralink_wifi: ajust channel width and sgi40 info at assoc req.
   41) kernel: ralink_wifi: fix add extcap htinfo at probe req.
   42) kernel: ralink_wifi: only arp need force announce by ampdu and use
   data reserved queue.
   43) kernel: ralink_wifi: fix potentional null pointer dereference in
   MlmeEnqueueForRecv.
   44) kernel: ralink_wifi: move to new dma_api from deprecated pci_api
   (remove api jam).
   45) kernel: ralink_wifi: fix TPC current transmit power limit report.
   46) kernel: ralink_wifi: fix Power Constraint Limit power report.
   47) kernel: ralink_wifi: fix sanity checks and correct calibs.
   48) kernel: ralink_wifi: fix TPC report for iPA scheme (MD1/1.1).
   49) kernel: ralink_wifi: if default target pwr not set in nvram set 23dBm
   for 5GHz and 20dBm to 2.4GHz modes.
   50) kernel: ralink_wifi: calculate real power constraint limit for
   clients, reduce client side interference.
   51) kernel: ralink_wifi: recheck VHT SGI/STBC operation mode in vht_adust
   for 80MHz clients.
   52) kernel: ralink_wifi: band steering: do not send REJECT from auth if
   check false. Only update table entry.
   53) kernel: ralink_wifi: add MTK/Ralink specific IE only if needed.
   54) kernel: ralink_wifi: set by default only 2 probe response send to
   clients after check probe req.
   55) kernel: ralink_wifi: if not know peer BW capability, set safe BW from
   supported MCS.
   56) kernel: ralink_wifi: fix update basic rate bitmap.
   57) kernel: ralink_wifi: fix drop to in legacy OFDM modes in 5GHz if not
   supported by config.
   58) kernel: ralink_wifi: do not map mcs32 to mcs0 (loop dropdown fix).
   59) kernel: ralink_wifi: implement dynamic 80to40MHz fallback.
   60) kernel: ralink_wifi: fix very pessimistic rate select trend in some
   cases.
   61) kernel: ralink_wifi: tune QA to RATE alg for more reallistic.
   62) kernel: ralink_wifi: fix sanity chek in rssi calc.
   63) kernel: ralink_wifi: indicate auth in FT (fast transition mode) in
   log.
   64) kernel: ralink_wifi: mt7610: implemet vht operation mode notify
   support.
   65) kernel: ralink_wifi: mt7610: fix freq plan for 5180MHz (36) Channel.
   (freq beat issue).
   66) kernel: ralink_wifi: mt7610: fix central channel mapping for set PWR
   in VHT80 mode.
   67) kernel: ralink_wifi: mt7610: fix TRSW delay adjust.
   68) kernel: ralink_wifi: mt7610: fix Tx BA Winsize limit.
   69) kernel: log2: make order_base_2() behave correctly on const input
   value zero.
   70) kernel: tty: prevent unnecessary work queue lock checking on flip
   buffer copy.
   71) kernel: tty: fix race condition if flushing tty flip buffers.
   72) kernel: tty: fix recursive deadlock in tty_perform_flush().
   73) kernel: tty: prevent ldisc drivers from re-using stale tty fields.
   74) kernel: net: integrate ipt_NETFLOW.
   75) kernel: net: don't call strlen on non-terminated string in
   dev_set_alias().
   76) kernel: net: use loopback dev when generating blackhole route.
   77) kernel: net: 8021q: fix one possible panic caused by BUG_ON in
   free_netdev.
   78) kernel: net: conntrack: RFC5961 challenge ACK confuse conntrack
   LAST-ACK transition.
   79) kernel: net: udp: prefetch rmem_alloc in udp_queue_rcv_skb().
   80) kernel: net: tcp: disallow cwnd undo when switching congestion
   control.
   81) kernel: net: tcp: remove false sharing in tcp_rcv_state_process().
   82) kernel: net: tcp: remove unnecessary skb_reset_tail_pointer().
   83) kernel: net: tcp: remove poll() flakes when receiving RST.
   84) kernel: net: tcp: avoid fragmenting peculiar skbs in SACK.
   85) kernel: net: tcp: eliminate negative reordering in
   tcp_clean_rtx_queue.
   86) kernel: net: ipv6: fix out of bound writes in __ip6_append_data().
   87) kernel: net: ipv6: prevent overrun when parsing v6 header options.
   88) kernel: net: ipv6: check ip6_find_1stfragopt() return value properly.
   89) kernel: net: ipv6: inhibit IPv4-mapped src address on the wire.
   90) kernel: net: ipv6: fix IPv6 packet loss in scenarios involving roaming
   + snooping switches.

   6.2.x
   1) update backups calibs for SCN-CPE-ME1.
   2) busybox: update to 1.27.1 stable version.
   3) radvd: update to 2.17 version.
   4) freeradius: up to 3.0.15 version (high critical security fixup
   release).
   5) coovachilli: up to 1.4 from git (commit c6f6ada8).
   6) pppd: sync some patches from new git of project.
   7) init.d: implement TV/SIP ports with vlan tag support for MT7621 at dual
   rgmii mode.
   8) init.d: avoid unneded restart bndstrg and iaapd daemons in some cases.
   9) init.d: fix VLAN WLAN, VLAN LAN work in dual rgmii mode.
   10) goahead/libnvram/init.d: implement user defined INPUT rules add for
   local services.
   11) goahead: add RRM regulatory class select.
   12) goahead: reorganize some roaming depended options to one block.
   13) goahead: fix wifi scanresult show in some cases.
   14) netcwmpd: add parametr attributes support.
   15) netcwmpd: fix parametrs get fix with some ACS.
   16) freeradius/cerst: build 1024bit DH keys (fix new android/ios compat
   wpa enterprise AP).
   17) kernel: raeth: increase watchdog_timeo for up perf at high cpu load.
   18) kernel: ralink_wifi: use real transmit power for TPE.
   19) kernel: ralink_wifi: enchange regulatory class table.
   20) kernel: ralink_wifi: increase max scan channel time for bit
   BeaconInterval config (fix lost AP scan result in roam configs).
   21) kernel: ralink_wifi: do not block age out clients for avoid racely
   reconnection.
   22) kernel: ralink_wifi: remove not more needed limit bw by mcs.
   23) kernel: ralink_wifi: fix 80211H without DFS procedure support.
   24) kernel: ralink_wifi: apcli: remove dead code conflicting with new auto
   channel select mode.
   25) kernel: ralink_wifi: add new Apple Iphone6 OUI D8:1D:72 and honor P9
   oui F0:43:47 to BCM bug workaround.
   26) kernel: ralink_wifi: rrm: sort scan table by RSSI at scan or rrm add
   BSS.
   27) kernel: ralink_wifi: rrm: initial parse measurement subtypes info.
   28) kernel: ralink_wifi: rrm: fix sanity check for avoid call
   BssTableSetEntry() if not needed.
   29) kernel: ralink_wifi: rrm: implement passive monitor and update
   neighbour.
   30) kernel: ralink_wifi: rrm: implement periodic scan for update
   neighbour.
   31) kernel: ralink_wifi: rrm: implement 10sec delayed first boot scan.
   32) kernel: ralink_wifi: rrm: small memory leak and warning fix.
   33) kernel: ralink_wifi: mt7610: copy ext cap from assoc req for operating
   mode use.
   34) kernel: ralink_wifi: mt7610: fix update HT/VHT protect modes.
   35) kernel: ralink_wifi: mt7610: dfs: start with rd normal mode in not dfs
   builds.
   36) kernel: ralink_wifi: mt7610: ate: fix rssi clalc, channel switch
   delay, tssi compensate procedure, ate stop and VHT protect tune.
   37) kernel: introduce offsetofend macros.
   38) kernel: ipt_NETFLOW: enable parse MAC/VLAN/NAT.
   39) kernel: mips: fix IRQ tracing & lockdep when rescheduling.
   40) kernel: sched/loadavg: avoid loadavg spikes caused by delayed NO_HZ
   accounting.
   41) kernel: futex: fix potential use-after-free in FUTEX_REQUEUE_PI.
   42) kernel: futex: add missing error handling to FUTEX_REQUEUE_PI.
   43) kernel: net: af_key: fix slab-out-of-bounds in pfkey_compile_policy.
   44) kernel: net: af_unix: add sockaddr length checks before accessing
   sa_family in bind and connect handlers.
   45) kernel: net: xfrm: oops on error in pfkey_msg2xfrm_state().
   46) kernel: net: xfrm: NULL dereference on allocation failure.
   47) kernel: net: l2tp: fix race in l2tp_recv_common().
   48) kernel: net: l2tp: ensure session can't get removed during
   pppol2tp_session_ioctl().
   49) kernel: net: l2tp: fix duplicate session creation.
   50) kernel: net: l2tp: take a reference on sessions used in genetlink
   handlers.
   51) kernel: net: l2tp: don't mask errors in pppol2tp_getsockopt().
   52) kernel: net: ipv6: release dst on error in ip6_dst_lookup_tail.
   53) kernel: net: ipv6: avoid unregistering inet6_dev for loopback.
   54) kernel: net: ipv6: dad: don't remove dynamic addresses if link is
   down.
   55) kernel: net: udp: avoid ufo handling on IP payload compression
   packets.
   56) kernel: net: tcp: fix tcp_mark_head_lost to check skb len before
   fragmenting.

   6.3.x
   1) defaults: add 140,144 channel to auto select skip list.
   2) xl2tpd: update to 1.3.10rc1.
   3) netcwmpd: deviceinfo issue fix.
   4) goahead: refactor dhcp and ip_accouning pages.
   5) kernel: ralink_wifi: allow secondary channel offset in Channel Switch
   Announcement IE.
   6) kernel: ralink_wifi: always update LastTxRate after
   asic_mcs_lut_update.
   7) kernel: ralink_wifi: avoid replace parametrs from sanity checks.
   8) kernel: ralink_wifi: remove incorerect sanity chek channel range.
   9) kernel: ralink_wifi: fix get channel from probe/beacon in AP mode.
   10) kernel: ralink_wifi: add workaround for samsung galaxy S5 work at high
   channels of high mcs (samsung bug).
   11) kernel: ralink_wifi: remove unneded channel band 1 restriction check
   in not DFS builds.
   12) kernel: ralink_wifi: speedup and more safe assoc procedure in some
   cases.
   13) kernel: ralink_wifi: do not sort scantab if not results or only one
   result exist.
   14) kernel: ralink_wifi: add sanity check for max wcid in
   MlmeDelBAReqSanity.
   15) kernel: ralink_wifi: more strong sanity check ext_supported_rates.
   16) kernel: ralink_wifi: ids: do not disable rx_filter in BBP (save cpu
   and more safe RX).
   17) kernel: ralink_wifi: ids: small optimize replay attacks detect.
   18) kernel: ralink_wifi: rrm: filter very AP with very low RSSI before add
   in scantab (passive beacon listen).
   19) kernel: ralink_wifi: rrm: fix channel sanity check in passive listen
   neighbour for update scantab.
   20) kernel: ralink_wifi: bndstr: collect all probe req with rssi >
   BND_STRG_RSSI_LOW.
   21) kernel: mips: fix mips_atomic_set() retry condition.
   22) kernel: mips: send SIGILL for BPOSGE32 in
   __compute_return_epc_for_insn.
   23) kernel: net: zero terminate ifr_name in dev_ifname().

   6.4.x
   1) build_system: toolchain: headers up and rebuild.
   2) build_system: update MD1.1/ME1 calibs backup after FEM change.
   3) uboot: ME1: do not touch usb power gpio.
   4) goahead: next step refactoring and fixup webUI.
   5) goahead: reset modem by power blink at apply changes (if supported).
   6) libmicrohttpd: update to 0.9.55 version.
   7) nodogsplash: up to git version 2.0.0-1 (commit: a11ce3b6).
   8) nodogsplash: fix compat with 0.9.55 version libmicrohttpd.
   9) tcpdump: update to 4.9.1 version.
   10) libcurl: update to 7.55.1 version.
   11) libtalloc: update to 2.1.10 version.
   12) zlib: update to 1.2.11 vesion.
   13) strace: update to 4.18 version.
   14) lldpd: update to 0.9.7 version.
   15) ethtool: update to 4.11 version.
   16) usb-modeswitch: update to 2.5.1 version (data up to 20170806).
   17) quagga: update to 1.2.1 version.
   18) init.d: rework modemhelper for more correct modem ready wait in NCM
   mode.
   19) init.d: add poweroffon command for modem reset.
   20) kernel: mm: don't dereference struct page fields of invalid pages.
   21) kernel: vfs: fix pipe counter breakage.
   22) kernel: init: introduce SYSTEM_SCHEDULING state.
   23) kernel: sched/core: enable might_sleep() and smp_processor_id() checks
   early.
   24) kernel: crypto: arc4 - improve performance by adding ecb(arc4).
   25) kernel: crypto: arc4 - now arc needs blockcipher support.
   26) kernel: mips: pci: introduce cpu_tcache_line_size.
   27) kernel: mips: pci: fix smp_processor_id() in preemptible.
   28) kernel: mips: pci: cleanup control flow.
   29) kernel: mips: pci: fix pcibios_scan_bus() NULL check code path.
   30) kernel: pipe: return -ENOIOCTLCMD instead of -EINVAL on unknown ioctl
   command.
   31) kernel: pipe: consolidate pipe file creation.
   32) kernel: pipe: pipe(2) - race-free error recovery.
   33) kernel: net: 8021q: convert compare_ether_addr to ether_addr_equal.
   34) kernel: net: vlan: propagate MAC address to VLANs.
   35) kernel: net: packet: fix tp_reserve race in packet_set_ring
   (CVE-2017-1000111).
   36) kernel: net: account for current skb length when deciding about UFO.
   37) kernel: net: rtnetlink: allocate more memory for
   dev_set_mac_address().
   38) kernel: net: packet: fix use-after-free in
   prb_retire_rx_blk_timer_expired().
   39) kernel: net: af_key: do not use GFP_KERNEL in atomic contexts.
   40) kernel: net: netfilter: nf_ct_ext: fix possible panic after
   nf_ct_extend_unregister.
   41) kernel: net: ipv4: should use consistent conditional judgement for ip
   fragment in __ip_append_data and ip_finish_output.
   42) kernel: net: ipv4: initialize fib_trie prior to
   register_netdev_notifier call.
   43) kernel: net: ipv6: should use consistent conditional judgement for ip6
   fragment between __ip6_append_data and ip6_finish_output.
   44) kernel: net: ipv6: lower ndisc notifier priority below addrconf.
   45) kernel: net: ipv6: avoid overflow of offset in ip6_find_1stfragopt.
   46) kernel: ralink_gpio: power OFF usb port at bootup, must enabled only
   from userspace.
   47) kernel: ralink_wifi: bndstr: allow connect all new clients if steering
   clients table full.
   48) kernel: ralink_wifi: mt7610: fix calculate ba_max_winsize in some
   cases.
   49) kernel: ralink_wifi: mt7603: fix select lower mcs index for mcs lut.
   50) kernel: ralink_wifi: mt7603: fix avoid reduant rate down by quick DRS.
   51) kernel: ralink_wifi: mt7603: fix mcs mapping table.
   52) kernel: ralink_wifi: mt7603: fast rate up at hibryd rule at low PER.
   53) kernel: ralink_wifi: mt7603: restore short range interference
   compensation for quick rate adapt.

   6.5.x
   1) build_system: add SNR-CPE-CG1 prototype support.
   2) busybox: update to 1.27.2 stable version.
   3) dnsmasq: update to 2.78 stable version.
   4) handoff: change defaults for more smooth client migration.
   5) defaults: disable FT over DS and resource request support by default
   (compat with some clients issue).
   6) defaults: increase FT key life time to one hour.
   7) init.d: add change flow control logic (pause frame support disabled by
   default).
   8) init.d: fix pppoe work with *_vlan ports mode.
   9) init.d: chillispot allow access local clients by mac without radius
   check if configured.
   10) goahead: add flow control webui and fix reboot logic at apply switch
   changes.
   11) goahead: fix regression crash at apply settings in some cases.
   12) goahead: libwive: fix lanauth status get.
   13) goahead: libwive: fix crash at apscan in some cases.
   14) cli: add easy parseble version scan report.
   15) netcwmpd: code review and some fixups.
   16) uqmi: update to currecnt version from git 19.12.2016 (commit
   3c5d5a61). 17) libubox: update to currecnt version from git 15.09.2017
   (commit 5c3b920c).
   18) usbctl: fix cdc mode and more human readable debug.
   19) kernel: arch: introduce smp_load_acquire(), smp_store_release().
   20) kernel: mips: kprobes: flush_insn_slot should flush only if probe
   initialised.
   21) kernel: mips: kgdb: use kernel context for sleeping threads.
   22) kernel: signal: only reschedule timers on signals timers have sent.
   23) kernel: compiler: allow 1- and 2-byte smp_load_acquire() and
   smp_store_release().
   24) kernel: locking, arch: use WRITE_ONCE()/READ_ONCE() in
   smp_store_release()/smp_load_acquire().
   25) kernel: futex: replace barrier() in unqueue_me() with READ_ONCE().
   26) kernel: list: use READ_ONCE() when testing for empty lists.
   27) kernel: cpumask: fix spurious cpumask_of_node() on non-NUMA multi-node
   configs.
   28) kernel: epoll: fix race between ep_poll_callback(POLLFREE) and
   ep_free()/ep_remove().
   29) kernel: usb: core: avoid race of async_completed() w/
   usbdev_release().
   30) kernel: driver core: bus: fix a potential double free.
   31) kernel: keys: fix dereferencing NULL payload with nonzero length.
   32) kernel: module: fix sprintf format specifier in param_get_byte().
   33) kernel: net: add kfree_skb_list().
   34) kernel: net: prevent sign extension in dev_get_stats().
   35) kernel: net: use 32-bit arithmetic while allocating net device.
   36) kernel: net: set sk_prot_creator when cloning sockets to the right
   proto.
   37) kernel: net: af_packet: use setup_timer() helper.
   38) kernel: net: ping: do not abuse udp_poll().
   39) kernel: net: netfilter: ctnetlink: fix incorrect nf_ct_put during hash
   resize.
   40) kernel: net: tcp: initialize rcv_mss to TCP_MIN_MSS instead of 0.
   41) kernel: net: tcp: fix wraparound issue in tcp_lp.
   42) kernel: net: ipv6: ip6_tunnel: fix missing tunnel encapsulation limit
   option.
   43) kernel: net: ipv6: need to export ipv6_push_frag_opts for tunneling
   now.
   44) kernel: net: ipv6: fix leak in ipv6_gso_segment().
   45) kernel: net: ipv6: only call ip6_route_dev_notify() once for
   NETDEV_UNREGISTER.
   46) kernel: net: ipv6: accept 64k - 1 packet length in
   ip6_find_1stfragopt().
   47) kernel: net: ipv6/dccp: do not inherit ipv6_mc_list from parent.
   48) kernel: net: ipv4: better IP_MAX_MTU enforcement.
   49) kernel: net: ipv4: dccp/tcp: do not inherit mc_list from parent.
   50) kernel: net: ipv4/ip_output: fix crash on SMB fastpath.
   51) kernel: net: xfrm: policy: check policy direction value.
   52) kernel: net: xfrm: fix memory leak of aead algorithm name.
   53) kernel: net: xfrm_user: validate XFRM_MSG_NEWAE XFRMA_REPLAY_ESN_VAL
   replay_window.
   54) kernel: net: xfrm_user: validate XFRM_MSG_NEWAE incoming ESN size
   harder.
   55) kernel: ralink_arch: pci: add support use different PERST_N pin
   (GPIO17) to reset external PCIe slot peripherals.
   56) kernel: ralink_arch: pci: increase init timeouts for more stable pci
   devices detect.
   57) kernel: ralink_raeth: fix change flow control by ethtool for MT7621.
   58) kernel: ralink_wifi: fast rate up at hibryd rule at low PER to.
   59) kernel: ralink_wifi: 3 seconds increase kick out delay for high
   traffic clients (more smooth roam).
   60) kernel: ralink_wifi: send reject to client in temp block after kick
   logic (more fast client switch to new AP).
   61) kernel: ralink_wifi: skip clients with rssi == -127 from kickout logic
   (may be not get rssi sample from bbp for now).
   62) kernel: ralink_wifi: use max rssi for avoid unneeded kickout by level
   diviation of chains.
   63) kernel: ralink_wifi: add new honor P8 oui A8:C8:3A to BCM bug
   workaround.
   64) kernel: ralink_wifi: mt7603: fix soft one sec counters work (need for
   interference compensation logic).
   65) kernel: ralink_wifi: mt7603: fix drvclose procedure.
   66) kernel: ralink_wifi: mt7603: use PSE reset instead of PDMA reset.

   6.6.x
   1) lldpd: up to 0.9.8 version.
   2) quagga: up to 1.2.2 version.
   3) strace: up to 4.19 version.
   4) tcpdump: up to 4.9.2 version.
   5) libcurl: up to 7.56.0 version.
   6) nodogsplash: sync with git version (commit 0b9b8f04).
   7) goahead: do not touch route parse every page load.
   8) goahead: fix parse route interface name.
   9) goahead: more strong hostname test in dhcp page.
   10) cli: add wl scan_result command for view last scan results without new
   scan.
   11) bndstr: fix delete entry logic.
   12) bndstr: improve dissallow 2.4GHz logic after fallback.
   13) bndstr: do not allow 2.4GHz by low RSSI if station current not have
   auth stat in this AP (safe roaming).
   14) libwive: import more functions from others places.
   15) init.d: fix read nedgw from file in some cases.
   16) init.d: rework vpn route modify logic, fix for static ip at wan mode.
   17) init.d: rework prepare route modify logic.
   18) init.d: add test vpn server in local network, for prevent unneded
   route add.
   19) kernel: revert: tcp: Apply device TSO segment limit earlier and reduce
   the bloat caused by tcp_is_cwnd_limited().
   20) kernel: vt: fix unchecked __put_user() in tioclinux ioctls.
   21) kernel: fs/seq_file: fix out-of-bounds read.
   22) kernel: fs/dcache.c: fix spin lockup issue on nlru->lock.
   23) kernel: net: core: prevent from dereferencing null pointer when
   releasing SKB.
   24) kernel: net: packet: check length in getsockopt() called with
   PACKET_HDRLEN.
   25) kernel: net: 8021q: skip packets if the vlan is down.
   26) kernel: net: ipmr, ip6mr: fix scheduling while atomic and a deadlock
   with ipmr_get_route.
   27) kernel: net: netfilter: nf_nat_snmp: Fix panic when snmp_trap_helper
   fails to register.
   28) kernel: net: tcp_yeah: don't set ssthresh below 2.
   29) kernel: net: af_unix: fix struct pid memory leak.
   30) kernel: net: bpf: remove duplicate tcp_filter hook in ipv6.
   31) kernel: net: ipv4/fib: don't warn when primary address is missing if
   in_dev is dead.
   32) kernel: net: ipv6: send NS for DAD when link operationally up.
   33) kernel: net: ipv6: xfrm: handle errors reported by
   xfrm6_find_1stfragopt().
   34) kernel: net: unix: properly account for FDs passed over unix sockets.
   35) kernel: net: unix: correctly track in-flight fds in sending process
   user_struct.
   36) kernel: ralink_wifi: do not check BW in skip overlap bss scan logic.
   37) kernel: ralink_wifi: always try asic anable bss sync at VIF up if
   RD_MODE normal.
   38) kernel: ralink_wifi: skip IEEE 802.3 header if present. 802.3 header
   is front of LCC.
   39) kernel: ralink_wifi: announce 80MHz in VHT_CAP_IE only if BBP real in
   80MHz mode.
   40) kernel: ralink_wifi: fix force announce critical AMPDU for DHCP
   packets.
   41) kernel: ralink_wifi: do not keep dupe of critical packets.
   42) kernel: ralink_wifi: apcli/ft: key reinstallation attacks: forcing
   Nonce Reuse in WPA2.
   43) kernel: ralink_wifi: apcli: for VHT40 ApClient, add the OP Noitfy IE
   to notify rootAP the STA current BW.
   44) kernel: ralink_wifi: apcli: fix check channel in select candidate AP
   for connect.
   45) kernel: ralink_wifi: apcli: mt7610: fix BW adjust.
   46) kernel: ralink_wifi: rrm: do not skip beacon from row channels, if
   beacon decoded must be insert to scantab with low prio (auto sort).
   47) kernel: ralink_wifi: rrm: in RRM mode need skip AP with level < -85dB
   from scantab.
   48) kernel: ralink_wifi: ft: add backward compatable with not patched
   802.11R support clients.
   49) kernel: ralink_wifi: mt76x2: fix read STBC params from SKU.
   50) kernel: ralink_wifi: mt76x2: update firmware.
   51) kernel: ralink_wifi: mt7603: fix the memory leak caused by miss
   setting fRX_RETRIEVE.
   52) kernel: ralink_wifi: mt7603: fix the memory leak by resource prealloc
   logic.
   53) kernel: ralink_wifi: mt7603: fix rateadapt regression.
   54) kernel: ralink_wifi: mt76x2/mt7603: fix potenlional null pointer
   dereference in cmm wpa.
   55) kernel: ralink_wifi: mt7620/mt7610: switch to use SNR_FORMULA3 (sta).
   56) kernel: ralink_wifi: mt7620/mt7610: fix apcli beacon mask (sta).
   57) kernel: ralink_wifi: mt7620/mt7610: add MDIE to updates beacon to.

   6.7.x
   1) build_system: toolchain: headers up and rebuild.
   2) configs: add support i2c for CG1 (need for SFP control).
   3) defaults: more smooth handoff and agressive band steering parametrs by
   default.
   4) add sfppi tool for work with SFP module EEPROM.
   5) add sfp-i2c tool for get params from SFP module.
   6) openssl: up to 1.0.2m version.
   7) entware: switch to Entware3 version.
   8) irqbalabce: fix build without libcap-ng.
   9) netcwmpd: more compath with Eltex ACS.
   10) nvram: fix potentioanl null pointer dereference.
   11) defaults: chillispot: enable https rederect to default (need for new
   OS`s and work normal for now).
   12) init.d: rework automount and start/stop Entware services.
   13) init.d: syslog: use locally and via network instead of network only if
   enabled.
   14) init.d: basic support external phy at RGMII 2.
   15) init.d: rewrite switch init/link logic.
   16) init.d: rewrite 3G/4G modems support logic.
   17) init.d: add calc txqlen by mode.
   18) init.d: add create node for i2c controller.
   19) init.d: auto tune txqlen for chillispot tun interface to.
   20) init.d: add support dual band MBSSID mode.
   21) init.d: apply handoff settings for all real used MBSSID.
   22) init.d: rework mask for hwsnooping.
   23) init.d: force M2U for LAN and WIFI enable if TV/SIP ports configured.
   24) init.d: rework internal switch reinit, avoid double work and more
   readable code.
   25) init.d: internet.sh: stop vlan early for avoid busy at radio
   reconfigure.
   26) goahead: refactoring and fixup route page.
   27) goahead: fix ports number issue in ME1.
   28) goahead: fix reboot counter at firmware update.
   29) goahead: add MBSSID all bands support.
   30) goahead: timezone fixes.
   31) goahead: fix modem reconnect.
   32) goahead: fix vlan page supported vlan to wlan modes.
   33) goahead: fix default auto channel select mode.
   34) goahead: add show selected channel to webui.
   35) kernel: signal: move the "sig < SIGRTMIN" check into siginmask(sig).
   36) kernel: fcntl: don't use ambiguous SIG_POLL si_codes.
   35) kernel: kernel/extable.c: mark core_kernel_text notrace.
   37) kernel: sched/core: remove pointless printout in sched_show_task().
   38) kernel: sched: make resched_cpu() unconditional.
   39) kernel: arch: remove unused macro/function thread_saved_pc().
   40) kernel: cfg80211/wext: fix message ordering.
   41) kernel: block: relax a check in blk_start_queue().
   42) kernel: genirq: make sparse_irq_lock protect what it should protect.
   43) kernel: modpost: expand pattern matching to support substring matches.
   44) kernel: modpost: don't emit section mismatch warnings for compiler
   optimizations.
   45) kernel: mm/mempolicy: fix use after free when calling get_mempolicy.
   46) kernel: mm/init: fix zone boundary creation.
   47) kernel: keys: prevent KEYCTL_READ on negative key.
   48) kernel: keys: don't let add_key() update an uninstantiated key.
   49) kernel: keys: trusted: sanitize all key material.
   50) kernel: keys: trusted: fix writing past end of buffer in
   trusted_read().
   51) kernel: wext: unregister_pernet_subsys() on notifier registration
   failure.
   52) kernel: wext: uninline stream addition functions.
   53) kernel: wext: use struct iwreq earlier in the call chain.
   54) kernel: wext: dev_ioctl: copy only the smaller struct iwreq for wext.
   55) kernel: ralink_raeth: add support wakeup external phy from standby
   over gpio.
   56) kernel: ralink_raeth: add preconfig for RTL8211D.
   57) kernel: ralink_raeth: add SFP module enable by gpio logic.
   58) kernel: ralink_raeth: add SFP gpio lines init.
   59) kernel: ralink_raeth: add mdio line switch support for mdio access
   isolate.
   60) kernel: ralink_raeth: increase MDIO driving to 4mA for ExtMDIO control
   by GPIO.
   61) kernel: ralink_raeth: more correct mdio isolate.
   62) kernel: ralink_raeth: disable extPHY mdio at ifdown.
   63) kernel: ralink_raeth: add preconfig modeset by sysctl.
   64) kernel: ralink_raeth: disable EEE LPI for ExtPHY to.
   65) kernel: ralink_raeth: rework preconfig and ExtPHY reset procedure.
   66) kernel: ralink_wifi: allways use 256/128 tx/rx ring sizes schem.
   67) kernel: ralink_wifi: dynamic calculate kickout delay for high traffic
   clients.
   68) kernel: ralink_wifi: always use max rssi for streams in band steering
   and handoff logic (avoid stream diviation).
   69) kernel: ralink_wifi: collect very low level probe req only for 5GHz.
   70) kernel: ralink_wifi: more info handoff kickout log.
   71) kernel: ralink_wifi: increase kickout delay only if have transmit data
   to clients at last 5 seconds.
   72) kernel: ralink_wifi: move ralink specific IE to true place.
   73) kernel: ralink_wifi: clear BeaconTransmit before set new params in
   RTMPWriteTxWI.
   74) kernel: ralink_wifi: rearrange update beacon logic.
   75) kernel: ralink_wifi: ignore very low RSSI station at scan for auto
   channel select (<-90dB is really == background noise).
   76) kernel: ralink_wifi: 802.11k: calculate op_class if not get by scan
   for more compat with RFC.
   77) kernel: ralink_wifi: 802.11k: more correct neigh report compile.
   78) kernel: ralink_wifi: 802.11k: add sanity check and correction data
   from BCN.
   79) kernel: ralink_wifi: 802.11k: fix TSF reports.
   80) kernel: ralink_wifi: 802.11k: do not announce quiet support if not
   enabled by complile.
   81) kernel: ralink_i2c: fix build and warnings.
   82) kernel: fs: cache: fix dereference of NULL user_key_payload.
   83) kernel: fs: leak in O_DIRECT readv past the EOF.
   84) kernel: fs: fuse: initialize the flock flag in fuse_file on
   allocation.
   85) kernel: fs: fix unbalanced page refcounting in bio_map_user_iov.
   86) kernel: fs: ext4: validate s_first_meta_bg at mount time.
   87) kernel: fs: ext4: fix fencepost in s_first_meta_bg validation.
   88) kernel: mips: replace smp_mb with release barrier function in unlocks.
   89) kernel: mips: add nudges to writes for bit unlocks.
   90) kernel: mips: make thread_saved_pc static.
   91) kernel: mips: fix pcibios_map_irq section mismatch.
   92) kernel: mips: fix input modify in __write_64bit_c0_split().
   93) kernel: mips: remove pt_regs adjustments in indirect syscall handler.
   94) kernel: mips: declare various variables & functions static.
   95) kernel: mips: add iomem resource for kernel bss section.
   96) kernel: usb: core: fix out-of-bounds access bug in
   usb_get_bos_descriptor().
   97) kernel: usb: hub: allow reset retry for USB2 devices on connect
   bounce.
   98) kernel: usb: fix out-of-bounds in usb_set_configuration.
   99) kernel: usb: usbtest: fix NULL pointer dereference.
   100) kernel: usb: usbhid: fix out-of-bounds bug.
   101) kernel: usb: hcd: initialize hcd->flags to 0 when rm hcd.
   102) kernel: usb: usbfs: compute urb->actual_length for isochronous.
   103) kernel: usb: serial: qcserial: add pid/vid for Sierra Wireless EM7355
   fw update.
   104) kernel: usb: qmi_wwan: fix divide by 0 on bad descriptors.
   105) kernel: usb: qmi_wwan: add missing skb_reset_mac_header-call.
   106) kernel: usb: cdc_ether: fix divide by 0 on bad descriptors.
   107) kernel: net: small increase txqlen at default and use in all drivers.
   108) kernel: net: use different txqlen for wireless and wired links
   (buffer debloat).
   109) kernel: net: vlan: fix a use-after-free in vlan_device_event().
   110) kernel: net: ipsec: do not ignore crypto err in ah4 input.
   111) kernel: net: ppp: fix race in ppp device destruction.
   112) kernel: net: tcp: fix tcp_mtu_probe() vs highest_sack.
   113) kernel: net: tcp: fix tcp_fastretrans_alert warning.
   114) kernel: net: core: improve sanity checking in __dev_alloc_name.
   115) kernel: net: core: drop pointless check in __dev_alloc_name.
   116) kernel: net: core: check dev_valid_name in __dev_alloc_name.
   117) kernel: net: core: maybe return -EEXIST in __dev_alloc_name.
   118) kernel: net: sched: fix error recovery at qdisc creation.
   119) kernel: net: sched: sch_htb: fix crash on init failure.
   120) kernel: net: sched: sch_multiq: fix double free on init failure.
   121) kernel: net: sched: sch_hfsc: fix null pointer deref and double free
   on init failure.
   122) kernel: net: sched: sch_cbq: fix null pointer dereferences on init
   failure.
   123) kernel: net: sched: sch_netem: avoid null pointer deref on init
   failure.
   124) kernel: net: sched: sch_tbf: fix two null pointer dereferences on
   init failure.
   125) kernel: net: xfrm_user: fix info leak in xfrm_notify_sa().
   126) kernel: net: xfrm_user: fix info leak in build_aevent().
   127) kernel: net: ipv6: udp: fix the checksum computation when HW checksum
   does not apply.
   128) kernel: net: ipv6: set rt6i_protocol properly in the route when it is
   installed.
   129) kernel: net: ipv6: add rt6_get_cookie() function.
   130) kernel: net: ipv6: add rcu grace period before freeing fib6_node.
   131) kernel: net: ipv6: fix may be used uninitialized warning in
   rt6_check.
   132) kernel: net: ipv6: fix sparse warning on rt6i_node.
   133) kernel: net: ipv6: flowlabel: do not leave opt->tot_len with garbage.
   134) kernel: net: ipv6: fix memory leak with multiple tables during netns
   destruction.
   135) kernel: net: tun: bail out from tun_get_user() if the skb is empty.
   136) kernel: net: tun: sanitize TUNSETSNDBUF input.
   137) kernel: net: tun: call dev_get_valid_name() before
   register_netdevice().
   138) kernel: net: tun: allow positive return values on
   dev_get_valid_name() call.
   139) kernel: net: packet: in packet_do_bind, test fanout with bind_lock
   held.
   140) kernel: net: packet: hold bind lock when rebinding to fanout hook.
   141) kernel: net: netfilter: nf_ct_expect: nf_ct_expect_insert() returns
   void.
   142) kernel: net: netfilter: nf_ct_expect: nf_ct_expect_related_report():
   return zero on success.
   143) kernel: net: netfilter: nf_ct_expect: change __nf_ct_expect_check()
   return value.
   144) kernel: net: l2tp: initialise session's refcount before making it
   reachable.
   145) kernel: net: l2tp: define parameters of l2tp_session_get*() as const.
   146) kernel: net: l2tp: hold tunnel while looking up sessions in
   l2tp_netlink.
   147) kernel: net: l2tp: hold tunnel while handling genl tunnel updates.
   148) kernel: net: l2tp: hold tunnel while handling genl TUNNEL_GET
   commands.
   149) kernel: net: l2tp: remove useless duplicate session detection in
   l2tp_netlink.
   150) kernel: net: l2tp: hold tunnel used while creating sessions with
   netlink.
   151) kernel: net: l2tp: check ps->sock before running
   pppol2tp_session_ioctl().

   6.8.x
   1) default: increase wifi idle and arp cache stale timeouts to 300 second
   (more fast clients ready after deep-sleep).
   2) miniupnpd: up to 2.0.2017121 version.
   3) netcwmpd: some fixups.
   4) cli: some fixups.
   5) goahead: full rework localization logic for remove deprecated methods.
   6) goahead: small fix preloader.gif show.
   7) goahead: eoute table now show vpn server routes with correct names.
   8) kernel: ralink_wifi: update CommonCfg.bUseShortSlotTime if changed in
   APUpdateCapabilityAndErpIe (need for correct cap generate).
   9) kernel: ralink_wifi: move conflict SSID detection to true place.
   10) kernel: ralink_wifi: clear ACK in rings for clients sended
   disassoc/deauth or FT migration procedure (decrease potentional rings
   stubs).
   11) kernel: ralink_wifi: ignore not correct disassoc/deauth req.
   12) kernel: ralink_wifi: potentioal null pointer dereference fixes in some
   places.
   13) kernel: ralink_wifi: add move notify report to log.
   14) kernel: ralink_wifi: do not send deauth to allready migrated clients
   (move notify).
   15) kernel: ralink_wifi: clear ACK in TxRing for clienst long time idle
   (1/2 of time for disconnect of dead).
   16) kernel: ralink_wifi: add new iphone v6 oui 60:F8:1D, 60:A3:7D,
   B8:E8:56 macbook air and 10:B1:F8 honor P8 to BCM bug workaround.
   17) kernel: ralink_wifi: fix bss index calc before AutoChBssEntrySet.
   18) kernel: ralink_wifi: do not clear the previous Pairwise key table at
   new assoc with FT mode (reinstall later).
   19) kernel: ralink_wifi: add BMC packet PN replay attack detection and
   prevent.
   20) kernel: ralink_wifi: enhance checking RSC value base on key index for
   replay counter attack.
   21) kernel: ralink_wifi: avoid zero PTK in FT support case.
   22) kernel: ralink_wifi: mt7610: HT_EXTINFO removed from current 802.11
   specs (disable).
   23) kernel: ralink_wifi: full ignore assoc req from B only stations if AP
   dose not support CCK(B).
   24) kernel: ralink_wifi: fix error handle in make new station assoc.
   25) kernel: ralink_wifi: dynamic alloc FtInfoBuf in assoc req action.
   26) kernel: ralink_wifi: fix null pointer dereference at wds handle path.
   27) kernel: ralink_raeth: fix reverse port calculate.
   28) kernel: NFSv4: Fix client recovery when server reboots multiple times.
   29) kernel: mm: avoid returning VM_FAULT_RETRY from ->page_mkwrite
   handlers.
   30) kernel: mm: Handle 0 flags in _calc_vm_trans() macro.
   31) kernel: ext4: fix crash when a directory's i_size is too small.
   32) kernel: don't leak a key reference if request_key() tries to use a
   revoked keyring.
   33) kernel: usb: usb: host: fix incorrect updating of offset.
   34) kernel: keys: encrypted: fix dereference of NULL user_key_payload.
   35) kernel: phy: increase size of MII_BUS_ID_SIZE and bus_id.
   36) kernel: lib/genalloc.c: make the avail variable an atomic_long_t.
   37) kernel: usbnet: fix alignment for frames with no ethernet header.
   38) kernel: net: l2tp: purge socket queues in the .destruct() callback.
   39) kernel: net: l2tp: hold tunnel in pppol2tp_connect().
   40) kernel: net: l2tp: remove l2tp_session_find().
   41) kernel: net: l2tp: remove useless device duplication test in
   l2tp_eth_create().
   42) kernel: net: l2tp: fix race between l2tp_session_delete() and
   l2tp_tunnel_closeall().
   43) kernel: net: ppp: declare PPP devices as LLTX.
   44) kernel: net: ppp: avoid dealock on recursive xmit.
   45) kernel: net: ppp: remove unnecessary bh disable in xmit path.
   46) kernel: net: ppp: fix false xmit recursion detect with two ppp
   devices.
   47) kernel: net: ppp: fix a scheduling-while-atomic bug in del_chan.
   48) kernel: net: ppp: fix xmit recursion detection on ppp channels.
   49) kernel: net: ppp: fix __percpu annotation.
   50) kernel: net: ppp: destroy the mutex when cleanup.
   51) kernel: net: packet: fix a race in packet_bind() and
   packet_notifier().
   52) kernel: net: xfrm: copy policy family in clone_policy.
   53) kernel: net: set tw_refcnt in __inet_twsk_hashdance(), we need to call
   inet_twsk_schedule() first.
   54) kernel: net: tcp/dccp: block bh before arming time_wait timer.
   55) kernel: net: icmp: don't fail on fragment reassembly time exceeded.
   56) kernel: net: ipv4: ipv4_default_advmss() should use route mtu.

   7.0.x
   1) configs: disable transmission build (need update in future).
   2) configs: disable wpa supplicant build in 16Mb flash devices (not used).
   3) busybox: update to 1.28.0 version.
   4) bndstrg: fix uninit variable and cleanup.
   5) init.d: if rrm/ft enables tune arp/bridge for more fast cache rearrange
   and arp/rp filters disables on APs in bridge mode.
   6) init.d: fix iptables rules generate at lanauth mode.
   7) goahead: fix stupid bug (free for static allocation).
   8) kernel: kernel/acct.c: fix the acct->needcheck check in
   check_free_space().
   9) kernel: vfs: return -ENXIO for negative SEEK_HOLE / SEEK_DATA offsets.
   10) kernel: nfsd: update mtime on truncate.
   11) kernel: cifs: small underflow in cnvrtDosUnixTm().
   12) kernel: futex: drop refcount if requeue_pi() acquired the rtmutex.
   13) kernel: futex: prevent overflow by strengthen input validation.
   14) kernel: fscache: Fix the default for fscache_maybe_release_page().
   15) kernel: genksyms: Handle string literals with spaces in reference
   files.
   16) kernel: module: keep percpu symbols in module's symtab.
   17) kernel: mm/mmu_context, sched/core: fix mmu_context.h assumption.
   18) kernel: mm/mprotect: add a cond_resched() inside change_pmd_range().
   19) kernel: sched/core: add switch_mm_irqs_off() and use it in the
   scheduler.
   20) kernel: sched/core: Idle_task_exit() shouldn't use
   switch_mm_irqs_off().
   21) kernel: scsi: sd: fix capacity calculation with 32-bit sector_t.
   22) kernel: scsi: sr: sanity check returned mode data.
   23) kernel: kernel/signal.c: protect the traced SIGNAL_UNKILLABLE tasks
   from SIGKILL.
   24) kernel: kernel/signal.c: protect the SIGNAL_UNKILLABLE tasks from
   !sig_kernel_only() signals.
   25) kernel: kernel/signal.c: remove the no longer needed SIGNAL_UNKILLABLE
   check in complete_signal().
   26) kernel: ext4: validate that metadata blocks do not overlap superblock.
   27) kernel: ext4: sanity check the block and cluster size at mount time.
   28) kernel: ext4: reject inodes with negative size.
   29) kernel: ext4: add sanity checking to count_overhead().
   30) kernel: ext4: use more strict checks for inodes_per_block on mount.
   31) kernel: ext4: fix in-superblock mount options processing.
   32) kernel: ext4: fix reference counting bug on block allocation error.
   33) kernel: ext4: trim allocation requests to group size.
   34) kernel: ext4: use private version of page_zero_new_buffers() for
   data=journal mode.
   35) kernel: ext4: fix data corruption in data=journal mode.
   36) kernel: ext4: preserve the needs_recovery flag when the journal is
   aborted.
   37) kernel: ext4: keep existing extra fields when inode expands.
   38) kernel: ext4: fix data corruption for mmap writes.
   39) kernel: ext4: fix fdatasync(2) after extent manipulation operations.
   40) kernel: usb: core: prevent malicious bNumInterfaces overflow.
   41) kernel: usb: core: allow zero packet flag for interrupt urbs.
   42) kernel: usb: usbnet: remove unused driver_name variable.
   43) kernel: usb: usbnet: make sure no NULL pointer is passed through.
   44) kernel: usb: xhci: fix finding correct bus_state structure for USB 3.1
   hosts.
   45) kernel: usb: xhci: add support for URB_ZERO_PACKET to bulk/sg
   transfers.
   46) kernel: usb: cdc_ether: flag the Huawei ME906/ME909 as WWAN.
   47) kernel: usb: cdc-acm: Do not log urb submission errors on disconnect.
   48) kernel: usb: cdc_ncm: constify attribute_group structures.
   49) kernel: usb: cdc_ncm: reduce memory use when kernel memory low.
   50) kernel: usb: cdc_ncm: flag the u-blox TOBY-L4 as wwan.
   51) kernel: usb: cdc_ncm: set NTB format again after altsetting switch for
   Huawei devices.
   52) kernel: usb: cdc_ncm: GetNtbFormat endian fix.
   53) kernel: usb: cdc_mbim: add quirk for supporting Telit LE922A.
   54) kernel: usb: cdc_mbim: apply NDP to end quirk to HP lt4132.
   55) kernel: usb: serial: option: add two Longcheer device ids.
   56) kernel: usb: serial: option: add support for D-Link DWM-157 C1.
   57) kernel: usb: serial: option: simplify 3 D-Link device entries.
   58) kernel: usb: serial: option: add support for Telit ME910 PID 0x1101.
   59) kernel: usb: serial: console: fix use-after-free after failed setup.
   60) kernel: usb: serial: io_edgeport: fix possible sleep-in-atomic.
   61) kernel: usb: qmi_wwan: set FLAG_SEND_ZLP to avoid network initiated
   disconnect.
   62) kernel: usb: qmi_wwan: add Telit ME910 PID 0x1101 support.
   63) kernel: usb: qmi_wwan: add USB IDs for MDM6600 modem on Motorola Droid
   4.
   64) kernel: usb: usbip: set buffer pointers to NULL after free.
   65) kernel: usb: usbip: fix nonconforming hub descriptor.
   66) kernel: usb: increase quirk delay for USB devices.
   67) kernel: usb: pci-quirks.c: Corrected timeout values used in handshake.
   68) kernel: usb: usb-storage: unusual_devs entry to fix write-access
   regression for Seagate external drives.
   69) kernel: usb: fix typo in the definition of Endpoint[out]Request.
   70) kernel: net: net_sched: always reset qdisc backlog in qdisc_reset().
   71) kernel: net: ipsec: Fix aborted xfrm policy dump crash.
   72) kernel: net: enable interface alias removal via rtnl.
   73) kernel: net: l2tp: fix l2tp_eth module loading.
   74) kernel: net: l2tp: hold socket before dropping lock in l2tp_ip{,
   6}_recv().
   75) kernel: net: l2tp: hold tunnel socket when handling control frames in
   l2tp_ip and l2tp_ip6.
   76) kernel: net: l2tp: don't use l2tp_tunnel_find() in l2tp_ip and
   l2tp_ip6.
   77) kernel: net: packet: only test po->has_vnet_hdr once in packet_snd.
   78) kernel: net: inet: frag: release spinlock before calling icmp_send().
   79) kernel: net: tcp md5sig: use skb's saddr when replying to an incoming
   segment.
   80) kernel: net: 8021q: fix a memory leak for VLAN 0 device.
   81) kernel: net: ipv6: icmp6: allow icmp messages to be looped back.
   82) kernel: net: ipv6: mcast: better catch silly mtu values.
   83) kernel: net: ipv6: ip6_tunnel: disable dst caching if tunnel is
   dual-stack.
   84) kernel: net: ipv6: send unsolicited NA after DAD.
   85) kernel: net: ipv6: fix udpv6 sendmsg crash caused by too small MTU.
   86) kernel: net: ipv4: igmp: use correct source address on IGMPv3 reports
   (RFC 3376).
   87) kernel: net: ipv4: igmp: guard against silly MTU values.
   88) kernel: net: ipv4: Make neigh lookup keys for loopback/point-to-point
   devices be INADDR_ANY.
   89) kernel: net: pppoe: take ->needed_headroom of lower device into
   account on xmit.
   90) kernel: net: igmp: fix source address check for IGMPv3 reports.
   91) kernel: net: igmp: add a missing rcu locking section.
   92) kernel: net: allow neigh contructor functions ability to modify the
   primary_key.
   93) kernel: net: af_key: fix buffer overread in parse_exthdrs().
   94) kernel: net: af_key: fix buffer overread in verify_address_len().
   95) kernel: net: netfilter: nf_ct_expect: remove the redundant slash when
   policy name is empty.
   96) kernel: net: tcp: __tcp_hdrlen() helper.
   97) kernel: net: qdisc_pkt_len_init() should be more robust.
   98) kernel: sd: get disk reference in sd_check_events().
   99) kernel: bitops.h: add sign_extend64().
   100) kernel: pipe: avoid round_pipe_size() nr_pages overflow on 32-bit.
   101) kernel: ipc: msg, make msgrcv work with LONG_MIN.
   102) kernel: ralink_wifi: fix disable OLBC detection (use this mode by
   default).
   103) kernel: ralink_wifi: use different rssi threshold for
   olbc/bndstr/rrm/scan.
   104) kernel: ralink_wifi: add new iphone 6s and one pluse one 5 OUI to
   80MHz workaround.
   105) kernel: ralink_wifi: small cleanup and refactor mt7610 headers.
   106) kernel: ralink_wifi: roam: add resend L2 update frame after auth
   success (prevent DS arp tables unconistent with preauth support clients).
   107) kernel: ralink_wifi: rrm: small tune rssi thresholds for
   rrm/auto_channel select.
   108) kernel: ralink_wifi: rrm: improve rrm networks rescan and scan at
   boot (tune timeouts and switch to active mode).
   109) kernel: ralink_wifi: rrm: do not allow connect before bootup scan
   complete.
   110) kernel: mips: page.h: define virt_to_pfn().
   111) kernel: mips: remove memory clobber from non-octeon version of
   nudge_writes().
   112) kernel: mips: fix an off-by-one in dma_capable.
   113) kernel: mips: setup boot_command_line before plat_mem_setup.
   114) kernel: mips: fix execution hazard during watchpoint register probe.

   7.1.x
   1) goahead: fix hide WINS page (duplicate options full samba page).
   2) goahead: new style NAG topbar and menu font fix.
   3) goahead: allow flow control change at 100Mbit devices.
   4) busybox: update to 1.28.1 stable version.
   5) dnsmasq: update to 2.79rc1 version.
   6) miniupnpd: up to 2.0.20180203 version.
   7) ethtool: update to 4.15 version.
   8) freeradius: up to 3.0.16 version.
   9) lldpd: up to 0.9.9 version.
   10) quagga: up to 1.2.4 version.
   11) strace: up to 4.21 version.
   12) usb-modeswitch: update to 2.5.2 version.
   13) xupnpd: sync core with upsatream (commit 860fd90e 18 Feb 2018).
   14) make fq_codel as static and use per default now (very long tests at
   home and office with any troubles).
   15) init.d: increase AdvPreferredLifetime and AdvValidLifetime.
   16) init.d: radvd reload config by HUP signal if need instead of full
   restart.
   17) kernel: ralink_arch: MT7620/MT7621/MT7628: fix create PCIe BAR0
   window.
   18) kernel: ralink_wdg: add watchdog by userspace control driver.
   19) kernel: ralink_raeth: disabe FC for cpu ports for 7620 to.
   20) kernel: disable webstr support, now all target sites have https
   version (webstr filter only http).
   21) kernel: usbnet: silence an unnecessary warning.
   22) kernel: compiler-gcc.h: Introduce __optimize function attribute.
   23) kernel: compiler-gcc.h: __nostackprotector needs gcc-4.4 and up.
   24) kernel: rtc: interface: ignore expired timers when enqueuing new
   timers.
   25) kernel: rtc: set the alarm to the next expiring timer.
   26) kernel: crypto: hmac - require that the underlying hash algorithm is
   unkeyed.
   27) kernel: crypto: salsa20 - fix blkcipher_walk API usage.
   28) kernel: crypto: shash - fix zero-length shash ahash digest crash.
   29) kernel: crypto: talitos - fix sha224.
   30) kernel: net: l2tp: hold tunnel while processing genl delete command.
   31) kernel: net: ip6mr: fix stale iterator.
   32) kernel: net: dccp: CVE-2017-8824: use-after-free in DCCP code.
   33) kernel: net: don't call update_pmtu unconditionally.
   34) kernel: net: pkt_sched: fix warning false positives.
   35) kernel: net: xfrm: fix stack access out of bounds with
   CONFIG_XFRM_SUB_POLICY.
   36) kernel: net: xfrm: check id proto in validate_tmpl().
   37) kernel: net: xfrm: fix stack-out-of-bounds with misconfigured
   transport mode policies.
   38) kernel: net: sched: qdisc: allow setting default queuing discipline.
   39) kernel: net: sched: qdisc: make args to qdisc_create_default const.
   40) kernel: net: sched: qdisc: fix build with !CONFIG_NET_SCHED.
   41) kernel: net: sched: qdisc: fix a module refcount leak in
   qdisc_create_dflt().
   42) kernel: net: sched: use pfifo_fast for non real queues.
   43) kernel: net: sched: filters: fix notification of filter delete with
   proper handle.
   44) kernel: net: sched: fix error recovery at qdisc creation lost fix.
   45) kernel: net: sched: sch_fq_codel: avoid double free on init failure.
   46) kernel: net: netfilter: x_tables: validate e->target_offset early.
   47) kernel: net: netfilter: x_tables: fix 32bit compat layer.
   48) kernel: net: netfilter: xt_TCPOPTSTRIP: fix possible mangling beyond
   packet boundary.
   49) kernel: net: netfilter: xt_TCPOPTSTRIP: don't use tcp_hdr().
   50) kernel: net: netfilter: x_tables: fix int overflow in
   xt_alloc_table_info().
   51) kernel: net: netfilter: x_tables: avoid out-of-bounds reads in
   xt_request_find_{match|target}.
   52) kernel: net: netfilter: ipt_CLUSTERIP: fix out-of-bounds accesses in
   clusterip_tg_check().
   53) kernel: net: netfilter: on sockopt() acquire sock lock only in the
   required scope.
   54) kernel: net: netfilter: drop outermost socket lock in getsockopt().
   55) kernel: ralink_wifi: prevent txpower calculate and annouce issue in
   fabric case.
   56) kernel: ralink_wifi: rrm: use minrssi for calculate TPC link margin.
   57) kernel: ralink_wifi: rrm: disable RRMNeighborReport TSF element (break
   compat with new wpa_supplicant and android 8 implementation, wait final
   RFC).
   58) kernel: ralink_wifi: increase default pmk cahce period to 8hour ~ one
   work day, for more roam smooth in offices.

   7.2.x
   1) build_system: toolchain: headers up and rebuild.
   2) build_system: libnatpmp: add symlinks to so.0,so.1 (fix transmission
   link).
   3) busybox: update to 1.28.2 stable version.
   4) libusb: update to 1.21 version.
   5) libtalloc: update to 2.1.11 version.
   6) openssl: up to 1.0.2o version.
   7) libmicrohttpd: update to 0.9.59 version.
   8) libcurl: update to 7.58.0 version.
   9) dropbear: update to 2018.76 version.
   10) xl2tpd: update to 1.3.10.1 version (commit 767f33e3).
   11) nodogsplash: update to 2.0.1 version (commit 461fa24f).
   12) coovachilli: up to 1.4 from git (commit f3f7b49c).
   13) dnsmasq: update to 2.79 release version.
   14) bndstr: fix jam RRM vs BNDSTR init.
   15) eoip: add control util.
   16) dhcpv6: add a bit info to logger when get OPTION_RECONF_ACCEPT(20)
   dhcpv6 option.
   17) init.d: disable tcp_loose and a drop invalid state connections in
   input chain (deflect ACK/ACK+SYN flood attacks).
   18) init.d: fix lan to wlan bridge isolate mode work.
   19) init.d: fix L2TP server work in dual net and apcli modes.
   20) init.d: rewrite samba wait stop logic.
   21) init.d: automount: fix ext4 module load for support ext2/3 FS.
   22) init.d: dhcp script: fix full renew mode work at routes changed.
   23) init.d: dhcp script: force full renew after dhcp fail.
   24) init.d: dhcp script: force start pppoe in dhcp fail case if not
   started in normal path.
   25) init.d: samba: fix auto share last media part for all.
   26) init.d: add l2tp v3 eth bridge mode tunnel support.
   27) init.d: add eoip eth bridge mode tunnel support.
   28) init.d: iaap: sysctl: tune only timeouts, not touch arp/rp filters
   mode (not need for now).
   29) init.d: remove mount point after manual umount.
   30) init.d: config-vlan.sh: fix skip wan_phy logic.
   31) libwive: fix potentional null pointer dereference or out of range
   issue.
   32) goahead: fix potentioanl null pointer dereferences in some cases.
   33) goahead: fix wds page remove links logic.
   34) goahead: hide wlan2lan isolate in full bridget modes.
   35) goahead: limit tcp backlog.
   36) dhcp6s: add support reload configs by SIGHUP and use it.
   37) ralinkiappd: increase tcp conection backlog to 72 connections.
   38) kernel: ralink_arch: add delay after pci-e phy reconfigure.
   39) kernel: ralink_wifi: increase pmk chache id entries to 128.
   40) kernel: ralink_wifi: add new iphone6 oui 50:A6:7F and 6C:72:E7 to bcm
   workaround.
   41) kernel: ralink_wifi: move L2 update send frame to more true place.
   42) kernel: ralink_wifi: optimize call clear tx rings ack before delete
   mactab record.
   43) kernel: ralink_wifi: fix allowToSend init by default.
   44) kernel: ralink_wifi: fix potentional null pointer dereference in
   mactable managment.
   45) kernel: ralink_wifi: fix potentional null pointer dereference in more
   places of decode managment frames.
   46) kernel: ralink_wifi: do not change response code by handoff or band
   steering if status allready not success (correct reject reason send to
   client).
   47) kernel: ralink_wifi: avoid dead record before ageouted in mactable for
   rejected clients.
   48) kernel: ralink_wifi: decrease noise debug, remove class 2-3 errors
   flood.
   49) kernel: ralink_wifi: update WMM capable flag in
   update_associated_mac_entry to.
   50) kernel: ralink_wifi: init GI as 800 per default, replaced by ra_ctl.
   51) kernel: ralink_wifi: add lost out of bounds checks.
   52) kernel: ralink_wifi: always use pEntry->wcid instead of pEntry->Aid in
   sta delete case (new api compat and more safe).
   53) kernel: ralink_wifi: add new honor9 oui 5С:C3:07 bcm fix.
   54) kernel: ralink_wifi: fix extCapInfo init in probe path.
   55) kernel: ralink_wifi: mt7610: fix potentional use after free.
   56) kernel: ralink_wifi: rrm: semi enable quiet support (without real tx
   stops).
   57) kernel: ralink_wifi: rrm: can not insert in report list station
   without ssid.
   58) kernel: ralink_wifi: rrm: full disable channel switch dfs based works.
   59) kernel: ralink_wifi: ft: silencely discard frame from FT clients
   without FT procedure use in assoc.
   60) kernel: ralink_wifi: bndstr: prevent multiple records insert for one
   client.
   61) kernel: ralink_wifi: bndstr: skip steering probe req`s from SNR APs
   neigh scan for RRM.
   62) kernel: kconfig.h: use __is_defined() to check if MODULE is defined.
   63) kernel: mm: fix false-positive VM_BUG_ON() in
   page_cache_{get,add}_speculative().
   64) kernel: net: fix race on decreasing number of TX queues.
   65) kernel: net: make ip_ra_chain per struct net.
   66) kernel: net: move IP_ROUTER_ALERT out of lock_sock(sk).
   67) kernel: net: replace ip_ra_lock with per-net mutex.
   68) kernel: net: ip6_tunnel: get the min mtu properly in ip6_tnl_xmit.
   69) kernel: net: ipv6 sit: work around bogus gcc-8 -Wrestrict warning.
   70) kernel: net: ipv4: don't allow setting net.ipv4.route.min_pmtu below
   68 (RFC1191).
   71) kernel: net: ipv4: rcu cleanup in ip_ra_control().
   72) kernel: net: ipv4: only compute net once in ip_call_ra_chain.
   73) kernel: net: bridge: fix early call to br_stp_change_bridge_id and
   plug newlink leaks.
   74) kernel: net: conntrack: tcp_options: not need bug on if ptr is null.
   This case handled in upcode.
   75) kernel: net: netfilter: nf_conntrack_tcp: fix stack out of bounds when
   parsing TCP options.
   76) kernel: net: netfilter: drop template ct when conntrack is skipped.
   77) kernel: net: netfilter: nat: cope with negative port range.
   78) kernel: net: tcp: purge write queue upon RST.
   79) kernel: net: ppp: prevent unregistered channels from connecting to PPP
   units.
   80) kernel: net: tcp: sysctl: fix a race to avoid unexpected 0 window from
   space.
   81) kernel: net: bridge: check brport attr show in brport_show.
   82) kernel: net: fib_semantics: don't match route with mismatching
   tclassid.
   83) kernel: net: ip_gre: dont increase dev->needed_headroom on a live
   device.
   84) kernel: net: eoip: initial support.
   85) kernel: net: eoip: add fragmentation output support.
   86) kernel: net: enable l2tp_v3 support.
   87) kernel: net: xfrm: allow clearing socket xfrm policies.
   88) kernel: net: l2tp: do not accept arbitrary sockets.

   7.3.x
   1) build_system: toolchain: headers up and rebuild.
   2) build_system: cleanup of unused target and code.
   3) build_system: fix dependensy xupnpd of openssl.
   4) build_system: rework and update backups calibs.
   5) build_system: add new MD1.2 model with new FEM.
   6) configs: cleanup build configs and small decrease RWFS size for 8Mb
   flash devices (640k->512k).
   7) configs: enable napi GRO for all devices.
   8) defaults: enable igmpproxy by default (more 60% users enable this
   option for iptv, must be safe).
   9) defaults: fc mode set to auto by default (avoid drops with strong fc on
   mode hardware with 100FD ports).
   10) miniupnpd: update to 2.0.20180422 version.
   11) busybox: update to 1.28.3 stable version.
   12) nodogsplash: update to 2.0.1 version (commit 04f84839).
   13) xl2tpd: update to 1.3.11 version (commit caec6f5c).
   14) lldpd: up to 1.0.1 version.
   15) freeradius: up to 3.0.17 version.
   16) ethtool: update to 4.16 version.
   17) libcurl: update to 7.59.0 version.
   18) strace: up to 4.22 version.
   19) goahead: sync fc logic with init.d.
   20) goahead: fix change fc mode at 7620.
   21) igmpproxy: avoid reports duplicate at leave.
   22) igmpproxy: increase general query response interval.
   23) igmpproxy: disable force sweap member by esw for 7621, remove only
   from general aging.
   24) xupxnpd: fix m3u parse in some cases.
   25) cwmpd: fix ssl support and extend config (include webUI).
   26) init.d: remove old buggy migration from old FW dead workaround.
   27) init.d: optimize usb_storage wait ready.
   28) init.d: dhcpc: fix unneded forward disable on lease fail state for
   fake pure pppoe path.
   29) init.d: fix eoip start if l2tp_v3 not configured.
   30) init.d: avoid start or reconfig radvd/dhcp6d if prefix empty.
   31) init.d: use dhsmasq as relay for ipv6 to.
   32) init.d: work without flow control safe only if speed select manual to
   (mt762x esw not documented case).
   33) kernel: resource: fix integer overflow at reallocation.
   34) kernel: net: skbuff: fix not waking applications when errors are
   enqueued.
   35) kernel: net: skbuff: allow better page reuse in splice(sock -> pipe).
   36) kernel: net: skbuff: allow skb->head to be a page fragment.
   37) kernel: net: skbuff: net: make GRO aware of skb->head_frag.
   38) kernel: net: skbuff: net: fix truesize accounting in
   skb_gro_receive().
   39) kernel: net: skbuff: drop bad code from pskb_expand_head.
   40) kernel: net: skbuff: drop fastpath variable for skb_cloned check in
   pskb_expand_head.
   41) kernel: net: skbuff: optimize the pull_pages code in
   __pskb_pull_tail().
   42) kernel: net: skbuff: convert to skb_orphan_frags.
   43) kernel: net: skbuff: skb_peek()/skb_peek_tail() cleanups.
   44) kernel: net: skbuff: skb_orphan() changes.
   45) kernel: net: skbuff: pskb_expand_head: increase need head size for
   hw_nat use head room to.
   46) kernel: net: skbuff: pskb_expand_head: avoid oops and stop work if not
   mem for expand head allocated.
   47) kernel: net: skbuff: initialize skb->peeked when cloning.
   48) kernel: net: skbuff: return -EMSGSIZE in skb_to_sgvec to prevent
   overflow.
   49) kernel: net: skbuff: pskb_trim_rcsum() and CHECKSUM_COMPLETE are
   friends.
   50) kernel: net: vlan: more careful checksum features handling.
   51) kernel: net: fix checksum features handling in netif_skb_features().
   52) kernel: net: disable segmentation if checksumming is not supported.
   53) kernel: net: handle NAPI_GRO_FREE_STOLEN_HEAD case also in
   napi_frags_finish().
   54) kernel: net: ppp: avoid loop in xmit recursion detection code.
   55) kernel: net: pptp: remove a buggy dst release in pptp_connect().
   56) kernel: net: l2tp: check sockaddr length in pppol2tp_connect().
   57) kernel: net: pppoe: check sockaddr length in pppoe_connect().
   58) kernel: net: tcp: reset sk_send_head in tcp_write_queue_purge.
   59) kernel: net: tcp: purge write queue upon aborting the connection.
   60) kernel: net: tcp: don't read out-of-bounds opsize.
   61) kernel: net: tcp: md5: reject TCP_MD5SIG or TCP_MD5SIG_EXT on
   established sockets.
   62) kernel: net: ndisc: fix padding error in link-layer address option.
   63) kernel: net: adjust skb_gso_segment() for calling in rx path.
   64) kernel: net: fool proof dev_valid_name().
   65) kernel: net: mac80211: bail out from prep_connection() if a reconfig
   is ongoing.
   66) kernel: net: ipv6: avoid dad-failures for addresses with NODAD.
   67) kernel: net: neighbour: update neigh timestamps iff update is
   effective.
   68) kernel: net: fix rtnh_ok().
   69) kernel: net: fix uninit-value in __hw_addr_add_ex().
   70) kernel: net: af_packet: fix race in PACKET_{R|T}X_RING.
   71) kernel: net: fix one possible memleak in ip_setup_cork.
   72) kernel: net: handle null dst in rtnl_put_cacheinfo.
   73) kernel: net: gro: avoid reorders.
   74) kernel: net: do not update the pmtu on mtu locked routes (more RFC
   compliant).
   75) kernel: net: ipv4: do not increase PMTU with Datagram Too Big message
   (more RFC compliant).
   76) kernel: net: ipv6: add RTA_TABLE and RTA_PREFSRC to rtm_ipv6_policy.
   77) kernel: net: llc: hold llc_sap before release_sock().
   78) kernel: net: llc: fix NULL pointer deref for SOCK_ZAPPED.
   79) kernel: net: llc: llc: delete timers synchronously in llc_sk_free().
   80) kernel: tty: use __GFP_NOFAIL for tty_ldisc_get().
   81) kernel: ralink_raeth: do not disable FC on 7620 cpuport if use
   internal switch (speed decrease issue).
   82) kernel: ralink_wifi: use skb_set_tail_pointer instead of internal hard
   code in some cases.
   83) kernel: ralink_wifi: add new macbook oui 08:6d:41 and iphone oui
   2C:61:F6,90:8D:6C,9C:4F:DA to bcm fix.
   84) kernel: ralink_wifi: fix duplicate packets without wi_fi vlan support
   alloc size calc.
   85) kernel: ralink_wifi: avoid to OS push pakcets with null data pailoads
   (QCA61X4A bug).
   86) kernel: ralink_wifi: add sanity checks packets to rx done handle
   functions.
   87) kernel: ralink_wifi: add lost null checks in APCheckRxError.
   88) kernel: ralink_wifi: avoid amsdu ba annouce for non VHT mode (QCA61X4A
   bug).
   89) kernel: ralink_wifi: fix TxType frame parse.
   90) kernel: ralink_wifi: mt7610: allow 256 rx processes.

   7.4.x
   1) build_system: small cleanup and fix build process.
   2) build_system: for >=16Mb devices samba up to 3.6.25 version (need for
   support SMBv2 after MS drop support SMBv1 in Windows).
   3) busybox: update to 1.28.3 stable version.
   4) configs: disable zebra in 8Mb flash builds (not really used in
   production now, and need save flash free size).
   5) configs: add DM9601 usb->eth adapter support (temp use as eth modem).
   6) miniupnpd: update to 2.1 version.
   7) entware: update install script.
   8) build_system/init/libwive/calibs: prepare to support mt7615.
   9) build_system: add and use ngix (goahead removed).
   10) build_system: auto add changelog to result fw archive.
   11) init.d: avoid enneded vpn helper restarts.
   12) init.d: renew routes to server after get new vpn ip to.
   13) init.d: add pure usbether modem mode (hilink).
   14) init.d: dynamic ifname for wwan modem mode.
   15) init.d: avoid modules double start (prevent potantioanl races).
   16) init.d: avoid ethtun stop if modules allready removed.
   17) init.d: fix and improve 6to4 support.
   18) init.d: nginx: unify service restart logic.
   19) init.d: fix printer support.
   20) init.d: add wait ready after modules reload.
   21) init.d: move to first ra up scheme (dbdc mode at first start wait ra0
   up before allow rai0 up).
   23) init.d: iptables: limit num callback connection for CWMP from WAN to
   4, and drop from others.
   24) init.d: fix usbnet regression after move hotplug rescan call early.
   25) init.d: fix transmission start/restart race.
   26) init.d: fix radius config permissions.
   27) init.d: add IPv6DisableIANA for dhcpv6 option for force disable IANA
   send for WAN configure.
   28) init.d: nginx: add force nocache.
   29) libwive: add shadow password support.
   30) libnvram: fix small memory leak.
   31) cwmpd: fix memory leaks.
   32) cwmpd: fix replace mac issue.
   33) webui: rework wireless settings (fixup and refactoring).
   34) webui: fix auto mcs set regression.
   35) webui: rework Wireless settings for consolidate in one page (decrease
   need apply with radio restart).
   36) webui: new stage of refatoring.
   37) webui: add IPv6DisableIANA option.
   38) kernel: config: increase WDG intervals for avoid not needed reboots.
   39) kernel: tcp: do not overshoot window_clamp in tcp_rcv_space_adjust().
   40) kernel: mtd: add new spi flashes support.
   41) kernel: exit.c: avoid undefined behaviour when calling wait4().
   42) kernel: tty: make n_tty_read() always abort if hangup is in progress.
   43) kernel: time: make sure jiffies_to_msecs() preserves non-zero time
   periods.
   44) kernel: usb: xhci: xhci-mem: off by one in xhci_stream_id_to_ring().
   45) kernel: ranvram: more human readable debug message.
   46) kernel: compiller: always inline when CONFIG_OPTIMIZE_INLINING is
   disabled.
   47) kernel: compiller: add __attribute__((gnu_inline)) to all inline
   declarations.
   48) kernel: mips: io: add barrier after register read in readX().
   49) kernel: mips: c-r4k: fix data corruption related to cache coherence.
   50) kernel: mips: fix clean of vmlinuz.{32,ecoff,bin,srec}.
   51) kernel: mips: io: Add barrier after register read in inX().
   52) kernel: mm: pin address_space before dereferencing it while isolating
   an LRU page.
   53) kernel: mm/madvise.c: fix madvise() infinite loop under special
   circumstances.
   54) kernel: mm/mempolicy.c: avoid use uninitialized preferred_node.
   55) kernel: mm: fix the NULL mapping case in __isolate_lru_page().
   56) kernel: net: af_key: always verify length of provided sadb_key.
   57) kernel: net: tcp: purge write queue in tcp_connect_init().
   58) kernel: net: inetpeer: fix uninit-value in inet_getpeer.
   59) kernel: net: ip6mr: only set ip6mr_table from setsockopt when
   ip6mr_new_table succeeds.
   60) kernel: net: net/packet: refine check for priv area size.
   61) kernel: net: ipv4: fix memory leaks in udp_sendmsg, ping_v4_sendmsg.
   62) kernel: net: ipv4/ipv6: test tailroom before appending to linear skb.
   63) kernel: net: llc: better deal with too small mtu.
   64) kernel: net: llc: properly handle dev_queue_xmit() return value.
   65) kernel: net: netlink: fix uninit-value in netlink_sendmsg.
   66) kernel: net: netlink: make sure nladdr has correct size in
   netlink_connect().
   67) kernel: net: netfilter: ebtables: CONFIG_COMPAT: don't trust userland
   offsets.
   68) kernel: net: netfilter: ebtables: fix erroneous reject of last rule.
   69) kernel: net: tcp: avoid collapses in tcp_prune_queue() if possible.
   70) kernel: net: tcp: detect malicious patterns in
   tcp_collapse_ofo_queue().
   71) kernel: ralink_wifi: ft: fix bad RSNIE in some cases.
   72) kernel: ralink_wifi: rrm: fix bss beacon prepare for announse RRM cap.
   73) kernel: ralink_wifi: rrm: need update CAP and IEs if mode switch.
   74) kernel: ralink_wifi: rrm: use 0 random interval.
   75) kernel: ralink_wifi: more accurate vht txpwr envelope calculate.
   76) kernel: ralink_wifi: ageout time to 480 sec (fix psm issue with some
   clients).
   77) kernel: ralink_wifi: increase GTK update interval to 2sec (compat
   fix).
   78) kernel: ralink_wifi: increase ft1 key table size for more clients
   store in FT cache.
   79) kernel: ralink_wifi: disable rssi feedback (now not support and
   conflict with 256QAM flag in new devices).
   80) kernel: ralink_wifi: fix invalidate 802.1x entry.
   81) kernel: ralink_wifi: fix reset one sec counters
   82) kernel: ralink_wifi: fix channel repports.
   83) kernel: ralink_wifi: fix pkt_len calc.
   83) kernel: ralink_wifi: fix calc rssi in some cases.
   84) kernel: ralink_wifi: fix ProbeReqParam init.
   85) kernel: ralink_wifi: move start mlme timer to end of init (prevent
   races).
   86) kernel: ralink_wifi: implement ba reorder monitor (decrease drops and
   timeouts with multiclients).
   87) kernel: ralink_wifi: mt76x2/mt7610: avoid BBP hang up.
   88) kernel: ralink_wifi: mt7610: fix module reload in very noised radio.
   89) kernel: ralink_wifi: mt7610: fix mcu stub at down/if if radio is off.

   7.5.x
   1) busybox: update to 1.29.3 stable version.
   2) configs: ntp enable by default and set TZ=YEKT-5.
   3) miniupnpd: up to 2.1.20180706 version.
   4) miniupnpd: do not check reserved adresses, this break MAP global to
   local range of some ISP.
   5) igmpproxy: when the link is PPP (flag = 0x10d1) should get the P-t-P
   address to use.
   6) igmpproxy: fix case where we want to specify 0.0.0.0/0 but config
   disallows.
   7) igmpproxy: limit maximum select default timeout.
   8) 802.1x: fix root interface jam in multicard or dbdc mode.
   9) 802.1x: fix compat with mt7615 driver.
   10) build_system: samba36 modules review for decrease size.
   12) init.d: avoid incorrect configure vifs in dbdc mode.
   13) init.d: fix nginx stop.
   14) init.d: 6to4 allow use not standart prefix.
   15) init.d: fix reconfigure 7615 module if used vif`s.
   16) init.d: fix bridge reconfigure at kernel pass through enable.
   17) init.d: automount: try mount as ntfs if type is unknown (workaround
   mount GPT parts, need rework in future).
   18) init.d: automount: move mount small tmpfs part for /media to rcS
   (prevent race of multi hdd connect over hub).
   19) init.d: samba export all /media sd*/mmc devices as shares.
   20) init.d: dlna auto share media files from /media if mounted and xupnpd
   enabled.
   21) init.d: strong arp_* modes for use with ext vlans.
   22) init.d: avoid start hibryd snooping in modes with ext vlans.
   23) init.d: fix dns get from ppp if wan static dns mode enabled.
   24) libwive/libnvram/nginx: multivar fixup.
   25) libnvram: add workaround for ACS at bootup in DBDC mode.
   26) sysctl: limit frag thres for prevent SegmentSmack DOS attack for ipv6
   to.
   27) iappd: code review and small fixup.
   28) bandsteering: force steer at start.
   29) bandsteering: support MT7615 and later.
   30) igmpproxy: fix wifi/lan snooping concurent work.
   31) webui: fix wireless security warnings show.
   32) webui: fix per bssid options set.
   33) webui: fix idle timeout range.
   34) webui: add l2 tunnels (LT2TPv3/EOIP).
   35) webui: move BW to basic block for easy setup.
   36) webui: 6to4 allow use not standart prefix.
   37) webui: fix and merge to wone eoip/l2tpv3 pages.
   38) webui: fix real user name leak to different users.
   39) webui: fix access policy block hide.
   40) webui: move BSSID to block header (save space).
   41) webui: fix mcs limit select.
   42) webui: fix channel by region limit.
   43) webui: apcli fixup.
   44) webui: cleanup region settings.
   45) webui: translate ftp options.
   46) webui: make update procedure more safe.
   47) webui: fix m2u options default set.
   48) kernel: fork: don't copy inconsistent signal handler state to child.
   49) kernel: random: mix rdrand with entropy sent in from userspace.
